//-----------------------------------------------------------------------------
// Scene_BRshop
//-----------------------------------------------------------------------------

function Scene_brShop() {
    this.initialize.apply(this, arguments);
}

Scene_brShop.prototype = Object.create(Scene_MenuBase.prototype);
Scene_brShop.prototype.constructor = Scene_brShop;

Scene_brShop.prototype.initialize = function() {
    Scene_MenuBase.prototype.initialize.call(this);
};

Scene_brShop.prototype.start = function() {
    Scene_MenuBase.prototype.start.call(this);
    this._actorId = 1;
    this._actor = $gameActors.actor(this._actorId);
    $gameParty._menuActorId = 1;

    this._onCategory = 0;
    this._spr_pop = [];
//    this._org = [];
//    this._org[0] = [x,y,y+]; // Title
//    this._org[1] = [x,y,y+]; // Layout
//    this._org[2] = [x,y,y+]; // Status
//    this._org[3] = [x,y,y+]; // Help

    this.refreshActor();
};

Scene_brShop.prototype.create = function() {
    Scene_MenuBase.prototype.create.call(this);

    this._window_list = [];
    // Window
    this.createCategoryWindow();
    this.createHelpWindow();
    this.createSkillWindow();
    this.createStatWindow();
    this.createBlessWindow();
    this.createConfirmationWindow();

    // Sprite
    this.loadBitmaps();
    this.createSprite_Title();
    this.createSprite_Layout();
    this.createSprite_Currency();
    this.createSprite_Status();
    this.createSprite_Face();
    this.createSprite_Help();
    this.createSprite_Confirmation();
    this.createSprite_ConfirmationName();

    this.createCurrency();
    this.createActorStatus();
};

Micoomer.brShopBG = Scene_brShop.prototype.createBackground;
Scene_brShop.prototype.createBackground = function() {
	Micoomer.brShopBG.call(this);
	this._field = new Sprite();
	this.addChild(this._field);
};

Scene_brShop.prototype.loadBitmaps = function() {
  this._layImg = ImageManager.loadBackground('UI_brShop');
};

// WINDOW
Scene_brShop.prototype.createCategoryWindow = function() {
    var wx = 80;
    var wy = 115;
    var ww = 360;
    var wh = 360;
    this._window_cat = new Window_brShop_Category(wx, wy, ww, wh);
    this._window_cat.setHandler('skill',     this.onCategorySkill.bind(this));
    this._window_cat.setHandler('stat',     this.onCategoryStat.bind(this));
    this._window_cat.setHandler('blessing',     this.onCategoryBless.bind(this));
    this._window_cat.setHandler('cancel', this.popScene.bind(this));
    this._window_cat.setHandler('pagedown', this.nextActor.bind(this));
    this._window_cat.setHandler('pageup',   this.previousActor.bind(this));
    this.addWindow(this._window_cat);
};

Scene_brShop.prototype.createSkillWindow = function() {
    var wx = 215;
    var wy = 117;
    var ww = 360;
    var wh = 360;
    this._window_list[0] = new Window_brShop_Skill(wx, wy, ww, wh);
    this._window_list[0].setHelpWindow(this._helpWindow);
    this._window_list[0].setHandler('ok',     this.onSkillOk.bind(this));
    this._window_list[0].setHandler('cancel', this.onSubCancel.bind(this));
    this._window_list[0].deactivate();
    this.addWindow(this._window_list[0]);
};

Scene_brShop.prototype.createStatWindow = function() {
    var wx = 215;
    var wy = 117;
    var ww = 360;
    var wh = 360;
    this._window_list[1] = new Window_brShop_Stat(wx, wy, ww, wh);
    this._window_list[1].setHelpWindow(this._helpWindow);
    this._window_list[1].setHandler('ok',     this.onStatOk.bind(this));
    this._window_list[1].setHandler('cancel', this.onSubCancel.bind(this));
    this._window_list[1].deactivate();
    this._window_list[1].hide();
    this.addWindow(this._window_list[1]);
};

Scene_brShop.prototype.createBlessWindow = function() {
    var wx = 215;
    var wy = 117;
    var ww = 360;
    var wh = 360;
    this._window_list[2] = new Window_brShop_Bless(wx, wy, ww, wh);
    this._window_list[2].setHelpWindow(this._helpWindow);
    this._window_list[2].setHandler('ok',     this.onBlessOk.bind(this));
    this._window_list[2].setHandler('cancel', this.onSubCancel.bind(this));
    this._window_list[2].deactivate();
    this._window_list[2].hide();
    this.addWindow(this._window_list[2]);
};

Scene_brShop.prototype.createConfirmationWindow = function() {
    var wx = 553;
    var wy = 323;
    var ww = 160;
    var wh = 60;
    this._window_confirm = new Window_brShop_Confirm(wx, wy, ww, wh);
    this._window_confirm.setHandler('yes',     this.onConfirmOk.bind(this));
    this._window_confirm.setHandler('no',      this.onConfirmCancel.bind(this));
    this._window_confirm.setHandler('cancel',  this.onConfirmCancel.bind(this));
    this._window_confirm.deactivate();
    this._window_confirm.hide();
    this.addWindow(this._window_confirm);
};

Scene_brShop.prototype.createCurrency = function() {
  this._currency = [];
  for (var i = 0; i < 2; i++) {
    this._currency[i] = new Sprite(new Bitmap(200,40));
    this._currency[i].x = 295 + 5 * i;
    this._currency[i].y = 463;
    this._currency[i].bitmap.fontSize = 18;
    this._currency[i].bitmap.textColor = '#f57ac8';
    this._currency[i].bitmap.fontFace = 'FredokaSemi';
  	this.addChild(this._currency[i]);
  }
  this._currency[0].bitmap.drawText('Remnant',0,0,200,40,'left');
  this._currency[1].bitmap.drawText($gameParty.remnants(),0,0,200,40,'right');
};

Scene_brShop.prototype.createActorStatus = function() {
  this._actorStatus = new BrShop_Status(this._actor);
  this._actorStatus.x = 695;
  this._actorStatus.y = 137;
  this.addChild(this._actorStatus);
};

// SPRITE
Scene_brShop.prototype.createSprite_Title = function() {
  this._spr_title = new Sprite(this._layImg);
  this._spr_title.setFrame(530,450,480,100);
  this._field.addChild(this._spr_title);
};

Scene_brShop.prototype.createSprite_Layout = function() {
  this._spr_lay = [];
  for (var i = 0; i < this._window_list.length; i++) {
    this._spr_lay[i] = new Sprite(this._layImg);
    this._spr_lay[i].x = 50;
    this._spr_lay[i].y = 89;
    var frame = 540 * i;
    this._spr_lay[i].setFrame(frame,0,540,450);
    this._field.addChild(this._spr_lay[i]);
  }
  this._spr_lay[1].visible = false;
  this._spr_lay[2].visible = false;
};

Scene_brShop.prototype.createSprite_Currency = function() {
  this._spr_currency = new Sprite(this._layImg);
  this._spr_currency.x = 277;
  this._spr_currency.y = 467;
  this._spr_currency.setFrame(530,800,240,35);
  this._field.addChild(this._spr_currency);
};

Scene_brShop.prototype.createSprite_Status = function() {
  this._spr_status = new Sprite(this._layImg);
  this._spr_status.x = 678;
  this._spr_status.y = 53;
  this._spr_status.setFrame(0,450,530,490);
  this._field.addChild(this._spr_status);
};

Scene_brShop.prototype.createSprite_Face = function() {
  this._spr_face = new Sprite(this._layImg);
  this._spr_face.x = 617;
  this._spr_face.y = 60;
  this._field.addChild(this._spr_face);
  this.setFace(this._spr_face, this._actor._actorId);
};

Scene_brShop.prototype.setFace = function(sprite, actorId) {
  var w = 300;
  var h = 120;
  var x = 1130;
  var y = 450 + (h * (actorId - 1));
  sprite.setFrame(x,y,w,h);
};

Scene_brShop.prototype.createSprite_Help = function() {
  this._spr_help = new Sprite(this._layImg);
  this._spr_help.x = 110;
  this._spr_help.y = 550;
  this._spr_help.setFrame(530,550,600,130);
  this._field.addChild(this._spr_help);

  this._helpWindow.x = 102;
  this._helpWindow.y = 576;
};

Scene_brShop.prototype.createSprite_Confirmation = function() {
  this._spr_confirm = new Sprite(this._layImg);
  this._spr_confirm.x = 440;
  this._spr_confirm.y = 263;
  this._spr_confirm.setFrame(530,680,400,120);
  this._field.addChild(this._spr_confirm);
};

Scene_brShop.prototype.createSprite_ConfirmationName = function() {
  this._spr_confirmName = [];
  this._spr_confirmField = new Sprite();
  this._spr_confirmField.x = 550;
  this._spr_confirmField.y = 305;
  this._spr_confirmField.anchor.x = 0.5;
  this._spr_confirmField.visible = false;
  this._field.addChild(this._spr_confirmField);

  this._spr_confirmName[0] = new Sprite(ImageManager.loadSystem('IconSet'));
  this._spr_confirmField.addChild(this._spr_confirmName[0]);

  this._spr_confirmName[1] = new Sprite(new Bitmap(200,40));
  this._spr_confirmName[1].bitmap.fontSize = 18;
  this._spr_confirmName[1].bitmap.textColor = '#f57ac8';
  this._spr_confirmField.addChild(this._spr_confirmName[1]);
};

Scene_brShop.prototype.createSprite_Popup = function(text, posX, posY) {
  var index = this._spr_pop.length;
  this._spr_pop[index] = new Sprite(new Bitmap(160,40));
  this._spr_pop[index].x = posX;
  this._spr_pop[index].y = posY;
  this._spr_pop[index].posOrg = posY - 20;
  this._spr_pop[index].timer = 30;
  this._spr_pop[index].bitmap.fontSize = 18;
  this._spr_pop[index].bitmap.textColor = '#66cc40';
  this._spr_pop[index].bitmap.drawText(text,0,0,160,40);
  this._field.addChild(this._spr_pop[index]);
};

// WINDOW PROCESS
Scene_brShop.prototype.activateCatWindow = function() {
  for (var i = 0; i < this._window_list.length; i++) {
    this._window_list[i].deactivate();
  }
  this._window_cat.show();
  this._window_cat.activate();
};

Scene_brShop.prototype.activateSubWindow = function() {
  this._window_cat.deactivate();
  this._window_cat.hide();
  this._window_list[this._onCategory].refresh();
  this._window_list[this._onCategory].show();
  this._window_list[this._onCategory].activate();
};

Scene_brShop.prototype.activateConfirmWindow = function() {
  for (var i = 0; i < this._window_list.length; i++) {
    this._window_list[i].deactivate();
  }
  this._window_confirm.show();
  this._window_confirm.activate();
  this._window_confirm.select(0);
};

Scene_brShop.prototype.helpVisibility = function() {
  if (this._window_list[0].active || this._window_list[1].active || this._window_list[2].active || this._window_confirm.active) return true;
  return false;
};

Scene_brShop.prototype.onCategorySkill = function() {
  this.activateSubWindow();
  this._window_list[0].select(0);
};

Scene_brShop.prototype.onCategoryStat = function() {
  this.activateSubWindow();
  this._window_list[1].select(0);
};

Scene_brShop.prototype.onCategoryBless = function() {
  this.activateSubWindow();
  this._window_list[2].select(0);
};

Scene_brShop.prototype.onSkillOk = function() {
  this._item = this._window_list[0]._data[this._window_list[0].index()];
  this.setItem(this._item);
  this.activateConfirmWindow();
};

Scene_brShop.prototype.onSubCancel = function() {
  this.activateCatWindow();
};

Scene_brShop.prototype.onConfirmOk = function() {
  switch (this._onCategory) {
    case 0:
      this.doSkillBuy(this._item);
      break;

    case 2:
      this.doBlessBuy(this._item);
      break;
  }
};

Scene_brShop.prototype.onConfirmCancel = function() {
  this._window_confirm.deactivate();
  this._window_confirm.hide();
  this.activateSubWindow();
};

Scene_brShop.prototype.onStatOk = function() {
    this._item = this._window_list[1]._data[this._window_list[1].index()];
    this.doStatBuy(this._item);
};

Scene_brShop.prototype.onBlessOk = function() {
  this._item = this._window_list[2]._data[this._window_list[2].index()];
  this.setItem(this._item);
  this.activateConfirmWindow();
};

Scene_brShop.prototype.refreshActor = function() {
    this._actorId = this._actor._actorId;
    for (var i = 0; i < this._window_list.length; i++) {
      this._window_list[i].setActor(this._actor);
    }

    this.setFace(this._spr_face, this._actor._actorId);
    this._actorStatus.setData(this._actor);
    this._actorStatus.setBlessing(this._actor);
};

Scene_brShop.prototype.onActorChange = function() {
    this.refreshActor();
    this.activateCatWindow();
};

// PROCESS
Scene_brShop.prototype.passRemnantCheck = function(cost) {
  return $gameParty.remnants() > cost;
};

Scene_brShop.prototype.playSound = function(type) {
  switch (type) {
    case 1:
    AudioManager.playSe({
      name: "TO7BTL_2554",
      volume: 50,
      pitch: 100
   });
   break;

   case 2:
   AudioManager.playSe({
     name: "UI_PartyJoin",
     volume: 50,
     pitch: 150
   });
   break;
  }
};

Scene_brShop.prototype.updateText = function() {
  this._currency[1].bitmap.clear();
  this._currency[1].bitmap.drawText($gameParty.remnants(),0,0,200,40,'right');
};

Scene_brShop.prototype.setItem = function(item) {
  var sx = item.iconIndex % 16 * 32;
  var sy = Math.floor(item.iconIndex / 16) * 32;
  this._spr_confirmName[0].setFrame(sx,sy,32,32);

  this._spr_confirmName[1].bitmap.clear();
  this._spr_confirmName[1].bitmap.drawText(item.name,0,-4,200,40,'center');
};

Scene_brShop.prototype.setPopup = function(item, type) {
  var text = "+" + item.bonus;
  switch (type) {
    case 1:
      var x = 900;
      var y = 140 + (this._window_list[1].index() * 35);
      break;

    case 2:
      var x = 850;
      var y = 398 + (this._window_list[2].index() * 30);
      break;
  }
  this.createSprite_Popup(text, x, y);
};

Scene_brShop.prototype.doSkillBuy = function(item) {
  var id = item.id;
  var cost = Micoomer.skillLearnCost[this._actorId][id];
  if (this.passRemnantCheck(cost)) {
    this._actor.learnSkill(id);
    $gameParty.loseRemnants(cost);
    this.updateText();
    this.playSound(1);
  } else {
    SoundManager.playBuzzer();
  }
  this._window_confirm.deactivate();
  this._window_confirm.hide();
  this.activateSubWindow();
}

Scene_brShop.prototype.doStatBuy = function(item) {
  var cost = item.cost;
  if (this.passRemnantCheck(cost)) {
    this.processStatBuy(item);
    this.setPopup(item, 1);
    $gameParty.loseRemnants(cost);
    this.updateText();
    this.playSound(2);
  } else {
    SoundManager.playBuzzer();
  }
  this.activateSubWindow();
}

Scene_brShop.prototype.doBlessBuy = function(item) {
  var cost = item.cost;
  if (this.passRemnantCheck(cost)) {
    this.processBlessBuy(item);
    this.setPopup(item, 2);
    $gameParty.loseRemnants(cost);
    this.updateText();
    this.playSound(1);
  } else {
    SoundManager.playBuzzer();
  }
  this._window_confirm.deactivate();
  this._window_confirm.hide();
  this.activateSubWindow();
}

Scene_brShop.prototype.processStatBuy = function(item) {
  var id = item.id;
  var bonus = item.bonus;
  this._actor.addParam(id, bonus);
  this.updateActorStatus();
};

Scene_brShop.prototype.processBlessBuy = function(item) {
  var id = item.cParamId;
  this._actor.addCParam(id, 1);
  this.updateActorStatus();
};

Scene_brShop.prototype.updateActorStatus = function(item) {
  this._actorStatus.setData(this._actor);
  this._actorStatus.setBlessing(this._actor);
};

Scene_brShop.prototype.updateHelpVisibility = function() {
  this._helpWindow.visible = this.helpVisibility();
  this._spr_help.visible = this._helpWindow.visible;
};

Scene_brShop.prototype.updateConfirmVisibility = function() {
  this._spr_confirm.visible = this._window_confirm.visible;
  this._spr_confirmField.visible = this._window_confirm.visible;
};

Scene_brShop.prototype.updateCatIndex = function() {
  if (this._window_cat.active) {
    if (this._onCategory != this._window_cat._index) this.refreshCatIndex();
  }
};

Scene_brShop.prototype.refreshCatIndex = function() {
  this._onCategory = this._window_cat._index;
  this.updateLayout(this._onCategory);
  this.updateWindowTrans(this._onCategory);
};

Scene_brShop.prototype.updateLayout = function(a) {
  for (var i = 0; i < this._spr_lay.length; i++) {
		this._spr_lay[i].visible = false;
	}
	this._spr_lay[a].visible = true;
};

Scene_brShop.prototype.updateWindowTrans = function(a) {
  for (var i = 0; i < this._window_list.length; i++) {
    this._window_list[i].hide();
  }
  this._window_list[a].show();
};

Scene_brShop.prototype.updatePopup = function() {
  for (var i = 0; i < this._spr_pop.length; i++) {
    if (!this._spr_pop[i]) {continue};
    this._spr_pop[i].y = this.sprite_move_to(this._spr_pop[i].y, this._spr_pop[i].posOrg, 60);
    this._spr_pop[i].opacity -= 8;
    if (this._spr_pop[i].timer == 0) {
      this._field.removeChild(this._spr_pop[i]);
    } else {
      this._spr_pop[i].timer--;
    }
  }
};

Scene_brShop.prototype.sprite_move_to = function(value,real_value,speed) {
	if (value == real_value) {return value};
	var dnspeed = 2 + (Math.abs(value - real_value) / speed);
	if (value > real_value) {value -= dnspeed;
	    if (value < real_value) {value = real_value};}
    else if (value < real_value) {value  += dnspeed;
    	if (value  > real_value) {value  = real_value};
    };
	return Math.floor(value);
};

Micoomer.brShopUpdate = Scene_brShop.prototype.update;
Scene_brShop.prototype.update = function() {
  Micoomer.brShopUpdate.call(this);
    this.updateHelpVisibility();
    this.updateCatIndex();
    this.updateConfirmVisibility();
    if (this._spr_pop.length > 0) this.updatePopup();
};

//=============================================================================
// * Window
//=============================================================================
function Window_brShop_Skill() {
    this.initialize.apply(this, arguments);
}

Window_brShop_Skill.prototype = Object.create(Window_Selectable.prototype);
Window_brShop_Skill.prototype.constructor = Window_brShop_Skill;

Window_brShop_Skill.prototype.initialize = function(x, y, width, height) {
    Window_Selectable.prototype.initialize.call(this, x, y, width, height);
    this._actor = null;
    this._actorId = null;
    this._stypeId = 1;
    this._data = [];

};

Window_brShop_Skill.prototype.setActor = function(actor) {
    this._actor = actor;
    this._actorId = this._actor._actorId;
    this.refresh();
    this.resetScroll();
};

Window_brShop_Skill.prototype.maxCols = function() {
    return 1;
};

Window_brShop_Skill.prototype.spacing = function() {
    return 48;
};

Window_brShop_Skill.prototype.maxItems = function() {
    return this._data ? this._data.length : 1;
};

Window_brShop_Skill.prototype.item = function() {
    return this._data && this.index() >= 0 ? this._data[this.index()] : null;
};

Window_brShop_Skill.prototype.isCurrentItemEnabled = function() {
    return this.isEnabled(this._data[this.index()]);
};

Window_brShop_Skill.prototype.checkPool = function(item) {
    return item && Micoomer.skillLearnPool[this._actorId].includes(item.id);
};

Window_brShop_Skill.prototype.isEnabled = function(item) {
    return !this._actor.skills().contains(item);
};

Window_brShop_Skill.prototype.makeItemList = function() {
        this._data = $dataSkills.filter(function(item) {
            return this.checkPool(item);
        }, this);
};

Window_brShop_Skill.prototype.drawItem = function(index) {
    var skill = this._data[index];
    if (skill) {
        var rect = this.itemRect(index);
        rect.width -= this.textPadding();
        this.changePaintOpacity(this.isEnabled(skill));
        this.drawItemName(skill, rect.x, rect.y, rect.width);
        this.drawLearnCost(skill, rect.x, rect.y, rect.width);
    }
};

Window_brShop_Skill.prototype.drawLearnCost = function(skill, x, y, width) {
    var cost = Micoomer.skillLearnCost[this._actorId][skill.id];
    this.drawText(cost + ' BR', x, y, width, 'right');
};

Window_brShop_Skill.prototype.updateHelp = function() {
    this.setHelpWindowItem(this.item());
};

Window_brShop_Skill.prototype.refresh = function() {
    this.makeItemList();
    this.createContents();
    this.drawAllItems();
};

//=============================================================================
// * Window Category
//=============================================================================

function Window_brShop_Category() {
    this.initialize.apply(this, arguments);
}

Window_brShop_Category.prototype = Object.create(Window_Command.prototype);
Window_brShop_Category.prototype.constructor = Window_brShop_Category;

Window_brShop_Category.prototype.initialize = function(x, y) {
    Window_Command.prototype.initialize.call(this, x, y);
    this.contentsOpacity = 0;
};

Window_brShop_Category.prototype.makeCommandList = function() {
  this.addCommand('skill', 'skill', true);
  this.addCommand('stat', 'stat', true);
  this.addCommand('blessing', 'blessing', true);
};

Window_brShop_Category.prototype.lineHeight = function(index) {
	return 72;
};

//=============================================================================
// * Window Confirm
//=============================================================================

function Window_brShop_Confirm() {
    this.initialize.apply(this, arguments);
}

Window_brShop_Confirm.prototype = Object.create(Window_Command.prototype);
Window_brShop_Confirm.prototype.constructor = Window_brShop_Confirm;

Window_brShop_Confirm.prototype.initialize = function(x, y) {
    Window_Command.prototype.initialize.call(this, x, y);
};

Window_brShop_Confirm.prototype.maxCols = function() {
    return 2;
};

Window_brShop_Confirm.prototype.isCursorVisible = function() {
    return false;
};

Window_brShop_Confirm.prototype.makeCommandList = function() {
  this.addCommand('YES', 'yes', true);
  this.addCommand('NO', 'no', true);
};

//=============================================================================
// * Window
//=============================================================================
function Window_brShop_Stat() {
    this.initialize.apply(this, arguments);
}

Window_brShop_Stat.prototype = Object.create(Window_Selectable.prototype);
Window_brShop_Stat.prototype.constructor = Window_brShop_Stat;

Window_brShop_Stat.prototype.initialize = function(x, y, width, height) {
    Window_Selectable.prototype.initialize.call(this, x, y, width, height);
    this._actor = null;
    this._actorId = null;
    this._data = [];
};

Window_brShop_Stat.prototype.setActor = function(actor) {
    this._actor = actor;
    this._actorId = this._actor._actorId;
    this.refresh();
    this.resetScroll();
};

Window_brShop_Stat.prototype.maxCols = function() {
    return 1;
};

Window_brShop_Stat.prototype.spacing = function() {
    return 48;
};

Window_brShop_Stat.prototype.maxItems = function() {
    return this._data ? this._data.length : 1;
};

Window_brShop_Stat.prototype.item = function() {
    return this._data && this.index() >= 0 ? this._data[this.index()] : null;
};

Window_brShop_Stat.prototype.isCurrentItemEnabled = function() {
    return this.isEnabled(this._data[this.index()]);
};

Window_brShop_Stat.prototype.isEnabled = function(item) {
    return this._actor.param(item.id) < this._actor.paramMax(item.id);
};

Window_brShop_Stat.prototype.makeItemList = function() {
    this._data = Micoomer.statArray;
};

Window_brShop_Stat.prototype.drawItem = function(index) {
    var stat = this._data[index];
    if (stat) {
        var rect = this.itemRect(index);
        rect.width -= this.textPadding();
        this.changePaintOpacity(this.isEnabled(this._data[index]));
        this.drawIcon(stat.iconIndex, rect.x, rect.y + 2);
        this.drawText(stat.name, rect.x + 38, rect.y, rect.width);
        this.drawText(stat.cost + ' BR', rect.x, rect.y, rect.width, 'right');
    }
};

Window_brShop_Stat.prototype.updateHelp = function() {
    this.setHelpWindowItem(this.item());
};

Window_brShop_Stat.prototype.refresh = function() {
    this.makeItemList();
    this.createContents();
    this.drawAllItems();
};


//=============================================================================
// * Window
//=============================================================================
function Window_brShop_Bless() {
    this.initialize.apply(this, arguments);
}

Window_brShop_Bless.prototype = Object.create(Window_Selectable.prototype);
Window_brShop_Bless.prototype.constructor = Window_brShop_Bless;

Window_brShop_Bless.prototype.initialize = function(x, y, width, height) {
    Window_Selectable.prototype.initialize.call(this, x, y, width, height);
    this._actor = null;
    this._actorId = null;
    this._data = [];
};

Window_brShop_Bless.prototype.setActor = function(actor) {
    this._actor = actor;
    this._actorId = this._actor._actorId;
    this.refresh();
    this.resetScroll();
};

Window_brShop_Bless.prototype.maxCols = function() {
    return 1;
};

Window_brShop_Bless.prototype.maxItems = function() {
    return this._data ? this._data.length : 1;
};

Window_brShop_Bless.prototype.item = function() {
    return this._data && this.index() >= 0 ? this._data[this.index()] : null;
};

Window_brShop_Bless.prototype.isCurrentItemEnabled = function() {
    return this.isEnabled(this._data[this.index()]);
};

Window_brShop_Bless.prototype.isEnabled = function(item) {
    return this._actor.cParam(item.cParamId) < 10;
};

Window_brShop_Bless.prototype.makeItemList = function() {
    this._data = Micoomer.blessingArray;
};

Window_brShop_Bless.prototype.updateItemData = function() {
  for (var i = 0; i < this._data.length; i++) {
    var item = this._data[i];
    var level = this._actor.cParam(item.cParamId);
    this._data[i].cost = Micoomer.blessingCost[level];
    this._data[i].description = Micoomer.blessingDescription[i][level];
  }
};

Window_brShop_Bless.prototype.drawItem = function(index) {
    var item = this._data[index];
    if (item) {
        var rect = this.itemRect(index);
        rect.width -= this.textPadding();
        this.changePaintOpacity(this.isEnabled(this._data[index]));

        var itemLevel = this._actor.cParam(item.cParamId) + 1;
        var itemName = itemLevel > 10 ? item.name + ' Lv. MAX' : item.name + ' Lv.' + itemLevel;
        this.drawIcon(item.iconIndex, rect.x, rect.y + 2);
        this.drawText(itemName, rect.x + 42, rect.y, rect.width);
        this.drawText(item.cost + " BR", rect.x, rect.y, rect.width, 'right');
    }
};

Window_brShop_Bless.prototype.updateHelp = function() {
    this.setHelpWindowItem(this.item());
};

Window_brShop_Bless.prototype.refresh = function() {
    this.makeItemList();
    this.updateItemData();
    this.createContents();
    this.drawAllItems();
};


//=============================================================================
// ** brShop_Status
//=============================================================================
function BrShop_Status() {
    this.initialize.apply(this, arguments);
};

BrShop_Status.prototype = Object.create(Sprite.prototype);
BrShop_Status.prototype.constructor = BrShop_Status;

BrShop_Status.prototype.initialize = function(actor) {
    Sprite.prototype.initialize.call(this);

  this._actor = actor;
  this._statData = [];
  this._blessingData = [];
  this.loadBitmaps();
  this.createSprites();
};

BrShop_Status.prototype.loadBitmaps = function() {
	this._layImg = ImageManager.loadBackground('UI_brShop');
};

BrShop_Status.prototype.createSprites = function() {
	this.createStatText();
  this.createMeter();
  this.createBlessing();
};

BrShop_Status.prototype.createStatText = function() {
  this._text = [];
  for (var i = 0; i < 6; i++) {
    this._text[i] = new Sprite(new Bitmap(200,40));
  	this._text[i].y = 35 * i;
  	this._text[i].bitmap.fontSize = 20;
    this._text[i].bitmap.fontFace = 'FredokaBold';
    this._text[i].bitmap.textColor = '#f57ac8';
    this.addChild(this._text[i]);
  }
};

BrShop_Status.prototype.createMeter = function() {
  this._meter = [];
  for (var i = 0; i < 6; i++) {
    this._meter[i] = new Sprite(this._layImg);
    this._meter[i].x = 220;
  	this._meter[i].y = 17 + 35 * i;
    this.addChild(this._meter[i]);
  }
};

BrShop_Status.prototype.createBlessing = function() {
  this._bless = [];
  this._bless[0] = []; // level
  this._bless[1] = []; // Description
  for (var i = 0; i < 4; i++) {
    this._bless[0][i] = new Sprite(new Bitmap(100,40));
    this._bless[0][i].x = 82;
  	this._bless[0][i].y = 257 + 31 * i;
  	this._bless[0][i].bitmap.fontSize = 14;
    this._bless[0][i].bitmap.fontFace = 'FredokaSemi';
    this._bless[0][i].bitmap.textColor = '#f57ac8';
    this.addChild(this._bless[0][i]);

    this._bless[1][i] = new Sprite(new Bitmap(400,40));
    this._bless[1][i].x = 167;
  	this._bless[1][i].y = 257 + 31 * i;
  	this._bless[1][i].bitmap.fontSize = 14;
    this._bless[1][i].bitmap.fontFace = 'FredokaSemi';
    this._bless[1][i].bitmap.textColor = '#f57ac8';
    this.addChild(this._bless[1][i]);
  }
};

BrShop_Status.prototype.setData = function(actor) {
  this._statData[0] = [actor.param(0), actor.paramMax(0)];
  this._statData[1] = [actor.param(5), actor.paramMax(5)];
  this._statData[2] = [actor.param(2), actor.paramMax(2)];
  this._statData[3] = [actor.param(4), actor.paramMax(4)];
  this._statData[4] = [actor.param(3), actor.paramMax(3)];
  this._statData[5] = [actor.param(7), actor.paramMax(7)];
  this.setText(this._statData);
  this.setMeter(this._statData);
};

BrShop_Status.prototype.setText = function(data) {
  for (var i = 0; i < this._text.length; i++) {
    this._text[i].bitmap.clear();
    var text = i == 1 ? data[i][0] + '%' : data[i][0];
	  this._text[i].bitmap.drawText(text,0,0,200,40,'right');
  }
};

BrShop_Status.prototype.setMeter = function(data) {
  for (var i = 0; i < this._meter.length; i++) {
    var w = 240 * (data[i][0] / data[i][1]);
    var h = 7;
    this._meter[i].setFrame(530,835,w,h);
  }
};

BrShop_Status.prototype.setBlessing = function(actor) {
  this._blessingData[0] = [actor.blessing1, "Raise collected sperm fertility."];
  this._blessingData[1] = [actor.blessing2, "Boost maternity growth speed."];
  this._blessingData[2] = [actor.blessing3, "Reduce fatigue consumption during minigame."];
  this._blessingData[3] = [actor.blessing4, "Gain extra Blessed Remnants on each birth."];
  this.setBlessingText(this._blessingData);
};

BrShop_Status.prototype.setBlessingText = function(data) {
  for (var i = 0; i < this._bless[0].length; i++) {
    var text = 'Lv. ' + data[i][0];
    var desc = data[i][0] > 0 ? data[i][1] : "???";
    this._bless[0][i].bitmap.clear();
    this._bless[1][i].bitmap.clear();
	  this._bless[0][i].bitmap.drawText(text,0,0,100,40,'center');
    this._bless[1][i].bitmap.drawText(desc,0,0,400,40,'left');
  }
};
