//=============================================================================
// MCM_BattleMod.js
//=============================================================================

/*:
 * @plugindesc
 * @author micoomer
 *
 */

Game_BattlerBase.prototype.resetStateCheck = function(inf, id) {
    if (this.stateTurns(id) < inf) {this.setStateTurns(id, inf)};
};

Game_BattlerBase.prototype.launchAnimation = function(ani) {
	if (this.isActor()) {
		this.startAnimation(ani[0], true)
		this.startAnimation(ani[1]);
	} else {
		this.startAnimation(ani[0])
		this.startAnimation(ani[2]);
	}
};

Game_BattlerBase.prototype.upgradeState = function(state1, state2) {
	this.removeState(state1);
	this.addState(state2);
};

Game_BattlerBase.prototype.setAni = function(a, b1, b2) {
	this._tempAniSB = [a, b1, b2];
};

Game_BattlerBase.prototype.statBoostApply1 = function(state1, state2, v, inf, ani) {
	if (this.isStateAffected(state2)) {
		this.launchAnimation(ani);
		this.removeState(state1);
		this.resetStateCheck(inf, state2);
	} else {
		this.resetStateCheck(inf, state1);
		if (v == 2) {
			this.upgradeState(state1, state2);
		} else {
			this.launchAnimation(ani);
		}
	}
};

Game_BattlerBase.prototype.statBoostApply2 = function(state1, state2, v, inf, ani) {
	this.launchAnimation(ani);
	this.resetStateCheck(inf, state2);
};

Game_BattlerBase.prototype.addMP = function(value) {
  var c = value * 100;
  var v = this.mp1 + c;
  if (v > 600) {
    this.setCParam(21, 600);
  } else if (v < 0) {
    this.setCParam(21, 0);
  } else {
    this.addCParam(21, c);
  }
  this.setMP();
};

Game_BattlerBase.prototype.setMP = function() {
  var v = Math.floor(this.mp1 / 100);
  this.setCParam(22, v);
};

Game_BattlerBase.prototype.isResisted = function() {
	var r = Math.randomInt(100);
  var res = this.resist;
  if (r <= res) {return true}
  return false;
};

Game_BattlerBase.prototype.launchResist = function() {
  if (this.isActor()) {
		this.startAnimation(13, true);
	} else {
		this.startAnimation(13);
	}
};

Game_BattlerBase.prototype.applyDbf = function(id, type, resCheck) {
  if (type === 0) { // good state
    this.addState(id);
  } else { // bad state
    if (!this.result().fumble) {
      if (resCheck) {
        if (this.isResisted() || this.isStateResist(id)) {
          this.launchResist();
        } else {
          this.addState(id);
        }
      } else {
        this.addState(id);
      }
    }
  }
}

Game_BattlerBase.prototype.elongate = function(type, amount, resCheck) {
  var arr = type == 0 ? Micoomer._buffId : Micoomer._debuffId;
  var n = this.states();
  if (!this.result().fumble) {
    if (resCheck) {
      if (this.isResisted()) {
        this.launchResist();
      } else {
        for (i = 0; i < n.length; i++) {
          if (!arr.includes(n[i].id)) {continue};
          var t = this.stateTurns(n[i].id) + amount;
          this.setStateTurns(n[i].id, t);
        }
        if (this.isActor()) {this.startAnimation(114, true)} else {this.startAnimation(114)};
      }
    } else {
      for (i = 0; i < n.length; i++) {
        if (!arr.includes(n[i].id)) {continue};
        var t = this.stateTurns(n[i].id) + amount;
        this.setStateTurns(n[i].id, t);
      }
      if (this.isActor()) {this.startAnimation(114, true)} else {this.startAnimation(114)};
    }
  }
}

Game_BattlerBase.prototype.applyContDmg = function(data) {
  if (this.isActor()) {this.startAnimation(19, true);} else {this.startAnimation(19);};
  this._contStack = this._contStack || 0;
  this._contStack++;
  this._contStack = Math.min(this._contStack, 5);

  var id;
  var stack = this._contStack;
  switch (stack) {
    case 2:
      id = 56;
      break;
    case 3:
      id = 57;
      break;
    case 4:
      id = 58;
      break;
    case 5:
      id = 59;
      break;
    default:
      this.resetStateCheck(data, 55);
      break;
  }
  if (id) {
    this.addState(id);
    this.resetStateCheck(data, id);
  };
};

Game_BattlerBase.prototype.detonate = function() {
  var arr = Micoomer._contId;
  var n = this.states();
  var t = 0;
  for (i = 0; i < n.length; i++) {
    if (!arr.includes(n[i].id)) {continue};
    t += this.stateTurns(n[i].id);
  }
  if (t > 0) {
    var base = Math.ceil(this.mhp * 0.05) * t;
    var damage = this.isStateAffected(70) ? Math.ceil(base / 2) : base;
    if (damage >= this.hp) {
    	damage = this.hp - 1;
    };
    if (this.hp !== 1) this.gainHp(-damage);
    this.startDamagePopup();
    this.clearResult();
    AudioManager.playSe({
    	name: "Damage4",
    	volume: 50,
    	pitch: 100
    });

    // Removal
    for (i = 0; i < n.length; i++) {
      if (!arr.includes(n[i].id)) {continue};
      this.removeState(n[i].id);
    }
    if (this.isActor()) {this.startAnimation(115, true)} else {this.startAnimation(115)};
  }
};
