//=============================================================================
// MCM_BrSystem.js
//=============================================================================

/*:
 * @plugindesc
 * @author micoomer
 *
 */

//=============================================================================
// ** ImageManager
//=============================================================================

//=============================
// ** Load Variable Hud
//=============================
ImageManager.loadProsHud = function(filename) {
    return this.loadBitmap('img/hud_pros/', filename, 0, true);
};

//=============================================================================
// ** Scene_Map
//=============================================================================

Scene_Map.prototype.createProsHuds = function() {
	this._prosHuds = new ProsHuds();
	this._hudField0.addChild(this._prosHuds);
};

Scene_Map.prototype.createProsRes = function() {
	this._prosRes = new ProsRes();
	this._hudField1.addChild(this._prosRes);
};

Scene_Map.prototype.terminateProsScene = function() {
	this._hudField0.removeChild(this._prosHuds);
	this._hudField1.removeChild(this._prosRes);
};

Scene_Map.prototype.createClientSelect = function() {
	this._clientSelect = new ProsHuds_ClientSelect();
	this._hudField0.addChild(this._clientSelect);
};

Scene_Map.prototype.terminateClientSelect = function() {
	this._hudField0.removeChild(this._clientSelect);
};

Scene_Map.prototype.toggleClientSelect = function() {
  if (this._clientSelect) {
    this._clientSelect.visible = !this._clientSelect.visible;
  }
};

Scene_Map.prototype.createBirthSelect = function() {
	this._birthSelect = new BirthSelect();
	this._hudField0.addChild(this._birthSelect);
};

Scene_Map.prototype.terminateBirthSelect = function() {
	this._hudField0.removeChild(this._birthSelect);
};

Scene_Map.prototype.endingBirthSelect = function() {
	this.terminateBirthSelect();
  $gameTemp.reserveCommonEvent(49);
};

Scene_Map.prototype.checkEndingBirthSelect = function() {
	this._birthSelect.endingSession();
};

//==============================
// * PluginCommand
//==============================
var _mcm_prosHud_pluginCommand = Game_Interpreter.prototype.pluginCommand
Game_Interpreter.prototype.pluginCommand = function(command, args) {
	_mcm_prosHud_pluginCommand.call(this,command, args)

	// Base Scene
	if (command === "show_prosScene") {
		$gameTemp._brChar_location = args[0]; // 1 = Brothel, 2 = Slum
		this.setSpriteData($gameTemp._brChar_id);
		SceneManager._scene.createProsHuds();
    $gameSystem._rc_ProsSession++;
  }

  else if (command === "show_clientSelect") {
		SceneManager._scene.createClientSelect();
	}

  else if (command === "show_birthSelect") {
		SceneManager._scene.createBirthSelect();
	}

  else if (command === "calculate_res") {
		var id = Number(args[0]);
		this.tallyProsResult(id);
	}

};

Game_Interpreter.prototype.tallyProsResult = function(id) {
	var p = $gameActors.actor($gameTemp._brChar_id);
	switch (id) {

		case 1: // Normal Services

			// Fatigue
			var consumption = Micoomer.fatigueInc[0];
      this.tallyFatigue(p, consumption);

			// Tally
			this.tallyPopularity(1, p);
      this.tallyHorny(1, p);
      this.tallyLewdness(1, p);
      this.tallyMoney(1);

      //Tally Record
      p.addCParam(16, 1);
      $gameSystem._rc_SexActivity++;

		  break;

		case 2: // Normal Sex

			// Fatigue
			var consumption = Micoomer.fatigueInc[1];
      this.tallyFatigue(p, consumption);

      // Tally
			this.tallyPopularity(2, p);
      this.tallyHorny(2, p);
      this.tallyLewdness(2, p);
      this.tallyMoney(2);
			this.tallyEjac(p);

      //Tally Record
      p.addCParam(16, 1);
      p.addCParam(17, 1);
      $gameSystem._rc_SexActivity++;

      break;

	}

	// State Check
  var horny = p.horny;
	this.hornyCheck(horny);

};

Game_Interpreter.prototype.tallyFatigue = function(actor, amount) {
  if (actor.blessing3 > 0) {
    var level = actor.blessing3;
    var red_array = [];
    switch (level) {
      case 1: red_array = [0.92, 20]; break;
      case 2: red_array = [0.92, 30]; break;
      case 3: red_array = [0.92, 40]; break;
      case 4: red_array = [0.85, 40]; break;
      case 5: red_array = [0.85, 50]; break;
      case 6: red_array = [0.85, 60]; break;
      case 7: red_array = [0.78, 60]; break;
      case 8: red_array = [0.78, 70]; break;
      case 9: red_array = [0.78, 80]; break;
      case 10: red_array = [0.7, 80]; break;
    }
    if (Math.randomInt(100) < red_array[1]) {
      amount *= red_array[0];
      var log = Math.floor(((1 - red_array[0]) * 100));
      this.pluginCommand("showLog", ["Vigor Blessing takes effect! (" + log + "% stamina reduction)"]);
    }
  }
  var a = Math.floor(amount);
  actor.recoverStamina(a);
  this.pluginCommand("showLog", ["Girls stamina reduced by " + -a + "."]);
};

Game_Interpreter.prototype.tallyPopularity = function(type, p) {
  switch (type) {
    case 1:
      var y = Micoomer.servicePopBase[0];
      for (var i = 0; i < Micoomer.stateIdCheck.length; i++) {
        var t = Micoomer.stateIdCheck[i];
        if (p.isStateAffected(t)) {y = Micoomer.servicePopBase[i + 1]};
      }
      break;

    case 2:
      var y = Micoomer.sexPopBase[0];
      for (var i = 0; i < Micoomer.stateIdCheck.length; i++) {
        var t = Micoomer.stateIdCheck[i];
        if (p.isStateAffected(t)) {y = Micoomer.sexPopBase[i]};
      }
      break;
  }
  var yy = $gameTemp._brClientMatch ? Math.floor(y * Micoomer.prefMatch_bonusPop) : y
  $gameTemp._brTally_Popularity += yy;
};

Game_Interpreter.prototype.tallyHorny = function(type, p) {
  switch (type) {
    case 1:
      var y = Micoomer.serviceHornyYield[0];
      var b = 1 + (p.lewdlevel * 0.015);
      for (var i = 0; i < Micoomer.stateIdCheck.length; i++) {
        var t = Micoomer.stateIdCheck[i];
        if (p.isStateAffected(t)) {y = Micoomer.serviceHornyYield[i + 1]};
      }
      break;

    case 2:
      var y = Micoomer.sexHornyYield[0];
      var b = 1 + (p.lewdlevel * 0.03);
      for (var i = 0; i < Micoomer.stateIdCheck.length; i++) {
        var t = Micoomer.stateIdCheck[i];
        if (p.isStateAffected(t)) {y = Micoomer.sexHornyYield[i]};
      }
      break;
  }
  y = Math.floor(y * b.clamp(0,2));
  p.addCParam(12, y);
};

Game_Interpreter.prototype.tallyLewdness = function(type, p) {
  switch (type) {

    case 1:
      var base = Micoomer.serviceLewdnessBase;
      break;

    case 2:
      var base = 0;
      for (var i = 0; i < Micoomer.stateIdCheck.length; i++) {
        var t = Micoomer.stateIdCheck[i];
        if (p.isStateAffected(t)) {base = Micoomer.sexLewdnessBase[i]};
      }
      break;

  }
  if ($gameTemp._brChar_location == 2) {
    var loc_bonus1 = Micoomer.location2_LewdBonus[$gameSystem._popLv[2]];
    var loc_bonus2 = (1 + (loc_bonus1 / 100));
    base *= loc_bonus2;
  }
  var variance = (Math.random() * (1.1 - 0.9)) + 0.9;
  var plus = Math.floor(base * variance);
  $gameTemp._brTemp_Lewdness = plus;
  $gameTemp._brTally_Lewdness += plus;
};

Game_Interpreter.prototype.tallyMoney = function(type) {
  var multi = Micoomer.location_MoneyMultiplier[$gameTemp._brChar_location - 1] * $gameTemp._brTally_MoneyMultiplier;
  switch (type) {

    case 1:
      var base = $gameTemp._brClientMatch ? Math.floor($gameTemp._brClient.svc * Micoomer.prefMatch_bonusMoney) : $gameTemp._brClient.svc;
      base *= multi;
      break;

    case 2:
      var base = $gameTemp._brClientMatch ? Math.floor($gameTemp._brClient.sex * Micoomer.prefMatch_bonusMoney) : $gameTemp._brClient.sex;
      base *= multi;
      break;

  }

  if ($gameTemp._brChar_location == 1) {
    var loc_bonus1 = Micoomer.location1_MoneyBonus[$gameSystem._popLv[1]];
    var loc_bonus2 = (1 + (loc_bonus1 / 100));
    base *= loc_bonus2;
  }
  var variance = (Math.random() * (1.2 - 0.8)) + 0.8;
  var plus = Math.floor(base * variance);
  $gameTemp._brTemp_Money = plus;
  $gameTemp._brTally_Money += plus;

};

Game_Interpreter.prototype.tallyEjac = function(p) {
  var multi = Micoomer.location_EjacMultiplier[$gameTemp._brChar_location - 1];
  var base_ejac = Micoomer.sexEjacBase * multi;
  var variance = (Math.random() * (1.1 - 0.9)) + 0.9;
  var plus = Math.floor(base_ejac * variance);
  p.addCParam(13, plus);
};

Game_Interpreter.prototype.hornyCheck = function(param) {
  var tier = 0;
  if (param < 20) {return};
	if (param >= 20 && param < 50) {tier = 0};
	if (param >= 50 && param < 90) {tier = 1};
	if (param >= 90) {tier = 2};
  this.setHornyTier(tier, param);
};

Game_Interpreter.prototype.setHornyTier = function(tier, param) {
  $gameTemp._brChar_status = Micoomer.stateName[tier];
  if (tier == 2) {
    var spec_bonus = Micoomer.sexMoneyMultiplier[tier] + (0.07 * Math.floor((param - 90) / 10));
    $gameTemp._brTally_MoneyMultiplier = spec_bonus;
  } else {
    $gameTemp._brTally_MoneyMultiplier = Micoomer.sexMoneyMultiplier[tier];
  }
};

Game_Interpreter.prototype.setSpriteData = function(id) {
  // Name
	var unit = $gameActors.actor(id);
	$gameTemp._brChar_name = Micoomer.charName[id];
  // Status
	$gameTemp._brChar_status = 'Normal';
  unit.jumpstartHorny();
	this.hornyCheck(unit.horny);
//	for (var i = 0; i < Micoomer.stateIdCheck.length; i++) {
//		var t = Micoomer.stateIdCheck[i];
//		if (unit.isStateAffected(t)) {$gameTemp._brChar_status = Micoomer.stateName[i]};
//	}

};

// CLIENT SHIT
Game_Interpreter.prototype.newClient = function() {
  if ($gameSystem._client_pool.length !== 0) {
    var pool = $gameSystem._client_pool;
    var max = $gameSystem._client_pool.length;
    var rand = Math.randomInt(max);
    var cl = pool[rand];
    if (cl.setfavor == undefined) {
      var pref = this.updateClientPref(cl);
      cl.setfavor = pref;
    }
    $gameSystem._client_ready.push(cl);
    $gameSystem._client_pool.splice(rand, 1);
  }
};

Game_Interpreter.prototype.newClient_N = function() {
  if ($gameSystem._client_pool.length !== 0) {
    var pool = $gameSystem._client_pool;
    var max = $gameSystem._client_pool.length;
    var rand = Math.randomInt(max);
    var cl = pool[rand];
    $gameSystem._client_ready.push(cl);
    $gameSystem._client_pool.splice(rand, 1);
  }
};

Game_Interpreter.prototype.newClient_EX = function() {
  var pool = $gameSystem._client_poolEx;
  var max = $gameSystem._client_poolEx.length;
  var rand = Math.randomInt(max);
  var cl = pool[rand];
  var pref = this.updateClientPref(cl);
  cl.setfavor = pref;
  $gameSystem._client_ready.push(cl);
  $gameSystem._client_poolEx.splice(rand, 1);
};

Game_Interpreter.prototype.clearClient = function() {
  $gameSystem._client_ready = [];
  $gameSystem._client_pool = [];
	for (var i = 0; i < $gameSystem._clientData.length; i++) {
		$gameSystem._client_pool.push($gameSystem._clientData[i]);
	}
};

Game_Interpreter.prototype.resetClientTimer = function() {
	$gameSystem._client_nextTimer = $gameSystem._finishedDemo ? 300 : Micoomer.clientWaitingTime[$gameSystem._popLv[1]];
};

Game_Interpreter.prototype.updateClientPref = function(cl) {
  var data = [$gameSystem._availableGirls,cl.favor];
  var pref = this.weightedRandom(data[0], data[1]);
  var fav = $gameSystem._availableGirls.indexOf(pref);
  return fav;
};

Game_Interpreter.prototype.weightedRandom = function(items, weights) {

  var cumulativeWeights = [];
  for (var i = 0; i < weights.length; i++) {
    cumulativeWeights[i] = weights[i] + (cumulativeWeights[i - 1] || 0);
  }

  var maxCumulativeWeight = cumulativeWeights[cumulativeWeights.length - 1];
  var randomNumber = maxCumulativeWeight * Math.random();

  for (var itemIndex = 0; itemIndex < items.length; itemIndex++) {
    if (cumulativeWeights[itemIndex] >= randomNumber) {
      return items[itemIndex];
    }
  }
}

//=============================================================================
// ** PROSTITUTION
//=============================================================================
function ProsHuds() {
    this.initialize.apply(this, arguments);
};

ProsHuds.prototype = Object.create(Sprite.prototype);
ProsHuds.prototype.constructor = ProsHuds;

//==============================
// * Initialize
//==============================
ProsHuds.prototype.initialize = function() {
    Sprite.prototype.initialize.call(this);

	this.loadBitmaps();

	// Set default var
	this.resetTally();

	this._actorId = $gameTemp._brChar_id;
	this._actor = $gameActors.actor(this._actorId);

  $gameTemp._br_lockIndex = $gameTemp._br_lockIndexTemp;

	this._aniPhase = 0;
	this._aniDur = [20, 20, 30];
	this._aniSpd = [(255/this._aniDur[0]), (255/this._aniDur[1]), (255/this._aniDur[2])];

	this._active = 0; // 0 = no input, 1 = main, 2 = sub
	this._terminate = 0;
	this._dialogActive = false;
	this._endTimer = 60;
	this._wetCheck = false;

	if (!this._hudField) {this.createHudField()};

	// Create Sprites
	this.createSprites();
};

ProsHuds.prototype.resetTally = function() {
	$gameTemp._brTally_Lewdness = 0;
	$gameTemp._brTally_Money = 0;
	$gameTemp._brTally_Popularity = 0;
	$gameTemp._brTally_MoneyMultiplier = 1;
};

//==============================
// * Load Bitmaps
//==============================
ProsHuds.prototype.loadBitmaps = function() {
	this._bgImg = ImageManager.loadProsHud("Backdrop");
	this._titleImg = ImageManager.loadProsHud("Title");
	this._layImg = ImageManager.loadProsHud("Layout");
};

ProsHuds.prototype.createHudField = function() {
	this._hudField = new Sprite();
	this.addChild(this._hudField);
	this._hudField1 = new Sprite();
	this.addChild(this._hudField1);
	this._hudField2 = new Sprite();
	this.addChild(this._hudField2);
	this._hudField3 = new Sprite();
	this.addChild(this._hudField3);
};

//==============================
// * Create Sprites
//==============================

ProsHuds.prototype.createSprites = function() {
	this.createBackground();
	this.createLayout();
	this.createName();
  this.createMenu();
	this.createStatus();
	this.createBust();
	this.createDialog();
};

ProsHuds.prototype.createBackground = function() {
	this._bg = new Sprite(this._bgImg);
	this._bg.opacity = 0;
	this._hudField.addChild(this._bg);
};

ProsHuds.prototype.createLayout = function() {
	this._layout = [];
	this._layout[0] = new Sprite(this._titleImg);
	this._layout[0].opacity = 0;
	this._hudField1.addChild(this._layout[0]);
	this._layout[1] = new Sprite(this._layImg);
	this._layout[1].opacity = 0;
	this._hudField1.addChild(this._layout[1]);
};

ProsHuds.prototype.createName = function() {
	this._name = new Sprite();
	this._name.bitmap = ImageManager.loadProsHud("N_" + $gameTemp._brChar_name);
	this._name.x = 1180;
	this._name.y = 48;
	this._name.anchor.x = 0.5;
	this._name.anchor.y = 0.5;
	this._name.opacity = 0;
	this._hudField1.addChild(this._name);
};

ProsHuds.prototype.createMenu = function() {
	this._mainMenu = new ProsHuds_Main();
  this._mainMenu.opacity = 0;
  this._hudField2.addChild(this._mainMenu);
};

ProsHuds.prototype.createStatus = function() {

	// Status Hud
	this._status = new Sprite(ImageManager.loadProsHud("Status"));
	this._status.opacity = 0;
	this._status.x = 995;
	this._status.y = 106;
	this._hudField1.addChild(this._status);

	// Status Text
	this._statText = [];
	for (var i = 0; i < 2; i++) {
		this._statText[i] = new Sprite(new Bitmap(200,40));
		this._statText[i].opacity = 0;
		this._statText[i].x = 1019;
		this._statText[i].y = 110 + (40 * i);
		this._statText[i].bitmap.fontSize = 18;
		this._statText[i].bitmap.fontFace = "FredokaSemi";
		this._statText[i].bitmap.textColor = '#f565c7';
		this._hudField1.addChild(this._statText[i]);
	}

  this.updateStatus();

};

ProsHuds.prototype.createBust = function() {
	this._bust = new MSprite(this._actorId, 1);
	this._bust.anchor.x = 0.5;
	this._bust.y = -130;
	this._bust.opacity = 0;
	this._hudField1.addChild(this._bust);
};

ProsHuds.prototype.createDialog = function() {

	this._dialogLayout = new Sprite(ImageManager.loadOther_Overworld('Message_2'));
	this._dialogLayout.opacity = 0;
	this._dialogLayout.anchor.x = 0.5;
	this._dialogLayout.x = Graphics.boxWidth / 2 + 15;
	this._dialogLayout.y = 547;
	this._hudField3.addChild(this._dialogLayout);

	this._dialogName = new Sprite(new Bitmap(100,40));
	this._dialogName.opacity = 0;
	this._dialogName.anchor.x = 0.5;
	this._dialogName.x = this._dialogLayout.x - 145;
	this._dialogName.y = this._dialogLayout.y - 7;
	this._hudField3.addChild(this._dialogName);
	this._dialogName.bitmap.fontSize = 22;
	this._dialogName.bitmap.textColor = '#9e5c95';
	this._dialogName.bitmap.drawText($gameTemp._brChar_name, 0,0,100,40,"center");

	this._dialogText = new Sprite(new Bitmap(600,40));
	this._dialogText.opacity = 0;
	this._dialogText.anchor.x = 0.5;
	this._dialogText.x = this._dialogLayout.x;
	this._dialogText.y = this._dialogLayout.y + 36;
	this._dialogText.bitmap.fontSize = 20;
	this._hudField3.addChild(this._dialogText);
	this.selectDialog(Micoomer.d_greetings[this._actorId]);
  this.selectFace(Micoomer.f_greetings[this._actorId]);

};

ProsHuds.prototype.createNotice = function(type) {
	if (this._notice) {this._hudField1.removeChild(this._notice)};
	this._notice = new Sprite(ImageManager.loadProsHud("Notice"));
	this._notice.anchor.x = 0.5;
	this._notice.anchor.y = 0.5;
	this._noticeOrg = Graphics.boxHeight / 2;
	this._notice.x = Graphics.boxWidth / 2;
	this._notice.y = this._noticeOrg + 100;
	this._notice.opacity = 0;
	this._hudField1.addChild(this._notice);
	this._noticeTimer = 20;
  var frame = type == 0 ? 0 : 60;
  this._notice.setFrame(0, frame, 700, 60);
};

ProsHuds.prototype.createPopup = function() {

//	AudioManager.playSe({
//		name: "System - Treasure Get",
//		volume: 90,
//		pitch: 100
//	});

	this._popTimer = [];
	this._popupOrg = [];
	this._popupActive = [];

	// Popup Layout
	this._popup = [];

	for (var i = 0; i < 2; i++) {
		this._popup[i] = new Sprite(ImageManager.loadProsHud("Popup"));
		this._popup[i].anchor.x = 0.5;
		this._popup[i].anchor.y = 0.5;
		this._popupOrg[i] = Graphics.boxHeight / 2 - 93 + (40 * i);
		this._popup[i].x = Graphics.boxWidth / 2 + 264;
		this._popup[i].y = this._popupOrg[i] + 100 + (20 * i);
		this._popup[i].opacity = 0;
		this._popupActive[i] = false;
		this._popTimer[i] = 60;
		this._hudField2.addChild(this._popup[i]);
	}

	// Popup Text
	this._popupText = [];
	for (var i = 0; i < 2; i++) {
		this._popupText[i] = new Sprite(new Bitmap(200,40));
		this._popupText[i].anchor.x = 0.5;
		this._popupText[i].anchor.y = 0.5;
		this._popupText[i].x = this._popup[i].x;
		this._popupText[i].y = this._popup[i].y - 3;
		this._popupText[i].opacity = 0;
		this._hudField2.addChild(this._popupText[i]);
		this.refreshPopup(this._popupText[i], i);

	}

};

//==============================
// * Set
//==============================

ProsHuds.prototype.stateCheck = function() {
	if (!this._wetCheck) {
		var horny = this._actor.horny;
		if (horny >= 20) {
      this._mainMenu.lockOpen(1);
  		this._wetCheck = true;
      $gameMap._interpreter.pluginCommand("showLog", ["Alright! The girl is wet !"]);
		}
	}
};

ProsHuds.prototype.refreshPopup = function(sprite, id) {
	var text = "";
	text = id == 0 ? "+" + $gameTemp._brTemp_Lewdness + " Lewdness" : "+" + $gameTemp._brTemp_Money + " Money"
	sprite.bitmap.fontSize = 22;
	sprite.bitmap.textColor = id == 0 ? '#e478d3' : '#e3ac37'
	sprite.bitmap.drawText(text, 0,0,200,40,"center");
};

ProsHuds.prototype.selectDialog = function(set) {
	if (!set) {return};
	if (set.length === 0) {return};
	var setIndex = Math.randomInt(set.length);
	var setText = set[setIndex];
	this._dialogText.bitmap.clear();
	this._dialogText.bitmap.drawText(setText, 0,0,600,40,"center");
	this._dialogActive = true;
	this._dialogTimer = 180;
};

ProsHuds.prototype.selectFace = function(set) {
	if (!set) return;
  if (!set.length === 0) return;
  var setIndex = Math.randomInt(set.length);
  this._bust.setFace(set[setIndex]);
};

ProsHuds.prototype.notAvailableMenu = function(type) {
	this.createNotice(type);
};

ProsHuds.prototype.gainRewards = function() {
	$gameParty.gainGold($gameTemp._brTally_Money);
	this._actor.gainLewdness($gameTemp._brTally_Lewdness);
  $gameTemp._popStoreTemp[$gameTemp._brChar_location] += $gameTemp._brTally_Popularity;

  // AP Consumption
	var consumption = 25;
  $gameParty.recoverAP(-consumption);

  // Client Splice
  $gameSystem._client_pool.push($gameTemp._brClient);
  $gameSystem._client_ready.splice($gameTemp._brClientID, 1);
};

ProsHuds.prototype.processSub = function(type) {
	this._subMenu = new ProsHuds_Sub(this._actorId, type);
  this._hudField2.addChild(this._subMenu);
};

ProsHuds.prototype.sprite_move_to = function(value,real_value, speed) {
	if (value === real_value) {return value};
	var dnspeed = 1 + (Math.abs(value - real_value) / speed);
	if (value > real_value) {value -= dnspeed;
	    if (value < real_value) {value = real_value};}
    else if (value < real_value) {value  += dnspeed;
    	if (value  > real_value) {value  = real_value};
    };
	return Math.floor(value);
};

//==============================
// * Update Timeline
//==============================

ProsHuds.prototype.updateTimeline = function() {
	if (this._aniDur[this._aniPhase] > 0) {
		this._aniDur[this._aniPhase]--;
	} else {
		this._aniPhase += 1;
		if (this._aniPhase == 3) {this._active = 1};
	}
};

ProsHuds.prototype.updateAni = function() {
	var speed = this._aniSpd[this._aniPhase];

	switch (this._aniPhase) {

	// Phase 0
	case 0:
		this._bg.opacity += speed;
		break;

	// Phase 1
	case 1:
		for (var i = 0; i < this._layout.length; i++) {
			this._layout[i].opacity += speed;
		}
		this._name.opacity += speed;
		break;

	// Phase 2
	case 2:
		this._bust.opacity += speed;
		this._mainMenu.opacity += speed;
		this._status.opacity += speed;
		this._statText[0].opacity += speed;
		this._statText[1].opacity += speed;
		this._dialogLayout.opacity += speed;
		this._dialogName.opacity += speed;
		this._dialogText.opacity += speed;
		break;

	}
};

ProsHuds.prototype.updateStatus = function() {
	this._statText[0].bitmap.clear();
	this._statText[1].bitmap.clear();
	var text1 = Math.ceil((this._actor.stam / this._actor.maxstam) * 100);
	var text2 = $gameTemp._brChar_status;
	this._statText[0].bitmap.drawText(text1 + "%", 0,0,200,40,"right");
	this._statText[1].bitmap.drawText(text2, 0,0,200,40,"right");
};

ProsHuds.prototype.updatePopup = function() {
	for (var i = 0; i < this._popup.length; i++) {
		if (this._popup[i].y > this._popupOrg[i]) {
			this._popup[i].y -= 10;
			this._popup[i].opacity += 26;
			if (this._popup[i].y <= this._popupOrg[i]) {this._popupActive[i] = true};
		}
		this._popupText[i].y = this._popup[i].y - 3;
		this._popupText[i].opacity = this._popup[i].opacity;
		if (this._popupActive[i]) {this._popTimer[i]--;}
		if (this._popTimer[i] <= 0) {
			this._popup[i].y -= 5;
			this._popup[i].opacity -= 32;
			this._popup[i].scale.y -= 0.1;
			this._popupText[i].visible = false;
			if (this._popup[i].opacity == 0) {
				this._hudField2.removeChild(this._popup[i]);
				this._hudField2.removeChild(this._popupText[i]);
			};
		}
	}
};

ProsHuds.prototype.updateDialog = function() {
	if (this._dialogActive) {
		this._hudField3.opacity += 30;
		this._dialogTimer--;
		if (this._dialogTimer == 0) {
			this._dialogActive = false;
		}
	} else {
		this._hudField3.opacity -= 20;
	}
};

ProsHuds.prototype.updateNotice = function() {
  if (this._notice.y !== this._noticeOrg) {
    this._notice.y = this.sprite_move_to(this._notice.y, this._noticeOrg, 6);
    this._notice.opacity = this.sprite_move_to(this._notice.opacity, 255, 4);
  } else {
    this._noticeTimer--;
  };
	if (this._noticeTimer <= 0) {
		this._notice.opacity -= 15;
		if (this._notice.opacity == 0) {
			this._hudField1.removeChild(this._notice);
		}
	}
};

//==============================
// * Boolean
//==============================

ProsHuds.prototype.enterCG = function() {
	  if ($gameTemp._enterCG) {return true};
	  return false;
};

ProsHuds.prototype.quitCG = function() {
	  if ($gameTemp._quitCG[1]) {return true};
	  return false;
};

ProsHuds.prototype.pressAnyButton = function() {
	  if (Input.isTriggered('ok') || Input.isTriggered('cancel')) {return true};
	  return false;
};

ProsHuds.prototype.fatigueCheck = function(type) {
	var ftg = this._actor.stam;
	if (ftg < -Micoomer.fatigueInc[type]) {return false};
	return true;
};

//==============================
// * Input
//==============================
ProsHuds.prototype.updateInput = function() {
	if (this._mainMenu.readyInput()) {
		if (Input.isRepeated('down')) {
			this._mainMenu.processDown();
		} else if (Input.isRepeated('up')) {
			this._mainMenu.processUp();
		} else if (Input.isTriggered('ok')) {
			var ind = this._mainMenu._index;
			if (this._mainMenu.isLocked(ind)) {
        var type = ind == 1 ? 0 : 1;
				SoundManager.playBuzzer();
				this.notAvailableMenu(type);
			} else {
				switch(ind) {
				case 0:
				case 1:
					SoundManager.playOk();
					if (this.fatigueCheck(ind)) {
            this._active = 2;
            this.processSub(ind);
						this.selectDialog(Micoomer.d_actionAcc[this._actorId]);
            this.selectFace(Micoomer.f_actionAcc[this._actorId]);
					} else {
						this.selectDialog(Micoomer.d_emptied[this._actorId]);
            this.selectFace(Micoomer.f_emptied[this._actorId]);
					}
					break;
				case 4:
					SoundManager.playOk();
					this._active = 0;
					this._terminate = 1;
					this.selectDialog(Micoomer.d_goodbye[this._actorId]);
          this.selectFace(Micoomer.f_goodbye[this._actorId]);
				}
			}
		}
	}
};

ProsHuds.prototype.updateInput2 = function() {
	if (this._subMenu.readyInput()) {
		if (Input.isRepeated('down')) {
			  this._subMenu.processDown();
		} else if (Input.isRepeated('up')) {
				this._subMenu.processUp();
		} else if (Input.isTriggered('ok')) {
			SoundManager.playOk();
			this._active = 0;
			$gameTemp._enterCG = true;
			var ce = this._subMenu._type == 0
      ? Micoomer.svcCE[this._subMenu._availableSvc[this._subMenu.index]][this._actorId - 1]
      : Micoomer.sexCE[this._subMenu._availableSex[this._subMenu.index]][this._actorId - 1];
      if (this._subMenu._type == 0) {this.setSvcName(this._subMenu.index)};
			$gameTemp.reserveCommonEvent(ce);
		} else if (Input.isTriggered('cancel')) {
			SoundManager.playCancel();
			this._hudField2.removeChild(this._subMenu);
			this._active = 1;
			this.selectDialog(Micoomer.d_actionCancel[this._actorId]);
      this.selectFace(Micoomer.f_actionCancel[this._actorId]);
		}
	}
};

ProsHuds.prototype.setSvcName = function(i) {
  var a;
  switch (i) {
    case 0: a = "Kiss"; break;
    case 1: a = "Grope"; break;
    case 2: a = "Fellatio"; break;
    case 3: a = "Handjob"; break;
    case 4: a = "Paizuri"; break;
  }
  $gameTemp._svcPath = a;
}

//==============================
// * Check
//==============================
ProsHuds.prototype.CGtransition = function() {
	if (this.enterCG()) {
		this._dialogActive = false;
		this._hudField1.opacity -= 15;
		this._hudField2.opacity -= 15;
		if (this._hudField2.opacity == 0) {
			this._hudField2.removeChild(this._subMenu);
			$gameTemp._enterCG = false
		};
	} else if (this.quitCG()) {
		if ($gameTemp._quitCG[0]) {
			this.stateCheck();
			this.createPopup();
      this.updateStatus();
			this.selectDialog(Micoomer.d_afterCG[this._actorId]);
      this.selectFace(Micoomer.f_afterCG[this._actorId]);
			$gameTemp._quitCG[0] = false;
		};
		this._hudField1.opacity += 15;
		this._hudField2.opacity += 15;
		if (this._hudField2.opacity >= 255) {
			$gameTemp._quitCG[1] = false;
			this._active = 1;
		};
	}
};

ProsHuds.prototype.checkTermination = function() {

	switch (this._terminate) {

	case 1:
		this._endTimer--;
		if (this._endTimer == 0) {
			this._terminate = 2;
		}
		break;

	case 2:
		this._dialogActive = false;
		this._hudField1.opacity -= 10;
		this._hudField2.opacity -= 10;
		if (this._hudField2.opacity == 0) {
			if (!SceneManager._scene._prosRes) {
        SceneManager._scene.createProsRes()
      };
			if (this.pressAnyButton()) {
        this.gainRewards();
				SoundManager.playOk();
        SceneManager._scene._prosRes._needHide = true;
				this._terminate = 3;
			}
		}
		break;

	case 3:
		this._hudField.opacity -= 10;
		if (this._hudField.opacity == 0) {
			SceneManager._scene.terminateProsScene();
			$gameSwitches.setValue(541, true);
		}
		break;

	}
};

ProsHuds.prototype.update = function() {
	if (this._aniPhase < 3) {
		this.updateTimeline();
		this.updateAni();
	}
	if (this._popup) {this.updatePopup()};
	if (this._notice) {this.updateNotice()};
	this.updateDialog();
	if (this._active == 1) {
		this.updateInput();
	}
  if (this._active == 2) {
		this.updateInput2();
	}
	this.CGtransition();
	this.checkTermination();
  if (this._mainMenu) this._mainMenu.update();
  if (this._subMenu) this._subMenu.update();
};


//==============================
// * PROSTITUTION MAIN
//==============================

function ProsHuds_Main() {
    this.initialize.apply(this, arguments);
};

ProsHuds_Main.prototype = Object.create(Sprite.prototype);
ProsHuds_Main.prototype.constructor = ProsHuds_Main;

//==============================
// * Initialize
//==============================
ProsHuds_Main.prototype.initialize = function(actorId) {
    Sprite.prototype.initialize.call(this);

	this._actorId = actorId;
	this._actor = $gameActors.actor(this._actorId);

	this._index = 0;
	this._maxIndex = 5;
  this._lastIndex = this._maxIndex - 1;

  $gameTemp._br_lockIndex = $gameTemp._br_lockIndexTemp;

  this._duration = 40;
  this._speed = [12, 255/25];

  this._orgX = [39, -200];
  this._orgY = [142, 560];

	// Create Sprites
  this.loadBitmaps();
	this.createSprites();
};

ProsHuds_Main.prototype.loadBitmaps = function() {
  this._img = [];
  for (var i = 0; i < this._maxIndex; i++) {
    this._img[i] = ImageManager.loadProsHud('Com_' + i);
  }
  this._cursorImg = ImageManager.loadProsHud('Cursor');
  this._lockImg = ImageManager.loadProsHud('Lock');
};

ProsHuds_Main.prototype.createSprites = function() {
  this.createInactiveCommands();
	this.createActiveCommands();
  this.createCursor();
	this.createInLock();
	this.createAcLock();
};

ProsHuds_Main.prototype.createInactiveCommands = function() {
  this._inCom = [];
	for (var i = 0; i < this._maxIndex; i++) {
		this._inCom[i] = new Sprite(this._img[i]);
		this._inCom[i].x = this._orgX[0];
	  this._inCom[i].y = i !== this._lastIndex ? this._orgY[0] + (60 * i) : this._orgY[1];
		this.addChild(this._inCom[i]);
    this._inCom[i].setFrame(0,0,256,64);
	}
};

ProsHuds_Main.prototype.createActiveCommands = function() {
  this._acCom = [];
	for (var i = 0; i < this._maxIndex; i++) {
		this._acCom[i] = new Sprite(this._img[i]);
		this._acCom[i].x = this._inCom[i].x;
		this._acCom[i].y = this._inCom[i].y;
    this._acCom[i].opacity = 0;
		this.addChild(this._acCom[i]);
    this._acCom[i].setFrame(0,64,256,64);
	}
};

ProsHuds_Main.prototype.createCursor = function() {
		this._cursor = new Sprite(this._cursorImg);
		this._cursor.x = this._inCom[0].x + 37;
    this._cursor.anchor.x = 0.5;
    this._cursor.anchor.y = 0.5;
		this.addChild(this._cursor);
    this.resetCursor(0);
};

ProsHuds_Main.prototype.createInLock = function() {
  this._inLock = [];
	for (var i = 0; i < this._maxIndex; i++) {
		this._inLock[i] = new Sprite(this._lockImg);
		this._inLock[i].x = this._inCom[i].x + 26;
		this._inLock[i].y = this._inCom[i].y + 22;
    this._inLock[i].visible = false;
		this.addChild(this._inLock[i]);
    this.checkLock(this._inLock[i], i);
    this._inLock[i].setFrame(0,0,20,20);
	}
};

ProsHuds_Main.prototype.createAcLock = function() {
  this._acLock = [];
	for (var i = 0; i < this._maxIndex; i++) {
    var p = $gameTemp._br_lockIndex[i];
		this._acLock[i] = new Sprite(this._lockImg);
		this._acLock[i].x = this._inLock[i].x;
		this._acLock[i].y = this._inLock[i].y;
    this._acLock[i].opacity = 0;
    this._acLock[i].visible = false;
		this.addChild(this._acLock[i]);
    this.checkLock(this._acLock[i], i);
    this._acLock[i].setFrame(0,20,20,20);
	}
};


//==============================
// * Set
//==============================

ProsHuds_Main.prototype.resetCursor = function(i) {
	var y = this._inCom[i].y + 17;
  this._cursor.y = y;
  this._cursor.opacity = 0;
};

ProsHuds_Main.prototype.resetLockOpc = function() {
  for (var i = 0; i < this._maxIndex; i++) {
    this._inLock[i].visible = false;
    this._acLock[i].visible = false;
  }
};

ProsHuds_Main.prototype.checkLock = function(sprite, index) {
  var p = $gameTemp._br_lockIndex.indexOf(index, 0);
  if (p !== -1) {
    sprite.visible = true;
  }
};

ProsHuds_Main.prototype.lockOpen = function(i) {
  var p = $gameTemp._br_lockIndex.indexOf(i,0);
	if (p !== -1) {
    var n = $gameTemp._br_lockIndex[p];
    this._inLock[n].visible = false;
    this._acLock[n].visible = false;
    $gameTemp._br_lockIndex.splice(p, 1);
  }
};

//==============================
// * Update Timeline
//==============================

ProsHuds_Main.prototype.sprite_move_to = function(value,real_value, speed) {
	if (value === real_value) {return value};
	var dnspeed = 1 + (Math.abs(value - real_value) / speed);
	if (value > real_value) {value -= dnspeed;
	    if (value < real_value) {value = real_value};}
    else if (value < real_value) {value  += dnspeed;
    	if (value  > real_value) {value  = real_value};
    };
	return Math.floor(value);
};

ProsHuds_Main.prototype.updateCommand = function() {
	for (var i = 0; i < this._maxIndex; i++) {
		if (this.isComEnabled(i)) {
			this._acCom[i].opacity += 50;
		} else {
			this._acCom[i].opacity = 0;
		}
	}
};

ProsHuds_Main.prototype.updateCursor = function() {
  var ind = this._index;
  if ($gameTemp._br_lockIndex.indexOf(ind) == -1) {
	   var y = this._inCom[ind].y + 32;
     this._cursor.y = this.sprite_move_to(this._cursor.y, y, 30);
     this._cursor.opacity = this.sprite_move_to(this._cursor.opacity, 255, 15);
  }
};

ProsHuds_Main.prototype.updateLock = function() {
	if ($gameTemp._br_lockIndex !== $gameTemp._br_lockIndexTemp) {
    $gameTemp._br_lockIndex = $gameTemp._br_lockIndexTemp;
    this.resetLockOpc();
    for (var i = 0; i < this._maxIndex; i++) {
      this.checkLock(this._inLock[i], i);
      this.checkLock(this._acLock[i], i);
    }
  }
};

ProsHuds_Main.prototype.updateLockOpc = function() {
	for (var i = 0; i < $gameTemp._br_lockIndex.length; i++) {
    var p = $gameTemp._br_lockIndex[i];
		if (this.isComEnabled(p)) {
      this._acLock[p].opacity += 50;
		} else {
      this._acLock[p].opacity = 0;
		}
	}
};


//==============================
// * Boolean
//==============================
ProsHuds_Main.prototype.isComEnabled = function(index) {
	  if (index != this._index) {return false};
	  return true;
};

ProsHuds_Main.prototype.readyInput = function() {
	if (this.opacity == 255) {return true};
  return false;
};

ProsHuds_Main.prototype.isLocked = function(index) {
	  if ($gameTemp._br_lockIndex.indexOf(index) !== -1) {return true};
	  return false;
};

//==============================
// * Input
//==============================
ProsHuds_Main.prototype.processDown = function() {
  if (this._index < this._lastIndex) {
    this._index += 1;
    SoundManager.playCursor();
    this.resetCursor(this._index);
  }
};

ProsHuds_Main.prototype.processUp = function() {
  if (this._index > 0) {
    this._index -= 1;
    SoundManager.playCursor();
    this.resetCursor(this._index);
  }
};

//==============================
// * Check
//==============================
ProsHuds_Main.prototype.update = function() {
  this.updateLock();
  if (this.readyInput()) {
    this.updateCommand();

    this.updateLockOpc();
    this.updateCursor();
  }
};


//==============================
// * PROSTITUTION SUB
//==============================

function ProsHuds_Sub() {
    this.initialize.apply(this, arguments);
};

ProsHuds_Sub.prototype = Object.create(Sprite.prototype);
ProsHuds_Sub.prototype.constructor = ProsHuds_Sub;

//==============================
// * Initialize
//==============================
ProsHuds_Sub.prototype.initialize = function(actorId, type) {
    Sprite.prototype.initialize.call(this);

	this._actorId = actorId;
	this._actor = $gameActors.actor(this._actorId);
  this._type = type;
  this.setSubMenu();

	this.index = 0;
	this._maxIndex = this._type == 0 ? this._availableSvc.length : this._availableSex.length;
  this._lastIndex = this._maxIndex - 1;

  this._duration = 40;
  this._speed = [12, 255/25];

	// Create Sprites
  this.setPathing(this._type);
	this.createSprites();
};

//==============================
// * Load Bitmaps
//==============================
ProsHuds_Sub.prototype.setPathing = function(type) {
  var p = type == 0 ? 'ComSvc_' : 'ComSex_';
  var a = type == 0 ? this._availableSvc : this._availableSex;
  this._img = [];
  for (var i = 0; i < this._maxIndex; i++) {
    this._img[i] = ImageManager.loadProsHud(p + a[i]);
  }
};

ProsHuds_Sub.prototype.setSubMenu = function() {

  if ($gameTemp._br_svcAvailable.length == 0) {
    this._availableSvc = this.defaultSvc();
  } else {
    this._availableSvc = $gameTemp._br_svcAvailable;
  }
  if ($gameTemp._br_sexAvailable.length == 0) {
    this._availableSex = this.defaultSex();
  } else {
    this._availableSex = $gameTemp._br_sexAvailable;
  }
};

ProsHuds_Sub.prototype.defaultSvc = function() {
  return [0,1,2,3,4];
};

ProsHuds_Sub.prototype.defaultSex = function() {
  switch (this._actorId) {
    case 1:
      return [0,1];
      break;

    case 2:
      return [2];
      break;
  }
};

//==============================
// * Create Sprites
//==============================

ProsHuds_Sub.prototype.createSprites = function() {
  this._inSub = [];
  this._acSub = [];
  this._org = [];
  this._wait = [];
	for (var i = 0; i < this._maxIndex; i++) {
		this._inSub[i] = new Sprite(this._img[i]);
		this._inSub[i].opacity = 0;
		this._inSub[i].x = 640;
		this._inSub[i].y = 720;
    this._inSub[i].anchor.x = 0.5;
		this.addChild(this._inSub[i]);

		this._acSub[i] = new Sprite(this._img[i]);
		this._acSub[i].opacity = 0;
		this._acSub[i].x = this._inSub[i].x;
		this._acSub[i].y = this._inSub[i].y;
    this._acSub[i].anchor.x = 0.5;
		this.addChild(this._acSub[i]);

    this._org[i] = (360 - 40 * this._maxIndex) + (55 * i);
    this._wait[i] = 4 * i; // 0,4,12,16,20
		this.setSubSprite(i);
	}
};

//==============================
// * Set
//==============================

ProsHuds_Sub.prototype.setSubSprite = function(id) {
  this._inSub[id].setFrame(0,0,516,64);
  this._acSub[id].setFrame(0,64,516,64);
};

//==============================
// * Update Timeline
//==============================

ProsHuds_Sub.prototype.sprite_move_to = function(value,real_value, speed) {
	if (value === real_value) {return value};
	var dnspeed = 1 + (Math.abs(value - real_value) / speed);
	if (value > real_value) {value -= dnspeed;
	    if (value < real_value) {value = real_value};}
    else if (value < real_value) {value  += dnspeed;
    	if (value  > real_value) {value  = real_value};
    };
	return Math.floor(value);
};

ProsHuds_Sub.prototype.selectAni = function() {
	if (this._duration > 0) {
    for (var i = 0; i < this._maxIndex; i++) {
      this.updateAni(this._inSub[i], i);
    }
    this._duration--;
  }
};

ProsHuds_Sub.prototype.updateAni = function(sprite, i) {

  if (this._wait[i] == 0) {
    var speed = this._speed[0];
    var target = this._org[i];
    sprite.y = this.sprite_move_to(sprite.y, target, speed);
    sprite.opacity += this._speed[1];
  }
  if (this._wait[i] > 0) {this._wait[i]--};
};

ProsHuds_Sub.prototype.updateSub = function() {
	for (var i = 0; i < this._maxIndex; i++) {
		if (this.isSubEnabled(i)) {
			this._acSub[i].opacity += 50;
		} else {
			this._acSub[i].opacity = 0;
		}
    this._acSub[i].y = this._inSub[i].y;
	}
};

//==============================
// * Boolean
//==============================
ProsHuds_Sub.prototype.isSubEnabled = function(index) {
	  if (index != this.index) {return false};
	  return true;
};

ProsHuds_Sub.prototype.readyInput = function() {
	if (this._duration == 0) {return true};
  return false;
};

//==============================
// * Input
//==============================
ProsHuds_Sub.prototype.processDown = function() {
  if (this.index < this._lastIndex) {
    this.index += 1;
    SoundManager.playCursor();
  }
};

ProsHuds_Sub.prototype.processUp = function() {
  if (this.index > 0) {
    this.index -= 1;
    SoundManager.playCursor();
  }
};

//==============================
// * Check
//==============================
ProsHuds_Sub.prototype.update = function() {
  this.selectAni();
  if (this.readyInput()) {this.updateSub()};
};


//=============================================================================
// ** PROSTITUTE RESULT
//=============================================================================
function ProsRes() {
    this.initialize.apply(this, arguments);
};

ProsRes.prototype = Object.create(Sprite.prototype);
ProsRes.prototype.constructor = ProsRes;

ProsRes.prototype.initialize = function() {
  Sprite.prototype.initialize.call(this);
  this._org = [];
  this._org[0] = Graphics.boxHeight / 2;
  this._org[1] = this._org[0] + 120;
  this._org[2] = this._org[0] - 120;
	this.resetTally();
	this.createSprites();
};

ProsRes.prototype.createSprites = function() {
	this.x = Graphics.boxWidth / 2;
	this.y = this._org[1];
  this.createLayout();
	this.createNumber();
  this._needHide = false;
};

ProsRes.prototype.createLayout = function() {
  this._layout = new Sprite(ImageManager.loadProsHud("Result"));
  this._layout.anchor.x = 0.5;
  this._layout.anchor.y = 0.5;
  this._layout.y = 23;
	this.addChild(this._layout);
};

ProsRes.prototype.createNumber = function() {
	this._number = [];
	for (i = 0; i < 3; i++) {
		this._number[i] = new Sprite(new Bitmap(200,60));
		this._number[i].x = this._layout.x - 40;
		this._number[i].y = this._layout.y - 56 + (30 * i);
		this._number[i].bitmap.textColor = '#ffdada';
		this._number[i].bitmap.fontFace = "FredokaRegular";
		this._number[i].bitmap.fontSize = 16;
		this.addChild(this._number[i]);
		this.refreshNumber(i);
	}
};

ProsRes.prototype.refreshNumber = function(index) {
	this._number[index].bitmap.clear();
	this._number[index].bitmap.drawText(this._var[index],0,0,200,60,"right");
};

ProsRes.prototype.resetTally = function() {
	this._var = [];
	this._var[0] = $gameTemp._brTally_Lewdness;
	this._var[1] = $gameTemp._brTally_Money;
	this._var[2] = $gameTemp._brTally_Popularity;
	$gameTemp._brRes_var[0] = this._var[0];
	$gameTemp._brRes_var[1] = this._var[1];
	$gameTemp._brRes_var[2] = this._var[2];
};

ProsRes.prototype.sprite_move_to = function(value,real_value, speed) {
	if (value === real_value) {return value};
	var dnspeed = 1 + (Math.abs(value - real_value) / speed);
	if (value > real_value) {value -= dnspeed;
	    if (value < real_value) {value = real_value};}
    else if (value < real_value) {value  += dnspeed;
    	if (value  > real_value) {value  = real_value};
    };
	return Math.floor(value);
};

ProsRes.prototype.updateMove = function() {
  if (this._needHide) {
    this.opacity -= 25;
    this.y = this.sprite_move_to(this.y, this._org[2], 12);
  } else {
    this.opacity += 25;
    this.y = this.sprite_move_to(this.y, this._org[0], 12);
  }
};

ProsRes.prototype.update = function() {
	this.updateMove();
};



//==============================
// * PROSTITUTION CLIENT SELECT
//==============================

function ProsHuds_ClientSelect() {
    this.initialize.apply(this, arguments);
};

ProsHuds_ClientSelect.prototype = Object.create(Sprite.prototype);
ProsHuds_ClientSelect.prototype.constructor = ProsHuds_ClientSelect;

ProsHuds_ClientSelect.prototype.initialize = function() {
    Sprite.prototype.initialize.call(this);

  $gameTemp.reserveCommonEvent(24);
  $gameTemp._brClientMatch = false;

  // client pool
  this._clientPool = $gameSystem._client_ready;

	this._index = 0;
	this._maxIndex = $gameSystem._client_ready.length;
  this._lastIndex = this._maxIndex - 1;

  this._charIndex = 0;
	this._charMaxIndex = $gameParty.size();
  this._charLastIndex = this._charMaxIndex - 1;

  var actor = $gameParty.members();
  this._aID = [];
  this._actor = [];
  for (var i = 0; i < this._charMaxIndex; i++) {
    this._aID[i] = actor[i]._actorId;
    this._actor[i] = $gameActors.actor(this._aID[i]);
  }

  this._phase = 0;

  this._duration = [];
  this._duration[0] = 31 + 5 * this._maxIndex;
  this._duration[1] = 40;
  this._speed = [12, 255/25];
  this._org = [];
  this._exOrg = [1290,990];
  this._wait = [];

	// Create Sprites
  this.loadBitmaps();
	this.createSprites();
};

ProsHuds_ClientSelect.prototype.loadBitmaps = function() {
  this._layImg = ImageManager.loadProsHud('UI_ProsClientSelect');
  this._prefImg = ImageManager.loadProsHud('UI_ProsClientPref');
  this._cursorImg = ImageManager.loadProsHud('Cursor');
};

ProsHuds_ClientSelect.prototype.createSprites = function() {
  this.createField();
  this.createRightBack();
  this.createDialog();

  // Phase 1
  this.createInactiveCommands();
	this.createActiveCommands();
  this.createCursor();
  this.createClientName();
  this.createClientPref();
  this.createGrad();

  // Phase 2
  this.createChar();
  this.createCharMeter();
  this.createTopPick();

};

ProsHuds_ClientSelect.prototype.createField = function() {
  this._comField = [];
  for (var i = 0; i < this._maxIndex; i++) {
    this._comField[i] = new Sprite();
    this._comField[i].x = 640;
    this._comField[i].y = 720;
    this._comField[i].anchor.x = 0.5;
    this._comField[i].opacity = 0;
    this.addChild(this._comField[i]);
  }
  this._charField = [];
  for (var i = 0; i < this._charMaxIndex; i++) {
    this._charField[i] = new Sprite();
    this._charField[i].x = 640;
    this._charField[i].y = 360;
    this._charField[i].anchor.x = 0.5;
    this._charField[i].anchor.y = 0.5;
    this._charField[i].opacity = 0;
    this._charField[i].visible = false;
    this.addChild(this._charField[i]);
  }
  this._dField = new Sprite();
  this._dField.opacity = 0;
  this.addChild(this._dField);
};

ProsHuds_ClientSelect.prototype.createRightBack = function() {
  this._rightBack = new Sprite(this._layImg);
  this._rightBack.x = this._exOrg[0];
  this.addChild(this._rightBack);
  this._rightBack.setFrame(520,0,290,500);
};

ProsHuds_ClientSelect.prototype.createDialog = function() {
	this._dialogLayout = new Sprite(ImageManager.loadOther_Overworld('Message_1'));
	this._dialogLayout.anchor.x = 0.5;
	this._dialogLayout.x = Graphics.boxWidth / 2;
	this._dialogLayout.y = 537;
	this._dField.addChild(this._dialogLayout);

	this._dialogName = new Sprite(new Bitmap(200,40));
	this._dialogName.anchor.x = 0.5;
	this._dialogName.x = this._dialogLayout.x - 217;
	this._dialogName.y = this._dialogLayout.y + 13;
	this._dField.addChild(this._dialogName);
	this._dialogName.bitmap.fontSize = 24;
	this._dialogName.bitmap.drawText('Reika', 0,0,200,40,"center");

	this._dialogText = new Sprite(new Bitmap(600,40));
	this._dialogText.anchor.x = 0.5;
	this._dialogText.x = this._dialogLayout.x;
	this._dialogText.y = this._dialogLayout.y + 51;
	this._dialogText.bitmap.fontSize = 20;
	this._dField.addChild(this._dialogText);
  this.resetDialog(this._clientPool[this._index].comment);

};

// PHASE 1
ProsHuds_ClientSelect.prototype.createInactiveCommands = function() {
  this._inCom = [];
	for (var i = 0; i < this._maxIndex; i++) {
		this._inCom[i] = new Sprite(this._layImg);
    this._inCom[i].anchor.x = 0.5;
		this._comField[i].addChild(this._inCom[i]);

    this._inCom[i].setFrame(0,0,520,70);
    this._org[i] = 320 - (25 * this._maxIndex) + (50 * i);
    this._wait[i] = 4 * i;
  }
};

ProsHuds_ClientSelect.prototype.createActiveCommands = function() {
  this._acCom = [];
	for (var i = 0; i < this._maxIndex; i++) {
		this._acCom[i] = new Sprite(this._layImg);
    this._acCom[i].anchor.x = 0.5;
    this._acCom[i].opacity = 0;
		this._comField[i].addChild(this._acCom[i]);

    this._acCom[i].setFrame(0,70,520,70);
  }
};

ProsHuds_ClientSelect.prototype.createCursor = function() {
		this._cursor = new Sprite(this._cursorImg);
		this._cursor.x = this._inCom[0].x - 100;
    this._cursor.anchor.x = 0.5;
    this._cursor.anchor.y = 0.5;
    this._cursor.opacity = 0;
		this.addChild(this._cursor);
};

ProsHuds_ClientSelect.prototype.createGrad = function() {

  this._grad = [];
	for (var i = 0; i < this._maxIndex; i++) {
		this._grad[i] = new Sprite(this._layImg);
	  this._grad[i].y = this._inCom[i].y;
    this._grad[i].anchor.x = 0.5;
		this._comField[i].addChild(this._grad[i]);

    this._grad[i].setFrame(0,140,520,70);
    this._grad[i].mask = this._clientName[i];
	}
};

ProsHuds_ClientSelect.prototype.createClientName = function() {
  this._clientName = [];
  this._clientText = [];
	for (var i = 0; i < this._maxIndex; i++) {
		this._clientName[i] = new Sprite(new Bitmap(520,32));
    this._clientName[i].y = this._inCom[i].y + 16;
    this._clientName[i].anchor.x = 0.5;
		this._comField[i].addChild(this._clientName[i]);

    var text = this._clientPool[i].name;
    this._clientName[i].bitmap.fontSize = 20;
    this._clientName[i].bitmap.fontFace = 'FredokaSemi';
    this._clientName[i].bitmap.drawText(text, 0, 0, 520, 32, 'center');

    var w = this._clientName[i].bitmap.measureTextWidth(text);
    this._clientText[i] = Math.floor(w);

	}
};

ProsHuds_ClientSelect.prototype.createClientPref = function() {
  this._clientPref = [];
	for (var i = 0; i < this._maxIndex; i++) {
		this._clientPref[i] = new Sprite(this._prefImg);
	  this._clientPref[i].x = 300;
    this._clientPref[i].y = this._inCom[i].y - 30;
    this._clientPref[i].anchor.x = 0.5;
    this._clientPref[i].visible = false;
		this._comField[i].addChild(this._clientPref[i]);
    this.updatePref(i);
	}
};

// PHASE 2
ProsHuds_ClientSelect.prototype.createChar = function() {

  this._charCom = [];
  this._charFace = [];
  this._charOrg = [];
	for (var i = 0; i < this._charMaxIndex; i++) {

    // Layout
		this._charCom[i] = new Sprite(this._layImg);
    this._charCom[i].anchor.x = 0.5;
    this._charCom[i].anchor.y = 0.5;
		this._charField[i].addChild(this._charCom[i]);
    this._charCom[i].setFrame(0,280,220,220);

    // Faces
    this._charFace[i] = new Sprite(this._layImg);
    this._charFace[i].anchor.x = 0.5;
    this._charFace[i].anchor.y = 0.5;
    this._charFace[i].y -= 29;
    this._charField[i].addChild(this._charFace[i]);

    var n = 110 * (this._aID[i] - 1);
    this._charFace[i].setFrame(810,n,110,110);

    this._charOrg[i] = 760 - (120 * this._charMaxIndex) + (240 * i);

  }
};

ProsHuds_ClientSelect.prototype.createCharMeter = function() {

  this._charMeter = [[],[]];
	for (var i = 0; i < this._charMaxIndex; i++) {
    var data = [this._actor[i].stam, this._actor[i].maxstam];
    var text = Math.floor(data[0] / data[1] * 100);
    this._charMeter[i][0] = new ProsHuds_ClsMeter(this._actor[i], this._layImg, 320, data, text);
    this._charMeter[i][0].x -= 76;
    this._charMeter[i][0].y = this._charFace[i].y + 78;
    this._charField[i].addChild(this._charMeter[i][0]);

    var data = [this._actor[i].pregnancy, 1000];
    var text = Math.floor(data[0] / data[1] * 100);
    this._charMeter[i][1] = new ProsHuds_ClsMeter(this._actor[i], this._layImg, 326, data, text);
    this._charMeter[i][1].x -= 76;
    this._charMeter[i][1].y = this._charFace[i].y + 108;
    this._charField[i].addChild(this._charMeter[i][1]);
  }
};

ProsHuds_ClientSelect.prototype.createTopPick = function() {
  this._topPick = [];
  for (var i = 0; i < this._charMaxIndex; i++) {
    this._topPick[i] = new Sprite(this._layImg);
    this._topPick[i].y -= 115;
    this._topPick[i].anchor.x = 0.5;
    this._topPick[i].visible = false;
    this._charField[i].addChild(this._topPick[i]);
    this._topPick[i].setFrame(220, 280, 140, 40);
  }
};

//==============================
// * Set
//==============================

ProsHuds_ClientSelect.prototype.resetCursor = function(i) {
  var x = 620 - (this._clientText[i]/2);
	var y = this._comField[i].y + 17;
  this._cursor.x = x;
  this._cursor.y = y;
  this._cursor.opacity = 0;
};

ProsHuds_ClientSelect.prototype.updatePref = function(i) {
  var data = this._clientPool[i].setfavor;
  if (data !== 0) {
    var h = (data-1) * 70;
    this._clientPref[i].setFrame(0, h, 220, 70);
    this._clientPref[i].visible = true;
  }
};

ProsHuds_ClientSelect.prototype.resetDialog = function(data) {
	this.selectDialog(Micoomer.receptionistDialogSet[data]);
};

ProsHuds_ClientSelect.prototype.selectDialog = function(set) {
	if (!set) {return};
  this._dialogText.opacity = 0;
	this._dialogText.bitmap.clear();
	this._dialogText.bitmap.drawText(set, 0,0,600,40,"center");
};

ProsHuds_ClientSelect.prototype.resetHUD = function(set) {
	switch (set) {
    case 1:
      for (var i = 0; i < this._comField.length; i++) {
        this._comField[i].visible = true;
      }
      for (var i = 0; i < this._charField.length; i++) {
        this._charField[i].visible = false;
      }
      this._cursor.visible = true;
      break;

    case 2:
      for (var i = 0; i < this._comField.length; i++) {
        this._comField[i].visible = false;
      }
      this._cursor.visible = false;
      for (var i = 0; i < this._charField.length; i++) {
        this._charField[i].visible = true;
        this._charField[i].x = 640;
        this._charField[i].opacity = 0;
      }
      this._duration[1] = 40;
      this.resetTopPick();
      break;
  }
};

ProsHuds_ClientSelect.prototype.resetTopPick = function() {
  var a = this._clientPool[this._index].setfavor - 1;
  for (var i = 0; i < this._topPick.length; i++) {
    this._topPick[i].visible = false;
  }
  if (this._topPick[a]) this._topPick[a].visible = true;
};

//==============================
// * Update Timeline
//==============================

ProsHuds_ClientSelect.prototype.sprite_move_to = function(value,real_value, speed) {
	if (value === real_value) {return value};
	var dnspeed = 1 + (Math.abs(value - real_value) / speed);
	if (value > real_value) {value -= dnspeed;
	    if (value < real_value) {value = real_value};}
    else if (value < real_value) {value  += dnspeed;
    	if (value  > real_value) {value  = real_value};
    };
	return Math.floor(value);
};

ProsHuds_ClientSelect.prototype.selectAni = function(phase) {
  switch (phase) {
    case 0:
      if (this._duration[0] > 0) {
        for (var i = 0; i < this._maxIndex; i++) {
          this.updateAni(this._comField[i], i);
        }
        this._rightBack.x = this.sprite_move_to(this._rightBack.x, this._exOrg[1], 16);
        this._duration[0]--;
        if (this._duration[0] == 0) {
          this.resetCursor(0);
          this._phase = 1;
        }
      }
      break;

    case 2:
      if (this._duration[1] > 0) {
        for (var i = 0; i < this._charMaxIndex; i++) {
          this._charField[i].x = this.sprite_move_to(this._charField[i].x, this._charOrg[i], 30);
          this._charField[i].opacity += 10;
        }
        this._duration[1]--;
        if (this._duration[1] == 0) {
          this._phase = 3;
        }
      }
      break;
  }

};

ProsHuds_ClientSelect.prototype.updateAni = function(sprite, i) {

  if (this._wait[i] == 0) {
    var speed = this._speed[0];
    var target = this._org[i];
    sprite.y = this.sprite_move_to(sprite.y, target, speed);
    sprite.opacity += this._speed[1];
  }
  if (this._wait[i] > 0) {this._wait[i]--};
};

ProsHuds_ClientSelect.prototype.updateCommand = function() {
	for (var i = 0; i < this._maxIndex; i++) {
    if (this.isComEnabled(i)) {
		    this._acCom[i].opacity += 50;
        this._clientPref[i].opacity += 50;
        this._grad[i].setFrame(0,210,520,70);
    } else {
      this._acCom[i].opacity -= 50;
      this._clientPref[i].opacity = this.sprite_move_to(this._clientPref[i].opacity, 150, 12);
      this._grad[i].setFrame(0,140,520,70);
    }
	}
};

ProsHuds_ClientSelect.prototype.updateCharCom = function() {
	for (var i = 0; i < this._charMaxIndex; i++) {
    if (this.isCharComEnabled(i)) {
		   this._charField[i].opacity += 50;
    } else {
      this._charField[i].opacity = 150;
    }
	}
};

ProsHuds_ClientSelect.prototype.updateCursor = function() {
  var ind = this._index;
	var y = this._comField[ind].y + 32;
  this._cursor.y = this.sprite_move_to(this._cursor.y, y, 30);
  this._cursor.opacity = this.sprite_move_to(this._cursor.opacity, 255, 15);
};

ProsHuds_ClientSelect.prototype.updateDialogOpc = function() {
  this._dField.opacity += 9;
	this._dialogText.opacity += 12;
};

//==============================
// * Boolean
//==============================
ProsHuds_ClientSelect.prototype.isComEnabled = function(index) {
	  if (index != this._index) {return false};
	  return true;
};

ProsHuds_ClientSelect.prototype.isCharComEnabled = function(index) {
	  if (index != this._charIndex) {return false};
	  return true;
};

ProsHuds_ClientSelect.prototype.readyInput = function() {
  if (this._phase == 1 || this._phase == 3) {return true};
  if (this.visible) {return true};
  return false;
};

//==============================
// * Input
//==============================
ProsHuds_ClientSelect.prototype.updateInput = function() {
  switch (this._phase) {
    case 1:
    if (Input.isRepeated('down')) {
			  this.processDown();
		} else if (Input.isRepeated('up')) {
				this.processUp();
		}
    break;

    case 3:
    if (Input.isRepeated('right')) {
			  this.processRight();
		} else if (Input.isRepeated('left')) {
				this.processLeft();
		}
    break;
  }

	if (Input.isTriggered('ok')) {
    this.okProcess(this._phase);
	} else if (Input.isTriggered('cancel')) {
    this.cancelProcess(this._phase);
	}
};

ProsHuds_ClientSelect.prototype.processDown = function() {
  if (this._index < this._lastIndex) {
    this._index += 1;
  } else if (this._index == this._lastIndex) {
    this._index = 0;
  }
  SoundManager.playCursor();
  this.resetCursor(this._index);
  this.resetDialog(this._clientPool[this._index].comment);
};

ProsHuds_ClientSelect.prototype.processUp = function() {
  if (this._index > 0) {
    this._index -= 1;
  } else if (this._index == 0) {
    this._index = this._lastIndex;
  }
  SoundManager.playCursor();
  this.resetCursor(this._index);
  this.resetDialog(this._clientPool[this._index].comment);
};

ProsHuds_ClientSelect.prototype.processRight = function() {
  if (this._charIndex < this._charLastIndex) {
    this._charIndex += 1;
  } else if (this._charIndex == this._charLastIndex) {
    this._charIndex = 0;
  }
  SoundManager.playCursor();
};

ProsHuds_ClientSelect.prototype.processLeft = function() {
  if (this._charIndex > 0) {
    this._charIndex -= 1;
  } else if (this._charIndex == 0) {
    this._charIndex = this._charLastIndex;
  }
  SoundManager.playCursor();
};

ProsHuds_ClientSelect.prototype.okProcess = function(phase) {
  SoundManager.playOk();
  switch (phase) {
    case 1:
      this.selectClient(this._index);
      this.resetHUD(2);
      this._phase = 2;
      this.selectDialog("Who want to engage in this session?");
      break;

    case 3:
      this.selectCharacter(this._charIndex);
      break;
  }
};

ProsHuds_ClientSelect.prototype.cancelProcess = function(phase) {
  SoundManager.playCancel();
  switch (phase) {
    case 1:
      this.terminateHUD();
      break;
    case 3:
      this.resetHUD(1);
      this.resetCursor(this._index);
      this.resetDialog(this._clientPool[this._index].comment);
      this._phase = 1;
      break;
  }

};

ProsHuds_ClientSelect.prototype.selectClient = function(index) {
  var a = this._clientPool[index];
  $gameTemp._brClient = a;
  $gameTemp._brClientID = index;
  $gameTemp._brClientName = a.nick;
};

ProsHuds_ClientSelect.prototype.selectCharacter = function(index) {
  var a = this._aID[index];
  $gameTemp._brChar_id = a;
  if (this._topPick[index].visible) {$gameTemp._brClientMatch = true};
  this.terminateHUD();
  $gameTemp.reserveCommonEvent(38);
};

ProsHuds_ClientSelect.prototype.fatigueCheck = function(actor) {
  var fat = (actor.stam / actor.maxstam);
  if (fat < 0.5) {
    return false
  } else {
    return true
  }
};

ProsHuds_ClientSelect.prototype.terminateHUD = function() {
  SceneManager._scene.terminateClientSelect();
  $gameTemp.reserveCommonEvent(25);
};

//==============================
// * Check
//==============================
ProsHuds_ClientSelect.prototype.update = function() {
  this.selectAni(this._phase);
  switch (this._phase) {
    case 1:
      this.updateCommand();
      this.updateCursor();
      this.updateDialogOpc();
      break;
    case 2:
      this.updateDialogOpc();
      break;
    case 3:
      this.updateCharCom();
      break;
  }

  if (this.readyInput()) {
    this.updateInput();
  }
};


//==============================
// * ProsHuds_ClientSelectMeter
//==============================

function ProsHuds_ClsMeter() {
    this.initialize.apply(this, arguments);
};

ProsHuds_ClsMeter.prototype = Object.create(Sprite.prototype);
ProsHuds_ClsMeter.prototype.constructor = ProsHuds_ClsMeter;

ProsHuds_ClsMeter.prototype.initialize = function(actor, img, h, data, text) {
    Sprite.prototype.initialize.call(this);

  this._actor = actor;
  this._blt = img;
  this._h = h;
  this._data = data;
  this._text = text;

  this.createMeter();
  this.createNumber();
};

ProsHuds_ClsMeter.prototype.createNumber = function() {
  this._number = new Sprite(new Bitmap(200,32));
  this._number.x = this._meter.x - 38;
  this._number.y = this._meter.y - 25;
  this._number.bitmap.fontSize = 14;
  this._number.bitmap.outlineWidth = 4;
  this._number.bitmap.outlineColor = '#5d4e6a';
  this.addChild(this._number);
  this._number.bitmap.drawText(this._text + '%',-10,0,200,32, 'right');

};

ProsHuds_ClsMeter.prototype.createMeter = function() {
  this._meter = new Sprite(this._blt);
  this.addChild(this._meter);
  this._meter.setFrame(220,this._h,154,6);
  this.updateMeter(this._meter, this._data);
};

ProsHuds_ClsMeter.prototype.updateMeter = function(sprite, data) {
  var w = Math.floor(154 * (data[0] / data[1]));
  sprite.setFrame(220,this._h, w, 6);
};




//==============================
// * BIRTH SELECTION
//==============================

function BirthSelect() {
    this.initialize.apply(this, arguments);
};

BirthSelect.prototype = Object.create(Sprite.prototype);
BirthSelect.prototype.constructor = BirthSelect;

BirthSelect.prototype.initialize = function() {
    Sprite.prototype.initialize.call(this);

  $gameTemp.reserveCommonEvent(24);

  this._pool = $gameTemp._birthSceneSelect;
  this._pool.push("None");
	this._index = 0;
	this._maxIndex = this._pool.length;
  this._lastIndex = this._maxIndex - 1;
  this._phase = 0;

  this._duration = [];
  this._duration = 31 + 5 * this._maxIndex;
  this._speed = [12, 255/25];
  this._org = [];
  this._wait = [];

	// Create Sprites
  this.loadBitmaps();
	this.createSprites();
};

BirthSelect.prototype.loadBitmaps = function() {
  this._layImg = ImageManager.loadProsHud('UI_ProsClientSelect');
};

BirthSelect.prototype.createSprites = function() {
  this.createField();

  // Phase 1
  this.createInactiveCommands();
	this.createActiveCommands();
  this.createClientName();
  this.createGrad();
  this.createDialog();
};

BirthSelect.prototype.createField = function() {
  this._comField = [];
  for (var i = 0; i < this._maxIndex; i++) {
    this._comField[i] = new Sprite();
    this._comField[i].x = 640;
    this._comField[i].y = 720;
    this._comField[i].anchor.x = 0.5;
    this._comField[i].opacity = 0;
    this.addChild(this._comField[i]);
  }
};

BirthSelect.prototype.createInactiveCommands = function() {
  this._inCom = [];
	for (var i = 0; i < this._maxIndex; i++) {
		this._inCom[i] = new Sprite(this._layImg);
    this._inCom[i].anchor.x = 0.5;
		this._comField[i].addChild(this._inCom[i]);

    this._inCom[i].setFrame(0,0,520,70);
    this._org[i] = 320 - (25 * this._maxIndex) + (50 * i);
    this._wait[i] = 4 * i;
  }
};

BirthSelect.prototype.createActiveCommands = function() {
  this._acCom = [];
	for (var i = 0; i < this._maxIndex; i++) {
		this._acCom[i] = new Sprite(this._layImg);
    this._acCom[i].anchor.x = 0.5;
    this._acCom[i].opacity = 0;
		this._comField[i].addChild(this._acCom[i]);

    this._acCom[i].setFrame(0,70,520,70);
  }
};

BirthSelect.prototype.createClientName = function() {
  this._clientName = [];
	for (var i = 0; i < this._maxIndex; i++) {
		this._clientName[i] = new Sprite(new Bitmap(520,32));
    this._clientName[i].y = this._inCom[i].y + 16;
    this._clientName[i].anchor.x = 0.5;
		this._comField[i].addChild(this._clientName[i]);

    var text = i == this._maxIndex - 1 ? "None" : this._pool[i]._name;
    this._clientName[i].bitmap.fontSize = 20;
    this._clientName[i].bitmap.fontFace = 'FredokaSemi';
    this._clientName[i].bitmap.drawText(text, 0, 0, 520, 32, 'center');

	}
};

BirthSelect.prototype.createGrad = function() {

  this._grad = [];
	for (var i = 0; i < this._maxIndex; i++) {
		this._grad[i] = new Sprite(this._layImg);
	  this._grad[i].y = this._inCom[i].y;
    this._grad[i].anchor.x = 0.5;
		this._comField[i].addChild(this._grad[i]);

    this._grad[i].setFrame(0,140,520,70);
    this._grad[i].mask = this._clientName[i];
	}
};

BirthSelect.prototype.createDialog = function() {
	this._dialogLayout = new Sprite(ImageManager.loadOther_Overworld('Message_0'));
	this._dialogLayout.anchor.x = 0.5;
	this._dialogLayout.x = Graphics.boxWidth / 2;
	this._dialogLayout.y = 537;
	this.addChild(this._dialogLayout);

	this._dialogText = new Sprite(new Bitmap(600,40));
	this._dialogText.anchor.x = 0.5;
	this._dialogText.x = this._dialogLayout.x;
	this._dialogText.y = this._dialogLayout.y + 51;
	this._dialogText.bitmap.fontSize = 20;
  var text = "Which birth scene do you want to see?";
  this._dialogText.bitmap.drawText(text,0,0,600,40,"center");
	this.addChild(this._dialogText);

};

//==============================
// * Update Timeline
//==============================

BirthSelect.prototype.selectAni = function() {
    if (this._duration > 0) {
      for (var i = 0; i < this._maxIndex; i++) {
        this.updateAni(this._comField[i], i);
      }
      this._duration--;
      if (this._duration == 0) {
        this._phase = 1;
      }
    }
};

BirthSelect.prototype.updateAni = function(sprite, i) {

  if (this._wait[i] == 0) {
    var speed = this._speed[0];
    var target = this._org[i];
    sprite.y = globMoveTo(sprite.y, target, speed);
    sprite.opacity += this._speed[1];
  }
  if (this._wait[i] > 0) {this._wait[i]--};
};

BirthSelect.prototype.updateCommand = function() {
	for (var i = 0; i < this._maxIndex; i++) {
    if (this.isComEnabled(i)) {
		    this._acCom[i].opacity += 50;
        this._grad[i].setFrame(0,210,520,70);
    } else {
      this._acCom[i].opacity -= 50;
      this._grad[i].setFrame(0,140,520,70);
    }
	}
};

//==============================
// * Boolean
//==============================
BirthSelect.prototype.isComEnabled = function(index) {
	  if (index != this._index) {return false};
	  return true;
};

BirthSelect.prototype.readyInput = function() {
  if (!this.visible) return false;
  if (this._phase !== 1) return false;
  return true;
};

//==============================
// * Input
//==============================
BirthSelect.prototype.updateInput = function() {
  if (Input.isRepeated('down')) {
		this.processDown();
	} else if (Input.isRepeated('up')) {
		this.processUp();
	}

	if (Input.isTriggered('ok')) {
    this.okProcess();
	}
};

BirthSelect.prototype.processDown = function() {
  if (this._index < this._lastIndex) {
    this._index += 1;
  } else if (this._index == this._lastIndex) {
    this._index = 0;
  }
  SoundManager.playCursor();
};

BirthSelect.prototype.processUp = function() {
  if (this._index > 0) {
    this._index -= 1;
  } else if (this._index == 0) {
    this._index = this._lastIndex;
  }
  SoundManager.playCursor();
};

BirthSelect.prototype.okProcess = function() {
  SoundManager.playOk();
  if (this._index == this._lastIndex) {
    this.terminateHUD();
  } else {
    this.visible = false;
    $gameTemp._birthSceneSelected.push(this._pool[this._index]);
    if ($gameTemp._birthSceneSelected.length == 1) {
      $gameSystem.saveBgm();
      $gameScreen.showPicture(10,"church",0,0,0,100,100,255,0);
      $gameScreen.showPicture(11,"Black",0,0,0,100,100,100,0);
    };
    if ($gameSwitches.value(505)) {
      $gameTemp.reserveCommonEvent(Micoomer.birthCE[this._pool[this._index]._actorId]);
    } else {
      $gameTemp.reserveCommonEvent(50);
    }
    this._pool.splice(this._index,1);
  }
};

BirthSelect.prototype.updateIndex = function() {
  this.visible = true;

	this._index = 0;
	this._maxIndex = this._pool.length;
  this._lastIndex = this._maxIndex - 1;
  this._phase = 0;

  this._duration = [];
  this._duration = 31 + 5 * this._maxIndex;
  this._speed = [12, 255/25];
  this._org = [];
  this._wait = [];

  for (var i = 0; i < this._comField.length; i++) {
    this.removeChild(this._comField[i]);
  }
  this.createSprites();
};

BirthSelect.prototype.endingSession = function() {
  if (this._pool.length == 1) {
    SceneManager._scene.endingBirthSelect();
  } else {
    this.updateIndex();
  }
};

BirthSelect.prototype.terminateHUD = function() {
  SceneManager._scene.terminateBirthSelect();
  $gameTemp.reserveCommonEvent(49);
};

//==============================
// * Check
//==============================
BirthSelect.prototype.update = function() {
  this.selectAni();
  switch (this._phase) {
    case 1:
      this.updateCommand();
      break;
  }
  if (this.readyInput()) this.updateInput();
};
