//=============================================================================
// MCM_BustExtension.js
//=============================================================================

/*:
 * @plugindesc
 * @author micoomer
 *
 */

//=============================================================================
// ** PLUGIN PARAMETERS
//=============================================================================
　　var Micoomer = Micoomer || {};

//=============================
// ** Image Manager
//=============================
ImageManager.loadBust = function(filename) {
    return this.loadBitmap('img/sprites/bust/', filename, 0, true);
};

ImageManager.loadMSprite = function(path, filename) {
    return this.loadBitmap('img/sprites/menu/' + path, filename, 0, true);
};

ImageManager.loadMSprite2 = function(filename) {
    return this.loadBitmap('img/sprites/bust/', filename, 0, true);
};

//==============================
// * PluginCommand
//==============================
var _mcm_bust_pluginCommand = Game_Interpreter.prototype.pluginCommand
Game_Interpreter.prototype.pluginCommand = function(command, args) {
	_mcm_bust_pluginCommand.call(this,command, args)

	if (command === "loadBust") {
		var n = args[0];
		var id = args[1];
		this.loadBust(n, id);
    }
	else if (command === "bustActive") {
		var d = args[0];
		this.activeBust(d);
	}
	else if (command === "bustHide") {
		this.hideBust();
	}
};

Game_Interpreter.prototype.loadBust = function(n, id) {
		var id2 = 0; // Expression ID
		var id3 = 0; // Body ID
		var actorId = 0;
		var exId = 0;
		var type = 0;
		var baseX = [];
		var baseY = [];

		// Coor
		baseX[0] = 1100;
		baseY[0] = 730;
		var targetX = -40;
		var targetY = -10;

		if (id == 1) {id2 = 1; id3 = 6};
		if (id == 2) {id2 = 2; id3 = 7};
		if (id == 3) {id2 = 3; id3 = 8};
		if (id == 4) {id2 = 4; id3 = 9};
		if (id == 5) {id2 = 5; id3 = 10};

		if (n === "Marie") {actorId = 1};
		if (n === "Elucia") {actorId = 2};
		if (n === "Ran") {actorId = 3};
		if (n === "Lavia") {type = 1; exId = 1};

		if (actorId !== 0) {
			var actor_belly = $gameActors.actor(actorId).bellysize;
			var actor_milk = $gameActors.actor(actorId).milksize;
			baseX[1] = baseX[0] + Micoomer.actorBustPos[actorId][0];
			baseY[1] = baseY[0] + Micoomer.actorBustPos[actorId][1];
		} else if (exId !== 0) {
			baseX[1] = baseX[0] + Micoomer.exBustPos[exId][0];
			baseY[1] = baseY[0] + Micoomer.exBustPos[exId][1];
		}

		$gameTemp._bustTargetX[id][id3] = baseX[0] + targetX;
		$gameTemp._bustTargetY[id][id3] = baseY[0] + targetY;
		$gameTemp._bustTargetX[id][id2] = baseX[1] + targetX;
		$gameTemp._bustTargetY[id][id2] = baseY[1] + targetY;

		$gameTemp._bustHomeX[id][id3] = baseX[0];
		$gameTemp._bustHomeY[id][id3] = baseY[0];
		$gameTemp._bustHomeX[id][id2] = baseX[1];
		$gameTemp._bustHomeY[id][id2] = baseY[1];

		$bust(id2).loadBitmap('face', n + 'EXP[Exp10x5]');
		if (type == 0) {
			if (actor_milk > 1) {
				$bust(id3).loadBitmap('face', n + '_' + actor_belly + '_' + actor_milk);
			} else {
				$bust(id3).loadBitmap('face', n + '_' + actor_belly + '_0');
			}
		} else if (type == 1) {
			$bust(id3).loadBitmap('face', n);
		}

		$gameTemp._bustIndex[id] = [id2, id3];
		$bust(id2).opacityTo(0);
		$bust(id3).opacityTo(0);
		if (baseX[1]) {$bust(id2).moveTo(baseX[1], baseY[1], 0)};
		$bust(id3).moveTo(baseX[0], baseY[0], 0);
};

Game_Interpreter.prototype.activeBust = function(d) {
	if ($gameTemp._bustTemp) {
		var f = $gameTemp._bustTemp;
		$gameTemp._bustIndex[f].forEach(function(ii) { // 1 & 6
			$bust(ii).fadeOut();
			$bust(ii).moveTo($gameTemp._bustHomeX[f][ii], $gameTemp._bustHomeY[f][ii]);
		});
	}
	$gameTemp._bustIndex[d].forEach(function(i) {
		$bust(i).fadeIn();
		$bust(i).moveTo($gameTemp._bustTargetX[d][i], $gameTemp._bustTargetY[d][i]);
	});
	$gameTemp._bustTemp = d;
};

Game_Interpreter.prototype.hideBust = function() {
  if (!$gameTemp._bustTemp) return;
	var f = $gameTemp._bustTemp;
	$gameTemp._bustIndex[f].forEach(function(ii) {
		$bust(ii).fadeOut();
		$bust(ii).moveTo($gameTemp._bustHomeX[f][ii], $gameTemp._bustHomeY[f][ii]);
	});
};


//=============================================================================
// ** MenuSprite
//=============================================================================
function MSprite() {
    this.initialize.apply(this, arguments);
};

MSprite.prototype = Object.create(Sprite.prototype);
MSprite.prototype.constructor = MSprite;

//==============================
// * Initialize
//==============================
MSprite.prototype.initialize = function(id, type) {
    Sprite.prototype.initialize.call(this);
	this.replaceBust(id, type);
};

MSprite.prototype.replaceBust = function(id, type) {
	if (this._bust) {
		for (i = 0; i < this._bust.length; i++) {
			this.removeChild(this._bust[i]);
		}
	}
	this.id = id;
	this.actor = $gameActors.actor(id);
	this.type = type;
	this.maxPart = [];
	this.maxPart = [3, 5];
	this.partPath = [];
  this.faceId = 0;
	this.setAttribute();
	this.setPathing(this.type);
};

MSprite.prototype.setAttribute = function() {
	var darkNip = this.actor.isDarkNipple() ? true : false;
	var bellysize = this.actor.bellysize;
	var milksize = this.actor.milksize;
	var babies = this.actor.babies;
	var fetusphase = this.actor.fetusphase;
  var pubic = 0;
	switch (bellysize) {
		 case 0:
		 case 1:
		 case 2:
		 case 3:
			pubic = 1;
			break;
		 case 4:
			pubic = 2;
			break;
		 case 5:
			pubic = 3;
			break;
	};
  this.attr = [darkNip, bellysize, milksize, babies, fetusphase, pubic];
};

MSprite.prototype.setPathing = function(type) {
	var b = this.attr[1];
	var m = this.attr[2];
	var c = this.attr[3];
	var f = this.attr[4];
	var u = this.attr[5];
	if (type === 0) {
		var p = 'wd0/';
		if (m >= 2) {
			this.partPath[2] = ImageManager.loadMSprite(p, 'M' + this.id + '_' + b + '_' + m); // milk
		}
	} else {
		var p = 'wd1/';
		if (m >= 1) {
			this.partPath[2] = ImageManager.loadMSprite(p, 'M' + this.id + '_' + b + '_' + m); // milk
		}
		if (this.allowPubic()) {
			this.partPath[3] = ImageManager.loadMSprite(p, 'P' + this.id + '_' + u); // pubic
		};
		if (this.allowXray()) {
			this.partPath[4] = ImageManager.loadMSprite(p, 'X' + this.id + '_' + c + '_' + f); // Xray
		};
	};
	if (this.allowDarkNipple()) {
		this.partPath[0] = ImageManager.loadMSprite(p, this.id + 'D_' + b); // torso dark
	} else {
		this.partPath[0] = ImageManager.loadMSprite(p, this.id + '_' + b); // torso
	}
	this.partPath[1] = ImageManager.loadMSprite(p, 'F' + this.id); // face
  this._size = [this.partPath[1].width / 5, this.partPath[1].height / 3];

  // 0 = torso
  // 1 = face
  // 2 = milk
  // 3 = pubic
  // 4 = Xray

	this.createSprites();
};

MSprite.prototype.createSprites = function() {
	this._bust = [];
	for (i = 0; i < this.maxPart[this.type]; i++) {
		if (!this.partPath[i]) {continue};
		this._bust[i] = new Sprite();
		this._bust[i].bitmap = this.partPath[i];
		this.addChild(this._bust[i]);
	}
	if (this._bust[4]) {this._bust[4].visible = false};
  this._bust[1].x = $gameTemp._msprite_faceOrg[this.id][0];
  this._bust[1].y = $gameTemp._msprite_faceOrg[this.id][1];
  this.setFace(0);

};

MSprite.prototype.toggleXray = function() {
	if (this._bust[4]) {this._bust[4].visible = !this._bust[4].visible};
};

MSprite.prototype.allowDarkNipple = function() {
  if ($gameSwitches.value(502) && this.attr[0]) {return true}
  return false
};

MSprite.prototype.allowPubic = function() {
  if ($gameSwitches.value(503) && this.attr[5] > 0) {return true}
  return false
};

MSprite.prototype.allowXray = function() {
  if ($gameSwitches.value(501)) {return true}
  return false
};

MSprite.prototype.setFace = function(faceId) {
  var width = this._size[0];
  var height = this._size[1];
  var i = faceId;
  var h = Math.floor(i / 5) > 0 ? Math.floor(i / 5) * height : 0;
  var w = width * (i % 5);
  this._bust[1].setFrame(w,h,width,height);
};

MSprite.prototype.updateVisibility = function() {
  if (this.needFade()) {
    this.opacity -= 25;
  } else {
    this.opacity += 25;
  }
};

MSprite.prototype.needFade = function() {
  if ($gameTemp._mspriteHide) {return true}
  return false
};

MSprite.prototype.update = function() {
  this.updateVisibility();
};

//=============================================================================
// ** MenuSprite 2 for Main Menu
//=============================================================================
function MSprite2() {
    this.initialize.apply(this, arguments);
};

MSprite2.prototype = Object.create(Sprite.prototype);
MSprite2.prototype.constructor = MSprite2;

//==============================
// * Initialize
//==============================
MSprite2.prototype.initialize = function(id) {
    Sprite.prototype.initialize.call(this);
	this.replaceBust(id);
};

MSprite2.prototype.replaceBust = function(id) {
	if (this._bust) {
		for (i = 0; i < this._bust.length; i++) {
			this.removeChild(this._bust[i]);
		}
	}
	this.id = id;
	this.actor = $gameActors.actor(id);
	this.maxPart = 2;
	this.partPath = [];
	this.setAttribute();
	this.setPathing();
};

MSprite2.prototype.setAttribute = function() {
	this.name = '';
	this.darkNip = this.actor.isDarkNipple() ? true : false;
	this.bellysize = this.actor.bellysize;
	this.milksize = this.actor.milksize < 2 ? 0 : this.actor.milksize;
	switch (this.id) {
		case 1:
			this.name = 'Marie';
			break;
		case 2:
			this.name = 'Elucia';
			break;
		case 3:
			this.name = 'Ran';
			break;
	};
};

MSprite2.prototype.setPathing = function() {
	var b = this.bellysize;
	var m = this.milksize;
	if ($gameSwitches.value(502) && this.darkNip) {
		this.partPath[0] = ImageManager.loadMSprite2(this.name + 'D_' + b + '_' + m); // torso dark
	} else {
		this.partPath[0] = ImageManager.loadMSprite2(this.name + '_' + b + '_' + m); // torso
	}
	this.partPath[1] = ImageManager.loadMSprite2(this.name + 'EXP[Exp10x5]'); // face
	this.createSprites();
};

MSprite2.prototype.createSprites = function() {
	this._bust = [];
	for (i = 0; i < this.maxPart; i++) {
		if (!this.partPath[i]) {continue};
		this._bust[i] = new Sprite();
		this._bust[i].bitmap = this.partPath[i];
		this.addChild(this._bust[i]);
	}
	this.refreshFrame();
};

MSprite2.prototype.refreshFrame = function() {
  var w = this._bust[1].width / 10;
  var h = this._bust[1].height / 5;
	this._bust[1].x = Micoomer.actorMenuPos[this.id][0];
	this._bust[1].y = Micoomer.actorMenuPos[this.id][1];
	this._bust[1].setFrame(0, 0, w, h);
	this._bust[0].setFrame(Micoomer.actorMenuX[this.id], 0, 256, 720);
};

//=============================================================================
// ** Bust for battle
//=============================================================================

BattleManager.setBust = function (battler) {
  var n = battler.name();
  var id = battler.actorId();

  $gameTroop._interpreter.pluginCommand("loadBust", [n, id]);
  $gameTroop._interpreter.pluginCommand("bustActive", [id]);
  $bust(id).setExpression(0);

};

BattleManager.clearBust = function (data) {
  $gameTroop._interpreter.pluginCommand("bustHide",[]);
  $bust(data).setExpression(0);
};
