//=============================================================================
// MCM_CGSystem.js
//=============================================================================

/*:
 * @plugindesc
 * @author micoomer
 *
 */

//=============================================================================
// ** PLUGIN PARAMETERS
//=============================================================================

var $CGi 		= null;
$CGi = new CG_System();

//=============================
// ** Load Bust
//=============================

var CGfct = function(bmp) {
	$gameScreen.showPicture(bmp.id, bmp.name, 0, 0, 720, 100, 100, 255, 0);
};

ImageManager.loadCG = function(path, filename) {
    return this.loadBitmap(path, filename, 0, true);
};

//=============================
// ** CG_System
//=============================

function CG_System() {}

CG_System.prototype.initialize = function() {
	this._currentActiveCGid = null;
};

CG_System.prototype.preloadCG = function(n, id) {
	var bmp = ImageManager.loadCG(n);
	bmp.id = id;
	bmp.name = n;
	bmp.addLoadListener(CGfct);
};

//=============================
// ** CG other
//=============================

Micoomer.CGpluginCommand = Game_Interpreter.prototype.pluginCommand
Game_Interpreter.prototype.pluginCommand = function(command, args) {
	Micoomer.CGpluginCommand.call(this,command, args)

	if (command === "loadCG") {
		var c = args[0];
		var p = args[1];
		this.setCGPath(c, p);
  }

	var o = Number(args[0]);
	switch ($CGi._currentActiveCGid) {

		// Marie Birth Church
		case 101:
			switch (command) {
				case 'eyes':
					$CG101.changePart(112, 10, o);
					break;
				case 'eyebrow':
					$CG101.changePart(113, 9, o);
					break;
				case 'mouth':
					$CG101.changePart(111, 11, o);
					break;
				case 'head':
					$CG101.changePart(110, 12, o);
					break;
				case 'splurt':
					$CG101.changeSw(116, 0, o);
					break;
				case 'fw':
					$CG101.progress(1);
					break;
				case 'bw':
					$CG101.progress(-1);
					break;
			}
		break;

		// Marie Cowgirl
		case 102:
			switch (command) {
				case 'head':
					$CG102.changeParent(o);
					break;
				case 'body':
					$CG102.changePart(110, 14, o);
					break;
				case 'eyes':
					$CG102.changePart(111, 13, o);
					break;
				case 'eyebrow':
					$CG102.changePart(112, 12, o);
					break;
				case 'mouth':
					$CG102.changePart(113, 11, o);
					break;
				case 'blush':
					$CG102.changePart(114, 10, o);
					break;
				case 'movement':
					$CG102.changeSw(120, 0, o);
					$CG102.changeSw(121, 0, o);
					break;
				case 'steam':
					$CG102.changeSw(122, 1, o);
					break;
				case 'cum':
					$CG102.changePart(116, 8, o);
					break;
			}
		break;

		// Marie Doggy
		case 103:
			switch (command) {
				case 'hand':
					$CG103.changeHand();
					break;
				case 'head':
					$CG103.changeParent(o);
					break;
				case 'eyes':
					$CG103.changePart(111, 13, o);
					break;
				case 'eyebrow':
					$CG103.changePart(112, 12, o);
					break;
				case 'mouth':
					$CG103.changePart(113, 11, o);
					break;
				case 'blush':
					$CG103.changePart(114, 10, o);
					break;
				case 'movement':
					$CG103.changeSw(118, 0, o);
					$CG103.changeSw(119, 1, o);
					break;
				case 'steam':
					$CG103.changeSw(121, 2, o);
					break;
			}
		break;

		// Elucia Missionary
		case 201:
			switch (command) {
				case 'body':
					$CG201.changePart(110, 17, o);
					break;
				case 'blush':
					$CG201.changePart(111, 16, o);
					break;
				case 'eyes':
					$CG201.changePart(112, 15, o);
					break;
				case 'eyebrow':
					$CG201.changePart(113, 14, o);
					break;
				case 'mouth':
					$CG201.changePart(114, 13, o);
					break;
				case 'lower':
					$CG201.changePart(117, 10, o);
					break;
				case 'cum':
					$CG201.changePart(124, 3, o);
					break;
				case 'movement':
					$CG201.changeSw(120, 0, o);
					$CG201.changeSw(121, 0, o);
					break;
				case 'man':
					$CG201.changeSw(125, 1, o);
					break;
				case 'steam':
					$CG201.changeSw(126, 2, o);
					break;
			}
		break;

		// Elucia BirthChurch
		case 202:
			switch (command) {
				case 'head':
					$CG202.changePart(111, 13, o);
					break;
				case 'body':
					$CG202.changePart(110, 14, o);
					break;
				case 'eyes':
					$CG202.changePart(114, 10, o);
					break;
				case 'eyebrow':
					$CG202.changePart(115, 9, o);
					break;
				case 'mouth':
					$CG202.changePart(113, 11, o);
					break;
				case 'blush':
					$CG202.changePart(112, 12, o);
					break;
				case 'splurt':
					$CG202.changeSw(118, 0, o);
					break;
				case 'fw':
					$CG202.progress(1);
					break;
				case 'bw':
					$CG202.progress(-1);
					break;
			}
		break;

	}

};

Game_Interpreter.prototype.setCGPath = function(c, p) {
	var path = 'CG/';
	path += c + '/';
	path += p + '/';
	$gameTemp._CGpath = path;
	this.identifyCG(c, p);
};

Game_Interpreter.prototype.identifyCG = function(c, p) {
	switch (c) {
		case "Marie":
			var id = 1;
			break;

		case "Elucia":
			var id = 2;
			break;

		case "Ran":
			var id = 3;
			break;
	}

	$gameTemp._CGid = id;
	var actor = $gameActors.actor($gameTemp._CGid);

	switch (id) {
		case 1:
			switch (p) {
				case "Cowgirl":
					$CG102.setup(actor, $gameTemp._CGpath);
					break;
				case "Doggy":
					$CG103.setup(actor, $gameTemp._CGpath);
					break;
				case "BirthChurch":
					$CG101.setup(actor, $gameTemp._CGpath);
					break;
			}
		break;

		case 2:
			switch (p) {
				case "Missionary":
					$CG201.setup(actor, $gameTemp._CGpath);
					break;

				case "BirthChurch":
					$CG202.setup(actor, $gameTemp._CGpath);
					break;
			}
		break;
	}
};
