//=============================================================================
// MCM_GabQuote.js
//=============================================================================

/*:
 * @plugindesc
 * @author micoomer
 *
 */

//==============================
// * GAMETEMP INIT
//==============================
Micoomer.TempInit = Game_Temp.prototype.initialize;
Game_Temp.prototype.initialize = function() {
	Micoomer.TempInit.call(this);

	// Bust Extension
	this._maxBust = 5;
	this._bustTemp = 0;
	this._bustIndex = [];
	this._bustHomeX = [];
	this._bustHomeY = [];
	this._bustTargetX = [];
	this._bustTargetY = [];
	for (var i = 1; i < this._maxBust + 1; i++) {
		this._bustIndex[i] = [];
		this._bustHomeX[i] = [];
		this._bustHomeY[i] = [];
		this._bustTargetX[i] = [];
		this._bustTargetY[i] = [];
	}
	this._bustBattleExp = 0;
	this._bustHideName = ["Marie", "Elucia", "Ran", "Lavia"];

	// MSprite
	this._mspriteHide = false;
	this._msprite_faceOrg = [];
	this._msprite_faceOrg[1] = [549,215];
	this._msprite_faceOrg[2] = [549,215];
	this._msprite_faceOrg[3] = [520,222];

	// Scene status
	this._statusIndex = 0;

	// Brothel
	this._enterCG = false;
	this._quitCG = [];

	this._CGid = undefined;
	this._CGpath = undefined;
	this._CGce = undefined;

	this._svcPath = null;

	this._br_lockIndex = [];
	this._br_lockIndexTemp = [];
	this._br_svcAvailable = [];
	this._br_sexAvailable = [];

	this._brChar_id = 0;
	this._brChar_location = 0;
	this._brChar_name = '';
	this._brChar_dialog = '';
	this._brChar_status = '';

	this._brClient = null;
	this._brClientID = undefined;
	this._brClientMatch = false;
	this._brClientHide = false;
	this._brClientName = 'Juan';

	this._brTemp_Lewdness = 0;
	this._brTemp_Money = 0;

	this._brTally_Lewdness = 0;
	this._brTally_Money = 0;
	this._brTally_Popularity = 0;
	this._brTally_MoneyMultiplier = 1;

	this._brRes_var = [];

	this._milkBottleGain = 0;
	this._milkBottleWaste = 0;
	this._milkBottleEligible = null;
	this._birthMoneyGain = 0;
	this._birthRemnantGain = 0;
	this._birthSceneSelect = [];
	this._birthSceneSelected = [];

	// Overworld
	this._alertIteration = 0;
	this._quoteIteration = [];
	this._quoteAviID = [0,1,2,3,4];
	this._quoteData = [];

	this._fixedExp = null;
	this._battle_turnAmount = 0;

	// POPULARITY
	this._popStoreTemp = [0,0,0];
};

//=============================================================================
// ** Game System
//=============================================================================

Micoomer.SystemInit = Game_System.prototype.initialize;
Game_System.prototype.initialize = function() {
	Micoomer.SystemInit.call(this);

	this._finishedDemo = false;

	// Difficulty
	this._difficulty = null;

	// OW HUD
	this._debugId = 1;
	this._debugStatVisible = false;
	this._debugStat2Visible = false;
	this._apPanelVisible = false;
	this._objHudVisible = false;
	this._clientPanelVisible = false;
	this._shortcutVisible = false;
	this._objectiveText = "Berpetualang bersama si Marie.";

	// OW
	this._boiledPrawnTimer = 0;
	this._boiledPrawnBuff = false;

	// Travel
	this._travelLocation = [];
	this._travelLocation[0] = [false,false,false];
	this._travelLocation[1] = [false,false,false,false,false];

	// Activity Point
	this._partyAPCur = 0;
	this._partyAPMax = 0;

	// Popularity Level
	this._popLv = [0,0,0];
	this._popEXP = [0,0,0];
	this._popStoreTown = 0; // for Town
	this._popAllow = false;

	// Brothel client
	this._clientData = [];
	this._clientDataEx = [];

	this._clientData[0] = {
		name:'Merchant Kale',
		nick: 'Kale',
		svc: 600,
		sex: 1500,
		comment: 2,
		favor: [100,0,0,0],
		setfavor: 0,
		body: 'A'
	};
	this._clientData[1] = {
		name:'Smithing Master Hewg',
		nick: 'Hewg',
		svc: 513,
		sex: 1284,
		comment: 1,
		favor: [100,0,0,0],
		setfavor: 0,
		body: 'B'
	};
	this._clientData[2] = {
		name:'Thop',
		nick: 'Thop',
		svc: 840,
		sex: 2100,
		comment: 4,
		favor: [100,0,0,0],
		setfavor: 0,
		body: 'A'
	};
	this._clientData[3] = {
		name:'War Counselor Iji',
		nick: 'Iji',
		svc: 766,
		sex: 1915,
		comment: 3,
		favor: [100,0,0,0],
		setfavor: 0,
		body: 'A'
	};
	this._clientData[4] = {
		name:'Boc the Seamster',
		nick: 'Boc',
		svc: 791,
		sex: 1980,
		comment: 3,
		favor: [100,0,0,0],
		setfavor: 0,
		body: 'B'
	};
	this._clientData[5] = {
		name:'Corhyn',
		nick: 'Corhyn',
		svc: 711,
		sex: 1779,
		comment: 3,
		favor: [100,0,0,0],
		setfavor: 0,
		body: 'A'
	};
	this._clientData[6] = {
		name:'Knight Bernahl',
		nick: 'Bernahl',
		svc: 630,
		sex: 1575,
		comment: 2,
		favor: [100,0,0,0],
		setfavor: 0,
		body: 'A'
	};
	this._clientData[7] = {
		name:'Carian Servant',
		nick: 'Juan',
		svc: 562,
		sex: 1405,
		comment: 1,
		favor: [100,0,0,0],
		setfavor: 0,
		body: 'B'
	};

	this._clientData[8] = {
		name:'Fat Coin Purse',
		nick: 'Dog',
		svc: 840,
		sex: 2100,
		comment: 4,
		favor: [0,100,0,0],
		setfavor: undefined,
		body: 'B'
	};
	this._clientData[9] = {
		name:'Radagon of the Golden Order',
		nick: 'Marika',
		svc: 791,
		sex: 1980,
		comment: 3,
		favor: [0,30,70,0],
		setfavor: undefined,
		body: 'A'
	};
	this._clientData[10] = {
		name:'Morgott, the Omen',
		nick: 'Morgott',
		svc: 712,
		sex: 1779,
		comment: 3,
		favor: [0,40,40,0],
		setfavor: undefined,
		body: 'B'
	};
	this._clientData[11] = {
		name:'Malenia the Blade of Miquella',
		nick: 'Malenia',
		svc: 630,
		sex: 1575,
		comment: 2,
		favor: [0,40,60,0],
		setfavor: undefined,
		body: 'A'
	};
	this._clientData[12] = {
		name:'Mohg the Lord of Blood',
		nick: 'Mohg',
		svc: 562,
		sex: 1405,
		comment: 1,
		favor: [0,50,50,0],
		setfavor: undefined,
		body: 'B'
	};

	this._client_ready = [];
	this._client_pool = [];
//	this._client_poolEx = [];
	for (var i = 0; i < this._clientData.length; i++) {
		this._client_pool[i] = this._clientData[i];
	}
//	for (var i = 0; i < this._clientDataEx.length; i++) {
//		this._client_pool[i] = this._clientDataEx[i];
//	}
	this._client_nextTimer = undefined;

	this._clientMin = 0;
	this._clientMax = 0;

	this._availableGirls = ['Neutral', 'Marie', 'Elucia', 'Ran'];

	// Record
	this._rc_DayPassed = 0;
	this._rc_MoneyEarned = 0;
	this._rc_BRearned = 0;
	this._rc_BRspent = 0;
	this._rc_MilkProd = 0;
	this._rc_ArtiFound = 0;
	this._rc_ArtiEnhance = 0;
	this._rc_ProsSession = 0;
	this._rc_SexActivity = 0;
	this._rc_PregnantCount = 0;
	this._rc_BirthCount = 0;
	this._rc_LewdEXP = 0;
	this._rc_BattleWon = 0;
	this._rc_MonSlain = 0;
	this._rc_SupportUsed = 0;
};

//=============================================================================
// ** Global Function
//=============================================================================

var globMoveTo = function(value, real_value, speed) {
	speed = speed || 20;
	if (value == real_value) {return value};
	var dnspeed = 3 + (Math.abs(value - real_value) / speed);
	if (value > real_value) {value -= dnspeed;
	    if (value < real_value) {value = real_value};}
    else if (value < real_value) {value  += dnspeed;
    	if (value  > real_value) {value  = real_value};
    };
	return Math.floor(value);
};

//=============================================================================
// ** Scene Base
//=============================================================================

Scene_Base.prototype.createHudField0 = function() {
	this._hudField0 = new Sprite();
	this._hudField0.z = 1;
	this.addChild(this._hudField0);
};

Scene_Base.prototype.createHudField1 = function() {
	this._hudField1 = new Sprite();
	this._hudField1.z = 1;
	this.addChild(this._hudField1);
};

Scene_Base.prototype.createHudField3 = function() {
	this._hudField3 = new Sprite();
	this._hudField3.z = 1;
	this.addChild(this._hudField3);
};

//=============================================================================
// ** Scene Map
//=============================================================================

Micoomer.SceneMapUpdate = Scene_Map.prototype.update;
Scene_Map.prototype.update = function() {
	Micoomer.SceneMapUpdate.call(this);

	// Move Counter
	if (this.moveCounterCond()) {
		this.moveCounter();
	}

	// Client Timer
	if ($gameSystem._client_ready.length < $gameSystem._clientMax) {
		this.refreshClientTimer();
	}

	// Boiled Prawn Effect
	if ($gameSystem._boiledPrawnBuff) this.checkBoiledPrawn();

	if ($gameTemp._quoteData.length > 0) this.checkQuoteTermination();

}

Micoomer.MapCreateSpriteset = Scene_Map.prototype.createSpriteset;
Scene_Map.prototype.createSpriteset = function() {
	Micoomer.MapCreateSpriteset.call(this);
	if (!this._hudField0) {this.createHudField0()};
	if (!this._hudField1) {this.createHudField1()};
	if (!this._hudField3) {this.createHudField3()};

	// field 0
	if ($gameTemp.isPlaytest()) this.createDebugTooltip();

	// field 3
	this.createQuote();
	this.createOW_Hud();
	this.createMsgBox();

	this._evLog = [];
	this._evLogSpr = [];

};

Scene_Map.prototype.createDebugTooltip = function() {
	this._debugHud1 = new DebugStat();
	this._hudField1.addChild(this._debugHud1);
	this._debugHud2 = new DebugStat2();
	this._hudField1.addChild(this._debugHud2);
};

Scene_Map.prototype.createQuote = function() {
	this._quoteSpr = new QuoteMap();
	this._hudField3.addChild(this._quoteSpr);
};

Scene_Map.prototype.checkQuoteAvailability = function() {
	if ($gameTemp._quoteData.length > 0) {
		this._quoteSpr.resetQuote();
	}
}

Scene_Map.prototype.checkQuoteTermination = function() {
	if (SceneManager.isSceneChanging()) {
		$gameTemp._quoteData = [];
		this._quoteSpr.visible = false;
		this._quoteSpr._timer = undefined;
	  this._quoteSpr._active = false;
	  this._quoteSpr._data = null;
	}
}

Scene_Map.prototype.createEventLog = function(data) {
	var index = this._evLog.length;
	this._evLogSpr[index] = new EventLog(index, data);
	this._hudField3.addChild(this._evLogSpr[index]);
	this._evLog.push(this._evLogSpr[index]);
};

Scene_Map.prototype.removeEventLog = function(item) {
	this._hudField3.removeChild(item);
	this._evLog.splice(this._evLog.indexOf(item), 1);
};

Scene_Map.prototype.createPopMeter = function(data) {
	if (this._popMeter) {this.terminatePopMeter()};
	this._popMeter = new PopMeter(data);
	this._hudField3.addChild(this._popMeter);
};

Scene_Map.prototype.createOW_Hud = function() {
	this._obj_hud = new Objective();
	this._hudField3.addChild(this._obj_hud);
	this._ap_panel = new Panel_AP();
	this._hudField3.addChild(this._ap_panel);
	this._client_panel = new Panel_Client();
	this._hudField3.addChild(this._client_panel);
	this._shortcut_hud = new ShortcutLog();
	this._hudField3.addChild(this._shortcut_hud);
	this._enemyAlert = new EnemyAlert();
	this._hudField3.addChild(this._enemyAlert);
};

Scene_Map.prototype.createMsgBox = function() {
	this._msgBox = new MessageBox();
	this._hudField3.addChild(this._msgBox);
};

Scene_Map.prototype.createPagedTutor = function(data, max, id) {
	this._pagedTutor = new PagedTutor(data, max, id);
	this._hudField3.addChild(this._pagedTutor);
};

Scene_Map.prototype.createMSprite = function(a, b) {
	this._bust = new MSprite(a, b);
	this._bust.anchor.x = 0.5;
	this._bust.y = -130;
	this._bust.opacity = 0;
	this._hudField1.addChild(this._bust);
	$gameTemp._mspriteHide = false;
};

Scene_Map.prototype.terminatePopMeter = function() {
	this._hudField3.removeChild(this._popMeter);
};

Scene_Map.prototype.terminatePagedTutor = function() {
	this._hudField3.removeChild(this._pagedTutor);
};

Scene_Map.prototype.terminateMSprite = function() {
	this._hudField1.removeChild(this._bust);
};

//=============================================================================
// ** Scene Battle
//=============================================================================

Micoomer.SceneBattleUpdate = Scene_Battle.prototype.update;
Scene_Battle.prototype.update = function() {
	Micoomer.SceneBattleUpdate.call(this);

	if ($gameSystem._client_ready.length < $gameSystem._clientMax) {
		this.refreshClientTimer();
	}

}

Micoomer.BattleCreateSpriteset = Scene_Battle.prototype.createSpriteset;
Scene_Battle.prototype.createSpriteset = function() {
	Micoomer.BattleCreateSpriteset.call(this);
	if (!this._hudField3) {this.createHudField3()};

	// field 3
	if ($gameTemp.isPlaytest()) this.createDebugTooltip();
	this.createQuote();
	this.createMsgBox();

};

Scene_Battle.prototype.createQuote = function() {
	this._quote = [];
	for (var i = 0; i < 5; i++) {
		this._quote[i] = new BattleQuote();
		this._hudField3.addChild(this._quote[i]);
	}
};

Scene_Battle.prototype.createDebugTooltip = function() {
	this._debugHud = new DebugStat2();
	this._hudField3.addChild(this._debugHud);
};

Scene_Battle.prototype.createMsgBox = function() {
	this._msgBox = new MessageBox();
	this._hudField3.addChild(this._msgBox);
};
