//=============================================================================
// mi_Credits.js
//=============================================================================


/*:
 * @plugindesc
 * @author micoomer
 *
 */


function Scene_Credits() {
    this.initialize.apply(this, arguments);
}

Scene_Credits.prototype = Object.create(Scene_MenuBase.prototype);
Scene_Credits.prototype.constructor = Scene_Credits;

Scene_Credits.prototype.initialize = function() {
    Scene_MenuBase.prototype.initialize.call(this);
    this._speed = 1;
    this._phase = 0;
};

Scene_Credits.prototype.create_mbackground = function() {
};

Scene_Credits.prototype.create = function() {
  Scene_MenuBase.prototype.create.call(this);
  this.createBG();
  this.createSprites();
  if (Imported.MOG_MenuParticles && !this.skip_particles()) {this.create_mparticles()};
};

Scene_Credits.prototype.createBG = function() {
  this._bg = [];
	this._bg = new Sprite(ImageManager.loadPicture("White"));
	this.addChild(this._bg);
};

Scene_Credits.prototype.createSprites = function() {
  this._cr = [];
	this._cr[0] = new Sprite(ImageManager.loadSystem("Credit_1"));
	this._cr[0].y = Graphics.boxHeight - 360;
  this._cr[0].opacity = 0;
	this.addChild(this._cr[0]);
  this._cr[1] = new Sprite(ImageManager.loadSystem("Credit_2"));
  this._cr[1].opacity = 0;
  this.addChild(this._cr[1]);
};

Scene_Credits.prototype.updatePhase = function() {
  switch (this._phase) {
    case 0:
      this._cr[0].y -= this._speed;
      if (this._cr[0].y < -this._cr[0].height + 700) {
        this._cr[0].opacity -= 1;
      } else {
        this._cr[0].opacity += 1;
      }
      if (this._cr[0].opacity == 0) {this._phase = 1};
      break;

    case 1:
      this._cr[0].opacity -= 1;
      this._cr[1].opacity += 2;
      if (this._cr[1].opacity >= 255) {
        this._wait = 180;
        this._phase = 2;
      }
      break;

    case 2:
      if (this._wait > 0) {this._wait--};
      if (this._wait == 0) {this._cr[1].opacity -= 2};
      if (this._cr[1].opacity == 0) {this._bg.opacity -= 2};
      if (this._bg.opacity == 0) {SceneManager.pop()};
      break;
  }

}

Scene_Credits.prototype.update = function() {
  Scene_MenuBase.prototype.update.call(this);
  this.updatePhase();
};
