//=============================================================================
// MCM_PTB.js
//=============================================================================

/*:
 * @plugindesc
 * @author micoomer
 *
 */

//=============================================================================
// ** Battle Manager
//=============================================================================

BattleManager.PTB_start = function(type) {
	$gameTemp._battle_turnAmount = 0;
	this.PTB_freezeUnit(!type);
	Micoomer._ptb_phase = type; // 0 = actor 1 = enemy
	Micoomer._ptb_needUpdate = true;
	this.PTB_calc(type);
	var sw = type ? 16 : 17
	$gameTemp.reserveCommonEvent(sw);
	AudioManager.playSe({
		name: "awb",
		volume: 50,
		pitch: 100
	});
};


BattleManager.PTB_calc = function(type) { // 0 = actor 1 = enemy
	if (type == 0) {$gameTemp._battle_turnAmount++}
	var s = type ? $gameParty.aliveMembers() : $gameTroop.aliveMembers()
	var icon = 0;
	for (i = 0; i < s.length; i++) {
		var ac = s[i];
		icon += ac.ptb;
	}
	Micoomer._ptb_fullIcon = icon;
}

BattleManager.PTB_act = function(type) { // 0 = full, 1 = paralyze
	switch (type) {
	case 0:
		Micoomer._ptb_fullIcon--;
		break;

	case 1:
		if (Micoomer._ptb_fullIcon < 2) {
			Micoomer._ptb_fullIcon = 0;
		} else {
			Micoomer._ptb_fullIcon -= 2;
		}
		break;

	}
	this.PTB_phaseCheck(Micoomer._ptb_phase);
}

BattleManager.PTB_increase = function(amount) {
	Micoomer._ptb_fullIcon += amount;
}

BattleManager.PTB_phaseCheck = function(type) { // 0 = actor 1 = enemy
	var t = Micoomer._ptb_fullIcon;
	if (t == 0) {
		var a = !type ? $gameParty.aliveMembers() : $gameTroop.aliveMembers()
		if (a.length > 0) {
			this.PTB_unfreezeUnit(!type);
			this.PTB_freezeUnit(type);
			this.PTB_calc(!type);
			Micoomer._ptb_phase = !type; // 0 = actor 1 = enemy
			Micoomer._ptb_needUpdate = true;
			var sw = !type ? 402 : 404
			var w = !type ? 14 : 15
			$gameSwitches.setValue(sw, true);
			$gameTemp.reserveCommonEvent(w);
			AudioManager.playSe({
				name: "awb",
				volume: 50,
				pitch: 100
			});
		}
	}
}

BattleManager.PTB_freezeUnit = function(type) { // 0 = actor 1 = enemy
	var a = type ? $gameParty.members() : $gameTroop.members()
	for (var i = 0; i < a.length; i++) {
		a[i].addState(43);
	}
}

BattleManager.PTB_unfreezeUnit = function(type) { // 0 = actor 1 = enemy
	var a = type ? $gameParty.members() : $gameTroop.members()
	for (var i = 0; i < a.length; i++) {
		a[i].removeState(43);
	}
}

var _mcm_processEscape = BattleManager.processEscape;
BattleManager.processEscape = function() {

	// AP Consumption
	var consumption = $gameSystem._difficulty == "Safe" ? 4 : 7;
	$gameParty.recoverAP(-consumption);

	_mcm_processEscape.call(this);
};

BattleManager.showGab = function(face, text) {
	$gameTroop._interpreter.pluginCommand("showGab", [face, text]);
};
