//=============================================================================
// MCM_ExpTable.js
//=============================================================================

/*:
 * @plugindesc
 * @author micoomer
 *
 */

//=============================================================================
// ** Game_Interpreter
//=============================================================================

//==============================
// * PluginCommand
//==============================
Micoomer.pregSys_pluginCommand = Game_Interpreter.prototype.pluginCommand
Game_Interpreter.prototype.pluginCommand = function(command, args) {
	Micoomer.pregSys_pluginCommand.call(this,command, args)

	// Base Scene
	if (command === "sleep_evt") {
		this.sleepEVT();
  }

	else if (command === "post_evt") {
		this.postSleepEVT();
  }

	else if (command === "abortion") {
		this.abortion();
  }

	else if (command === "DialogVariantCheck") {
	  var a = Number(args[0]);
		this.dialog_conditionChecking(a);
	}

};

Game_Interpreter.prototype.sleepEVT = function() {
	$gameTemp._birthSceneSelect = [];

	// CHECK BIRTH & EJAC TALLY
	var party = $gameParty.size();
	var actor = $gameParty.members();
	for (var i = 0; i < party; i++) {

		// Birth Trigger
		var pg = actor[i].pregnancy;
		if (pg == 1000) {
				$gameTemp._birthSceneSelect.push(actor[i]);
		}

	}
	$gameTemp.reserveCommonEvent(48);
};

Game_Interpreter.prototype.postSleepEVT = function() {

	// Birth Trigger
//	for (var i = 0; i < $gameTemp._birthSceneSelected.length; i++) {
//		this.birthBaby($gameTemp._birthSceneSelected[i]);
//	}
	$gameTemp._birthSceneSelected = [];

	// CHECK BIRTH & EJAC TALLY
	var party = $gameParty.size();
	var actor = $gameParty.members();
	for (var i = 0; i < party; i++) {

		if (actor[i]._isDarkNipple && !actor[i].isPregnant()) {actor[i]._isDarkNipple = false};

		if (!actor[i].isPregnant()) {
			// Babies Generation
			var ejp = actor[i].ejacpoint;
			this.EJPtally(actor[i], ejp);
		}

		var pg = actor[i].pregnancy;
		if (pg == 1000) {
			this.birthBaby(actor[i]);
		}

		// Horny Point
		actor[i].setCParam(12, 0); // Horny Point

		// MILKING EVENT
		this.milking(actor[i]);
		actor[i].milkMaxAdj(); // Adjust Milk Size

		// Preg Sprite
		this.changePregSprite(1, $gameActors.actor(actor[i]._actorId));

		// HP Recover
		actor[i].recoverAll();
		actor[i].addMP(-6);

	}

	// AP & STAMINA RECOVERY
	$gameParty.recoverAP($gameSystem._partyAPMax);
	$gameParty.recoverAllStamina();
	$gameSystem._rc_DayPassed++;

	// REFRESH CLIENT TO MIN
	if ($gameSystem._clientMin > $gameSystem._client_ready.length) {
		var min = $gameSystem._client_ready.length;
		while (min < $gameSystem._clientMin) {
			this.newClient();
			min++;
		}
		this.resetClientTimer();
	}

	if ($gameTemp._birthMoneyGain > 0) {
		this.pluginCommand("showLog", ["Received " + $gameTemp._birthMoneyGain + " money from the King as birthing reward!"]);
		$gameTemp._birthMoneyGain = 0;
	}

	if ($gameTemp._birthRemnantGain > 0) {
		this.pluginCommand("showLog", ["Obtained " + $gameTemp._birthRemnantGain + " remnants in total!"]);
		$gameTemp._birthRemnantGain = 0;
	}

	// MILK BOTTLE GENERATE
	if ($gameTemp._milkBottleGain > 0) {
		this.pluginCommand("showLog", ["Produced " + $gameTemp._milkBottleGain + " milk bottle through milking!"]);
	  $gameTemp._milkBottleGain = 0;
	}

	if ($gameTemp._milkBottleWaste > 0) {
		this.pluginCommand("showLog", ["Some milk produced are wasted."]);
		$gameTemp._milkBottleWaste = 0;
	}

	if ($gameTemp._popStoreTemp[0] > 0) this.gainPopularity_stored($gameTemp._popStoreTemp[0]);

	$gameTemp._birthSceneSelect = [];
};

// STATS
Game_Interpreter.prototype.gainPopularity = function(type, amount) {
	var gain = amount;
	var cur_lv = $gameSystem._popLv[type];
	var cur_xp = $gameSystem._popEXP[type];
	var nextXP = Micoomer.popularityExpRequired[type][cur_lv];

	// Popularity Meter
	var a = [];
	a[0] = type;
	a[1] = $gameSystem._popEXP[type];
	a[2] = nextXP;
	a[3] = Micoomer.popularityExpRequired[type][cur_lv - 1] || 0;
	a[4] = gain;
	if (cur_lv !== 3) {SceneManager._scene.createPopMeter(a)};

  $gameSystem._popEXP[type] += gain;

	// Level Limiter
	if (cur_lv == 3) {return};

	if ($gameSystem._popEXP[type] >= nextXP) {
		var inc = cur_lv + 1;
    $gameSystem._popLv[type] = inc;
	}

	// Brothel client adjustment
	if (type == 1) this.clientPoolAdjust($gameSystem._popLv[type]);
};

Game_Interpreter.prototype.gainPopularity_stored = function(store) {
	var index = $gameTemp._popStoreTemp.indexOf(store);
	this.gainPopularity(index, store);
	$gameTemp._popStoreTemp[index] = 0;
};

Game_Interpreter.prototype.clientPoolAdjust = function(level) {
	$gameSystem._clientMin = Micoomer.clientMinimum[level];
	$gameSystem._clientMax = Micoomer.clientMaximum[level];
};

Game_Interpreter.prototype.gainMoney_birth = function(b) {
	var base = 5000 * b;
	var variance = (Math.random() * (1.1 - 0.9)) + 0.9;
	var gain = Math.floor(base * variance);
	$gameParty.gainGold(gain);
	$gameTemp._birthMoneyGain += gain;
};

Game_Interpreter.prototype.gainRemnants_birth = function(actor, babies) {
	var iteration = babies;
	var gain = 0;

	while (iteration > 0) {
		var table = Micoomer.remnantGainPop[$gameSystem._popLv[0]];
		var base = table[0] + Math.randomInt(table[1]);

		// Favoritism blessing
		if (actor.blessing4 > 0) {
			var level = actor.blessing4;
			var gain_array = [];
			switch (level) {
				case 1: gain_array = [0,1,30]; break;
				case 2: gain_array = [0,1,40]; break;
				case 3: gain_array = [0,1,50]; break;
				case 4: gain_array = [0,2,50]; break;
				case 5: gain_array = [0,2,60]; break;
				case 6: gain_array = [0,2,70]; break;
				case 7: gain_array = [1,3,70]; break;
				case 8: gain_array = [2,3,70]; break;
				case 9: gain_array = [2,4,70]; break;
				case 10: gain_array = [3,4,70]; break;
			}
			if (Math.randomInt(100) < gain_array[2]) {
				var ra = Math.abs(gain_array[1] - gain_array[0]);
				var ga = gain_array[0] + Math.round(Math.random() * ra);
				base += ga;
			}
		}
		gain += base;
		iteration--;
	}
	$gameParty.gainRemnants(gain);
	$gameTemp._birthRemnantGain += gain;
};

Game_Interpreter.prototype.milking = function(actor) {
  var milkable = Math.floor(actor.milk / 250);
  if (milkable > 0) {
		if ($gameParty.hasItem($dataItems[44])) {
			var empty = $gameParty.numItems($dataItems[44]);
	    while (milkable > 0) {
	      if (empty == 0) {break};
	      $gameParty.gainItem($dataItems[43], 1);
	      $gameParty.loseItem($dataItems[44], 1);
				$gameSystem._rc_MilkProd++;
	      $gameTemp._milkBottleGain++;
	      milkable--;
	      empty--;
	    }
	    actor.resetMilk();
		} else {
			actor.resetMilk();
			$gameTemp._milkBottleWaste++;
		}
  }
};

// PREGNANCY
Game_Interpreter.prototype.EJPtally = function(actor, ejp) {
	var sce = 0;
	var ejp_base = ejp;

	// Fertility Blessing
	var ejp_multiplier = 1 + (0.05 * actor.blessing1);
	var ejp_final = Math.ceil(ejp_base * ejp_multiplier);

	if (ejp_final > 0) {

		if (ejp_final <= 149) {sce = 1};
		if (ejp_final >= 150) {sce = 2};
		if (ejp_final >= 200) {sce = 3};
		if (ejp_final >= 250) {sce = 4};
		if (ejp_final >= 300) {sce = 5};
		if (ejp_final >= 350) {sce = 6};
		if (ejp_final >= 425) {sce = 7};
		if (ejp_final >= 500) {sce = 8};
		if (ejp_final >= 600) {sce = 9};
		if (ejp_final >= 750) {sce = 10};
		if (ejp_final >= 900) {sce = 11};

		// Crown of Fortune Cat check
		if (actor.isEquipped($dataWeapons[3])) {
			if (Math.randomInt(100) <= 30) {
				sce += 1;
			}
		}

		this.generateBaby(actor, Micoomer.babiesGeneration[sce.clamp(1,3)]);
		actor._isPregnant = true;
		actor._prevEJP = ejp_final;
		actor.setCParam(13, 0); // reset Ejac Point
		this.pluginCommand("showLog", [actor._name + " become pregnant!"]);
		// tally preg record
		actor.addCParam(18, 1);
		$gameSystem._rc_PregnantCount++;
	}
};

Game_Interpreter.prototype.generateBaby = function(actor, prob) {
	while (actor.babies == 0) {
		var a = a || 0;
		var ch = prob[a] / 100;
		if (Math.random() <= ch) {
			actor.setCParam(3, prob.length - a);
			break;
		} else {
			a++
		}
	}
};

Game_Interpreter.prototype.abortion = function() {
	var party = $gameParty.size();
	var actor = $gameParty.members();
	for (var i = 0; i < party; i++) {
		this.resetPreg(actor[i]);
	}
};

Game_Interpreter.prototype.resetPreg = function(actor) {
	actor._isPregnant = false;
	actor.setCParam(0, 0); // Pregnancy
	actor.setCParam(1, 0); // Preg phase
	actor.setCParam(2, 0); // Fetus phase
	actor.setCParam(3, 0); // Babies
	actor.setCParam(4, 0); // Belly Size
	actor.setCParam(13, 0); // Ejac Point
	this.changePregSprite(1, actor);
};

Game_Interpreter.prototype.birthBaby = function(actor) {
	var b = actor.babies;
//	var annc1 = Micoomer.birthAnnounce[0][b][Math.randomInt(Micoomer.birthAnnounce[0][b].length)];
//	var annc2 = Micoomer.birthAnnounce[1][b];
//	var text = annc1 + actor._name + annc2;
//	this.pluginCommand("showLog", [text]);

	var gainpop = (100 + Math.randomInt(21)) * b;
	$gameTemp._popStoreTemp[0] += gainpop;
	this.gainMoney_birth(b);
	this.gainRemnants_birth(actor, b);
	this.resetPreg(actor);

	// tally birth record
	actor.addCParam(19, b);
	$gameSystem._rc_BirthCount += b;
};

Game_Interpreter.prototype.changePregSprite = function(type, unit, data) {
	switch (type) {
		// changePregSprite(1, $gameActors.actor());
		case 1:
			var a = unit.babies;
			var b = unit.pregphase;
			var c = unit._actorId;
			var index = index || 0;
			switch (b) {
				case 1:
				case 2:
					if (a < 4) {
						index = 1;
					} else {
						index = 2;
					}
					break;

				case 3:
				case 4:
					if (a < 4) {
						index = 2;
					} else {
						index = 3;
					}
					break;

				default:
					index = 0;
					break;
			}
			unit.setCharacterImage('A_' + c, index);
			$gamePlayer.refresh();
			break;

		// changePregSprite(2, $gameMap.event(this._eventId),$gameActors.actor(2));
		case 2:
			var a = data.babies;
			var b = data.pregphase;
			var c = data._actorId;
			var index = index || 0;
			switch (b) {
				case 1:
				case 2:
					if (a < 4) {
						index = 1;
					} else {
						index = 2;
					}
					break;

				case 3:
				case 4:
					if (a < 4) {
						index = 2;
					} else {
						index = 3;
					}
					break;

				default:
					index = 0;
					break;

			}
			unit.setImage('A_' + c, index);
			unit.refresh();
			break;
	}
};

//=============================================================================
// ** Scene_Base
//=============================================================================

Scene_Base.prototype.refreshClientTimer = function() {
  $gameSystem._client_nextTimer--;
  if ($gameSystem._client_nextTimer == 0) {
    $gameMap._interpreter.resetClientTimer();
		$gameMap._interpreter.newClient();
  };
};

//=============================================================================
// ** Scene_Map
//=============================================================================

Scene_Map.prototype.moveCounterCond = function() {
	if ($gamePlayer.isMoving() && $gamePlayer.canMove()) {return true}
	return false
};

Scene_Map.prototype.moveCounter = function() {
	var party = $gameParty.size();
	var actor = $gameParty.members();
	for (var i = 0; i < party; i++) {
		if (!actor[i].isBlessingActive()) {continue}
		actor[i]._moveCounter = actor[i]._moveCounter || 0;
		actor[i]._moveCounter++
		if (actor[i]._moveCounter == 45) {
			this.moveInterval(actor[i]);
			actor[i]._moveCounter = 0;
		}

	}
}

Scene_Map.prototype.moveInterval = function(actor) {
	if (actor.isPregnant()) {
		this.pregnancyCounter(actor);
	}
	this.milkCounter(actor);
	this.hornyCounter(actor);
}

// May add Overdue exception here

Scene_Map.prototype.pregnancyCounter = function(actor) {
	if (actor.pregnancy < 1000) {

		var preg_growth = actor.preggrowth + actor.blessing2;
		var preg_multi = actor.isEquipped($dataWeapons[1]) ? 2 : 1;
		actor.addCParam(0, Math.ceil(preg_growth * preg_multi));
		this.pregPhaseCheck(actor);
		this.fetusPhaseCheck(actor);
	} else if (actor.pregphase == 4) {
		if (actor._max_ptimer && actor._max_ptimer > 0) {
			actor._max_ptimer--;
		} else {
			this.maxPreg(actor);
		}
	}
}

Scene_Map.prototype.pregPhaseCheck = function(actor) {
	var preg_phase = 0;
	var cur_preg = actor.pregnancy;
	if (cur_preg >= 250) {preg_phase = 1};
	if (cur_preg >= 500) {preg_phase = 2};
	if (cur_preg >= 750) {preg_phase = 3};
	if (cur_preg == 1000) {preg_phase = 4; actor._max_ptimer = 40};

	if (actor.pregphase != preg_phase) {
		actor.setCParam(1, preg_phase);
		var belly = Micoomer.bellyTable[actor.babies][actor.pregphase];
		var pq = Micoomer.quotePregGrowth[actor._actorId][actor.babies][actor.pregphase];
		var pw = Math.randomInt(pq.length);
		actor.setCParam(4, belly);
		$gameMap._interpreter.pluginCommand('showQuote',[actor._actorId, pq[pw]]);

		// Dark Nipple Check
		if (actor.pregphase == 3) {
			actor._isDarkNipple = true;
		}
	}

	// Sprite Change
	$gameMap._interpreter.changePregSprite(1, $gameActors.actor(actor._actorId));
}

Scene_Map.prototype.fetusPhaseCheck = function(actor) {
	var fet_phase = 0;
	var cur_preg = actor.pregnancy;
	if (cur_preg >= 70) {fet_phase = 1};
	if (cur_preg >= 150) {fet_phase = 2};
	if (cur_preg >= 200) {fet_phase = 3};
	if (cur_preg >= 250) {fet_phase = 4};
	if (cur_preg >= 500) {fet_phase = 5};
	if (cur_preg >= 750) {fet_phase = 6};

	if (actor.fetusphase != fet_phase) {
		actor.setCParam(2, fet_phase);
	}
}

Scene_Map.prototype.milkCounter = function(actor) {
	if (actor.milk < actor.mmilk) {
		var base = actor.milkspeed + actor.babies;
		var milk_plus = actor.milk + base;

		if (milk_plus > actor.mmilk) {
			actor.setCParam(5, actor.mmilk);
		} else {
			actor.addCParam(5, base);
		}
		actor.milkSizeAdj();
	}
}

Scene_Map.prototype.maxPreg = function(actor) {
	var pq = Micoomer.quotePregGrowth[actor._actorId][actor.babies][5];
	var pw = Math.randomInt(pq.length);
	$gameMap._interpreter.pluginCommand('showQuote',[actor._actorId, pq[pw]]);
	actor._max_ptimer = 40;
};

Scene_Map.prototype.hornyCounter = function(actor) {
	if (actor.horny > 0) {
		actor.addCParam(12, -1);
	}
}
