//-----------------------------------------------------------------------------
// Scene_Ending
//-----------------------------------------------------------------------------

ImageManager.loadEnding = function(filename) {
    return this.loadBitmap('img/menus/ending/', filename, 0, true);
};

function Scene_Ending() {
    this.initialize.apply(this, arguments);
}

Scene_Ending.prototype = Object.create(Scene_MenuBase.prototype);
Scene_Ending.prototype.constructor = Scene_Ending;

Scene_Ending.prototype.initialize = function() {
    Scene_MenuBase.prototype.initialize.call(this);
    this._wOrg = [390, 360, 330];
    this._terminate = false;
};

Scene_Ending.prototype.create_mbackground = function() {
};

Scene_Ending.prototype.create = function() {
    Scene_MenuBase.prototype.create.call(this);

    this._window_c = [];
    this.loadBitmaps();
    this.createWindow();
    this.createSprites();
    this._window_c[0].activate();
    this._window_c[1].deactivate();
    this._phase = 0;
};

Scene_Ending.prototype.createBackground = function() {
	this._field = new Sprite();
	this.addChild(this._field);
};

Scene_Ending.prototype.loadBitmaps = function() {
  this._sp = [];
  this._sp[0] = ImageManager.loadEnding('1');
  this._sp[1] = ImageManager.loadEnding('2');
};

// WINDOW
Scene_Ending.prototype.createWindow = function() {
    var ww = 100;
    var wh = 60;
    var wx = 527;
    var wy = 410;
    this._window_c[0] = new Window_Ending1(wx, wy, ww, wh);
    this._window_c[0].setHandler('log',     this.onLog.bind(this));
    this._window_c[0].setHandler('return',  this.onReturn.bind(this));
    this._window_c[0].opacity = 0;
    this.addWindow(this._window_c[0]);

    var ww = 100;
    var wh = 30;
    var wx = 527;
    var wy = 513;
    this._window_c[1] = new Window_Ending2(wx, wy, ww, wh);
    this._window_c[1].setHandler('return',  this.onReturn.bind(this));
    this._window_c[1].opacity = 0;
    this.addWindow(this._window_c[1]);
};

Scene_Ending.prototype.createSprites = function() {
  this._sprite_c = [];
  for (var i = 0; i < 2; i++) {
    this._sprite_c[i] = new Sprite(this._sp[i]);
    this._sprite_c[i].anchor.x = 0.5;
    this._sprite_c[i].anchor.y = 0.5;
    this._sprite_c[i].x = 640;
    this._sprite_c[i].y = this._wOrg[0];
    this._sprite_c[i].opacity = 0;
    this._field.addChild(this._sprite_c[i]);
  }
};

// WINDOW PROCESS
Scene_Ending.prototype.onLog = function() {
  this._window_c[0].deactivate();
  this._phase = 1;
};

Scene_Ending.prototype.onReturn = function() {
  this._window_c[0].deactivate();
  this._window_c[1].deactivate();
  this._phase = 3;
  this._terminate = true;
  this._terminateTime = 60;
};

Scene_Ending.prototype.updatePhase = function() {
  switch (this._phase) {
    case 0:
      this._sprite_c[0].opacity += 18;
      this._sprite_c[0].y = globMoveTo(this._sprite_c[0].y, this._wOrg[1], 20);
      break;

    case 1:
      this._sprite_c[0].opacity -= 18;
      this._sprite_c[0].y = globMoveTo(this._sprite_c[0].y, this._wOrg[2], 20);
      if (this._sprite_c[0].opacity == 0) {
        this._window_c[1].activate();
        this._phase = 2;
      }
      break;

    case 2:
      this._sprite_c[1].opacity += 18;
      this._sprite_c[1].y = globMoveTo(this._sprite_c[1].y, this._wOrg[1], 20);
      break;
  }

  if (this._terminate) {
    for (var i = 0; i < 2; i++) {
      this._sprite_c[i].opacity -= 18;
      this._sprite_c[i].y = globMoveTo(this._sprite_c[i].y, this._wOrg[2], 20);
    }
    this._terminateTime--;
    if (this._terminateTime == 0) {
      SceneManager.pop();
    }
  }
};

Micoomer.sceneEndingUpdate = Scene_Ending.prototype.update;
Scene_Ending.prototype.update = function() {
  Micoomer.sceneEndingUpdate.call(this);
    if (this._sprite_c) this.updatePhase();
};


//=============================================================================
// * Window
//=============================================================================

function Window_Ending1() {
    this.initialize.apply(this, arguments);
}

Window_Ending1.prototype = Object.create(Window_Command.prototype);
Window_Ending1.prototype.constructor = Window_Ending1;

Window_Ending1.prototype.initialize = function(x, y) {
    Window_Command.prototype.initialize.call(this, x, y);
    this.contentsOpacity = 0;
};

Window_Ending1.prototype.makeCommandList = function() {
  this.addCommand('log', 'log', true);
  this.addCommand('return', 'return', true);
};

Window_Ending1.prototype.lineHeight = function(index) {
	return 40;
};

function Window_Ending2() {
    this.initialize.apply(this, arguments);
}

Window_Ending2.prototype = Object.create(Window_Command.prototype);
Window_Ending2.prototype.constructor = Window_Ending2;

Window_Ending2.prototype.initialize = function(x, y) {
    Window_Ending1.prototype.initialize.call(this, x, y);
};

Window_Ending2.prototype.makeCommandList = function() {
  this.addCommand('return', 'return', true);
};

Window_Ending2.prototype.lineHeight = function(index) {
	return 40;
};
