//-----------------------------------------------------------------------------
// Scene_Record
//-----------------------------------------------------------------------------

/*:
 * @plugindesc
 * @author micoomer
 *
 */

 function Scene_Record() {
     this.initialize.apply(this, arguments);
 }

 Scene_Record.prototype = Object.create(Scene_MenuBase.prototype);
 Scene_Record.prototype.constructor = Scene_Record;

 Scene_Record.prototype.initialize = function() {
     Scene_MenuBase.prototype.initialize.call(this);
 };

 Scene_Record.prototype.start = function() {
     Scene_MenuBase.prototype.start.call(this);

     this._onCategory = 0;
 };

Scene_Record.prototype.create = function() {
    Scene_MenuBase.prototype.create.call(this);
    this.createHelpWindow();
		this.createCategoryWindow();

		// Sprite
		this.loadBitmaps();
		this.setData();
		this.createSprites();
};

Scene_Record.prototype.setData = function() {
	this._list1_maxIndex = [8, 5, 3];
	this._list1_data = [];
	this._list1_data[0] = [
		$gameSystem.playtimeText(),
		$gameSystem._rc_DayPassed,
		$gameSystem._rc_MoneyEarned,
		$gameSystem._rc_BRearned,
		$gameSystem._rc_BRspent,
		$gameSystem._rc_MilkProd,
		$gameSystem._rc_ArtiFound + " / 11",
		$gameSystem._rc_ArtiEnhance + " / 25"
	];
	this._list1_data[1] = [
		$gameSystem._rc_ProsSession,
		$gameSystem._rc_SexActivity,
		$gameSystem._rc_PregnantCount,
		$gameSystem._rc_BirthCount,
		$gameSystem._rc_LewdEXP
	];
	this._list1_data[2] = [
		$gameSystem._rc_BattleWon,
		$gameSystem._rc_MonSlain,
		$gameSystem._rc_SupportUsed
	];

	this._list2_maxIndex = [4, 6, 3];
	this._list2_data = [];
	this._list2_data[0] = [
		$gameSystem._popLv[0],
		$gameSystem._popEXP[0],
		Micoomer.popularityExpRequired[0][$gameSystem._popLv[0]],
		Micoomer.remnantGainPop[$gameSystem._popLv[0]][0] + " ~ " + (Micoomer.remnantGainPop[$gameSystem._popLv[0]][0] + Micoomer.remnantGainPop[$gameSystem._popLv[0]][1] - 1)
	];

	this._list2_data[1] = [
		$gameSystem._popLv[1],
		$gameSystem._popEXP[1],
		Micoomer.popularityExpRequired[1][$gameSystem._popLv[1]],
		Micoomer.clientMinimum[$gameSystem._popLv[1]] + " ~ " + Micoomer.clientMaximum[$gameSystem._popLv[1]],
		(Micoomer.clientWaitingTime[$gameSystem._popLv[1]] / 60 / 60) + " minutes",
		"+" + Micoomer.location1_MoneyBonus[$gameSystem._popLv[1]] + "%"
	];

	this._list2_data[2] = [
		"???",
		"???",
		"???"
	];
};

Scene_Record.prototype.createCategoryWindow = function() {
    var wx = 280;
    var wy = 90;
    var ww = 160;
    var wh = 160;
    this._window_cat = new Window_Record_Category(wx, wy, ww, wh);
    this._window_cat.setHandler('cancel', this.popScene.bind(this));
    this.addWindow(this._window_cat);
};

//////////////////////////////////////////////////////////////////////////////

Micoomer.SceneRecordBackground = Scene_Record.prototype.createBackground;
Scene_Record.prototype.createBackground = function() {
	Micoomer.SceneRecordBackground.call(this);
	this._field = new Sprite();
	this.addChild(this._field);
};

Scene_Record.prototype.loadBitmaps = function() {
  this._layImg = ImageManager.loadBackground('UI_Record');
};

Scene_Record.prototype.createSprites = function() {
	this.createSprite_Title();
	this.createSprite_Box();
	this.createSprite_Button();
	this.createSprite_List();
	this.createData();
};

Scene_Record.prototype.createSprite_Title = function() {
	this._lay_title = new Sprite(this._layImg);
	this._lay_title.setFrame(0,599,480,96);
	this._field.addChild(this._lay_title);
};

Scene_Record.prototype.createSprite_Box = function() {
	this._lay_box = new Sprite(this._layImg);
	this._lay_box.x = 265;
	this._lay_box.y = 69;
	this._lay_box.setFrame(0,0,750,599);
	this._field.addChild(this._lay_box);
};

Scene_Record.prototype.createSprite_Button = function() {
	this._lay_button = [];
	for (var i = 0; i < 2; i++) {
		this._lay_button[i] = new Sprite(this._layImg);
		this._lay_button[i].x = 289;
		this._lay_button[i].y = 109 + (60 * i);
		var frame = 599 + (59 * i);
		this._lay_button[i].setFrame(480,frame,206,59);
		this._field.addChild(this._lay_button[i]);
	}
};

Scene_Record.prototype.createSprite_List = function() {
	this._lay_list = [];
	for (var i = 0; i < 2; i++) {
		this._lay_list[i] = new Sprite(this._layImg);
		this._lay_list[i].x = 494;
		this._lay_list[i].y = 90;
		this._lay_list[i].visible = false;
		var frame = 750 + (550 * i);
		this._lay_list[i].setFrame(frame,0,550,550);
		this._field.addChild(this._lay_list[i]);
	}
	this.updateList(0);
};

Scene_Record.prototype.createData = function() {

	this._dataField = [];
	this._dataField[0] = new Sprite();
	this.addChild(this._dataField[0]);

	this._dataField[1] = new Sprite();
	this.addChild(this._dataField[1]);
	this._dataField[1].visible = false;

	this._dataText = [];
	this._dataText[0] = [[],[],[]];
	this._dataText[1] = [[],[],[]];

	this.createData_Exploration();
	this.createData_Popularity();
};

Scene_Record.prototype.createData_Exploration = function() {

	var index = 0;
	for (var i = 0; i < this._list1_maxIndex[index]; i++) {
		this._dataText[0][index][i] = new Sprite(new Bitmap(200, 32));
		this._dataText[0][index][i].x = 760;
		this._dataText[0][index][i].y = 152 + (20 * i);
		this._dataText[0][index][i].bitmap.fontSize = 14;
		this._dataText[0][index][i].bitmap.textColor = '#f57ac8';
		this._dataField[0].addChild(this._dataText[0][index][i]);
		this.refreshText(this._dataText[0][index][i], this._list1_data[index][i]);
	}

	index = 1;
	for (var i = 0; i < this._list1_maxIndex[index]; i++) {
		this._dataText[0][index][i] = new Sprite(new Bitmap(200, 32));
		this._dataText[0][index][i].x = 760;
		this._dataText[0][index][i].y = 382 + (20 * i);
		this._dataText[0][index][i].bitmap.fontSize = 14;
		this._dataText[0][index][i].bitmap.textColor = '#f57ac8';
		this._dataField[0].addChild(this._dataText[0][index][i]);
		this.refreshText(this._dataText[0][index][i], this._list1_data[index][i]);
	}

	index = 2;
	for (var i = 0; i < this._list1_maxIndex[index]; i++) {
		this._dataText[0][index][i] = new Sprite(new Bitmap(200, 32));
		this._dataText[0][index][i].x = 760;
		this._dataText[0][index][i].y = 552 + (20 * i);
		this._dataText[0][index][i].bitmap.fontSize = 14;
		this._dataText[0][index][i].bitmap.textColor = '#f57ac8';
		this._dataField[0].addChild(this._dataText[0][index][i]);
		this.refreshText(this._dataText[0][index][i], this._list1_data[index][i]);
	}
};

Scene_Record.prototype.createData_Popularity = function() {

	var index = 0;
	for (var i = 0; i < this._list2_maxIndex[index]; i++) {
		this._dataText[1][index][i] = new Sprite(new Bitmap(200, 32));
		this._dataText[1][index][i].x = 760;
		this._dataText[1][index][i].y = 152 + (20 * i);
		this._dataText[1][index][i].bitmap.fontSize = 14;
		this._dataText[1][index][i].bitmap.textColor = '#f57ac8';
		this._dataField[1].addChild(this._dataText[1][index][i]);
		this.refreshText(this._dataText[1][index][i], this._list2_data[index][i]);
	}

	index = 1;
	for (var i = 0; i < this._list2_maxIndex[index]; i++) {
		this._dataText[1][index][i] = new Sprite(new Bitmap(200, 32));
		this._dataText[1][index][i].x = 760;
		this._dataText[1][index][i].y = 322 + (20 * i);
		this._dataText[1][index][i].bitmap.fontSize = 14;
		this._dataText[1][index][i].bitmap.textColor = '#f57ac8';
		this._dataField[1].addChild(this._dataText[1][index][i]);
		this.refreshText(this._dataText[1][index][i], this._list2_data[index][i]);
	}

	index = 2;
	for (var i = 0; i < this._list2_maxIndex[index]; i++) {
		this._dataText[1][index][i] = new Sprite(new Bitmap(200, 32));
		this._dataText[1][index][i].x = 760;
		this._dataText[1][index][i].y = 512 + (20 * i);
		this._dataText[1][index][i].bitmap.fontSize = 14;
		this._dataText[1][index][i].bitmap.textColor = '#f57ac8';
		this._dataField[1].addChild(this._dataText[1][index][i]);
		this.refreshText(this._dataText[1][index][i], this._list2_data[index][i]);
	}
};

Scene_Record.prototype.refreshText = function(sprite, data) {
	var text = String(data);
	sprite.bitmap.drawText(text,0,0,200,32,'right');
};

Scene_Record.prototype.updateCatIndex = function() {
  if (this._onCategory != this._window_cat._index) this.refreshCatIndex();
};

Scene_Record.prototype.refreshCatIndex = function() {
  this._onCategory = this._window_cat._index;
  this.updateList(this._onCategory);
	var cat = this._onCategory == 0 ? 1 : 0;
	this._dataField[this._onCategory].visible = true;
	this._dataField[cat].visible = false;
};

Scene_Record.prototype.updateList = function(a) {
  for (var i = 0; i < this._lay_list.length; i++) {
		this._lay_list[i].visible = false;
	}
	this._lay_list[a].visible = true;
};

Micoomer.recordUpdate = Scene_Record.prototype.update;
Scene_Record.prototype.update = function() {
  Micoomer.recordUpdate.call(this);
    this.updateCatIndex();
};

//=============================================================================
// * Window
//=============================================================================
function Window_Record_Category() {
    this.initialize.apply(this, arguments);
}

Window_Record_Category.prototype = Object.create(Window_Command.prototype);
Window_Record_Category.prototype.constructor = Window_Record_Category;

Window_Record_Category.prototype.initialize = function(x, y, width, height) {
    Window_Command.prototype.initialize.call(this, x, y, width, height);
		this.contentsOpacity = 0;
};

Window_Record_Category.prototype.makeCommandList = function() {
  this.addCommand('Exploration', 'exploration', true);
  this.addCommand('Popularity', 'popularity', true);
};

Window_Record_Category.prototype.lineHeight = function(index) {
	return 60;
};

Window_Record_Category.prototype.processOk = function() {
};
