//=============================================================================
// MCM_SceneStatus.js
//=============================================================================

/*:
 * @plugindesc
 * @author micoomer
 *
 */

//=============================================================================
// ** ImageManager
//=============================================================================

ImageManager.loadMenusstatus = function(filename) {
    return this.loadBitmap('img/menus/status/', filename, 0, true);
};

//=============================================================================
// ** Scene Status
//=============================================================================

//==============================
// * create Background
//==============================
var _mog_scStatus_createBackground = Scene_Status.prototype.createBackground;
Scene_Status.prototype.createBackground = function() {
	_mog_scEquip_createBackground.call(this);
	this._field = new Sprite();
	this.addChild(this._field);
};

//==============================
// * Create
//==============================
var _mog_scStatusM_create = Scene_Status.prototype.create;
Scene_Status.prototype.create = function() {
	_mog_scStatusM_create.call(this);
	this.createBust();
	this.createBase();
	this.createLayout();
	this.createSelection();
	this.createAbout();
	this.createButton();
	this.createMeters();
	this.createMeters2();
	this.resetPosition();
};

var _mog_scsStatusM_onActorChange = Scene_Status.prototype.onActorChange;
Scene_Status.prototype.onActorChange = function() {
	_mog_scsStatusM_onActorChange.call(this);
    this.resetPosition();
};

Scene_Status.prototype.resetPosition = function() {
    this.refreshAbout();
	this.refreshBust();
	this._statusWindow.contentsOpacity = 0;
	for (i = 0; i < 2; i++) {
		this._layout[i].opacity = 0;
		this._selection[i].opacity = 0;
	}
	$gameTemp._statusIndex = 0;
	this._meters.setActor(this._actor);
	this._meters2.setActor(this._actor);
};

Scene_Status.prototype.createBase = function() {
	this._base = new Sprite(ImageManager.loadMenusstatus("Base"));
	this._field.addChild(this._base);
};

Scene_Status.prototype.createBust = function() {
	this._bust = [];
	this._bustOrg = [];
	this._bustOrg = [Micoomer.Status_BustX, Micoomer.Status_BustX + 100];

	this._bust[0] = new MSprite(this._actor._actorId, 0);
	this._bust[0].x = this._bustOrg[1];
	this._bust[0].y = Micoomer.Status_BustY;
	this._field.addChild(this._bust[0]);

	this._bust[1] = new MSprite(this._actor._actorId, 1);
	this._bust[1].x = this._bustOrg[1];
	this._bust[1].y = Micoomer.Status_BustY;
	this._field.addChild(this._bust[1]);
};

Scene_Status.prototype.createLayout = function() {
	this._layout = [];
	for (i = 0; i < 2; i++) {
		this._layout[i] = new Sprite(ImageManager.loadMenusstatus("Layout_" + i));
		this._layout[i].x = 32;
		this._layout[i].y = 268;
		this._layout[i].opacity = 0;
		this._field.addChild(this._layout[i]);
	}
};

Scene_Status.prototype.createSelection = function() {
	this._selection = [];
	for (i = 0; i < 2; i++) {
		this._selection[i] = new Sprite(ImageManager.loadMenusstatus("Select_" + i));
		this._selection[i].x = 26;
		this._selection[i].y = 202;
		this._selection[i].opacity = 0;
		this._field.addChild(this._selection[i]);
	}
};

Scene_Status.prototype.createAbout = function() {
	this._about = new Sprite();
	this._about.x = 113;
	this._about.y = 77;
	this._field.addChild(this._about);
};

Scene_Status.prototype.createButton = function() {
	this._button = new Sprite();
	this._button.bitmap = $gameSwitches.value(501) ? ImageManager.loadMenusstatus("Button_1") : ImageManager.loadMenusstatus("Button_0")
	this._button.x = 423;
	this._button.y = 686;
	this._button.anchor.x = 0.5;
	this._button.anchor.y = 0.5;
	this._field.addChild(this._button);
};

Scene_Status.prototype.createMeters = function() {
    this._meters = new MetersStatusM(this._actor);
	this._field.addChild(this._meters);
};

Scene_Status.prototype.createMeters2 = function() {
    this._meters2 = new MetersStatusM2(this._actor);
	this._field.addChild(this._meters2);
};

Scene_Status.prototype.refreshAbout = function() {
	this._about.bitmap = ImageManager.loadMenusstatus("About_" + this._actor._actorId);
};

Scene_Status.prototype.refreshBust = function() {
	for (var i = 0; i < 2; i++) {
		this._bust[i].x = this._bustOrg[1];
		this._bust[i].replaceBust(this._actor._actorId, i);
	};
};

//==============================
// * Update
//==============================
var _mog_scStatatusM_update = Scene_Status.prototype.update;
Scene_Status.prototype.update = function() {
	_mog_scStatatusM_update.call(this);
	this._statusWindow.refresh();
    this.updateSlide();
	this.updateMeters();
	this.updateCommands();

};

Scene_Status.prototype.updateSlide = function() {
	this._statusWindow.opacity = 0;
	this._statusWindow.contentsOpacity += 20;

	if (this._bust[0].x > this._bustOrg[0]) {
		this._bust[0].x -= 4;
		if (this._bust[0].x < this._bustOrg[0]) {
			this._bust[0].x = this._bustOrg[0];
		};
	};
	this._bust[1].x = this._bust[0].x;

	if ($gameTemp._statusIndex === 0) {
		this._layout[0].opacity += 20;
		this._layout[1].opacity = 0;
		this._selection[0].opacity += 25;
		this._selection[1].opacity -= 25;
		this._bust[0].opacity = 255;
		this._bust[1].opacity = 0;
	} else {
		this._layout[0].opacity = 0;
		this._layout[1].opacity += 20;
		this._selection[0].opacity -= 25;
		this._selection[1].opacity += 25;
		this._bust[0].opacity = 0;
		this._bust[1].opacity = 255;
	}
};

Scene_Status.prototype.updateCommands = function() {
	if (Input.isTriggered('right')) {
    if ($gameTemp._statusIndex == 0) {
    	SoundManager.playCursor();
			$gameTemp._statusIndex = 1;
		}
	} else if (Input.isTriggered('left')) {
		if ($gameTemp._statusIndex == 1) {
    	SoundManager.playCursor();
			$gameTemp._statusIndex = 0;
		}
	} else if (Input.isTriggered('shift') && $gameTemp._statusIndex == 1 && $gameSwitches.value(501)) {
		SoundManager.playCursor();
		this._bust[1].toggleXray();
	}
};

Scene_Status.prototype.updateMeters = function() {
	this._meters.opacity = this._layout[0].opacity;
	this._meters2.opacity = this._layout[1].opacity;
};

//=============================================================================
// ** Window Status
//=============================================================================

//==============================
// * refresh
//==============================
Window_Status.prototype.refresh = function() {
	this.contents.clear();
    if (this._actor) {
		this.drawTextEx(this._actor.profile(), Micoomer.Status_ProfileX, Micoomer.Status_ProfileY);
		if ($gameTemp._statusIndex === 0) {
			this.contents.fontFace = 'FredokaSemi';
			this.contents.fontSize = 30;
			this.contents.textColor = '#f57ac8';
			this.drawText(this._actor.name(), 108, 267,100,"left");
			this.contents.fontSize = 24;
			this.drawText(this._actor.mhp, 274, 373,100,"right");
			this.drawText(this._actor.mdf + "%", 274, 412,100,"right");
			this.drawText(this._actor.atk, 274, 451,100,"right");
			this.drawText(this._actor.mat, 274, 490,100,"right");
			this.drawText(this._actor.def, 274, 529,100,"right");
			this.drawText(this._actor.luk, 274, 568,100,"right");
			this.contents.textColor = '#ffffff';
			this.drawText(this._actor.level, 431, 267,100,"center");
			this.drawText(this._actor.nextRequiredExp(), 591, 267,100,"right");
		} else if ($gameTemp._statusIndex === 1) {
			this.contents.fontFace = 'FredokaSemi';
			this.contents.fontSize = 20;
			this.contents.textColor = '#f57ac8';
			var milktext = this._actor.milk + " / " + this._actor.mmilk + " ml";
			this.drawText(milktext, 175, 313,200,"right");
			var pregsizeText = "";
			switch (this._actor.bellysize) {
				case 1 :
					pregsizeText = "Small";
					break;
				case 2 :
					pregsizeText = "Medium";
					break;
				case 3 :
				case 4 :
					pregsizeText = "Big";
					break;
				case 5 :
				case 6 :
					pregsizeText = "Huge!";
					break;
				case 7 :
				case 8 :
					pregsizeText = "Massive!!";
					break;
				default:
					pregsizeText = "Normal";
			};
			this.drawText(pregsizeText, 215, 347,160,"right");
			this.drawText(this._actor.csex + " times", 225, 441,150,"right");
			this.drawText(this._actor.ccreampie + " times", 225, 475,150,"right");
			this.drawText(this._actor.cpregnant + " times", 225, 509,150,"right");
			this.drawText(this._actor.cbirth + " times", 225, 543,150,"right");
			this.contents.fontSize = 16;
			var lewdText = Micoomer.lewdnessRequiredExp[this._actor.lewdlevel] - this._actor.lewdexp;
			this.drawText(lewdText + " point to next level", 435, 325,300,"right");
		};
    };
};

//=============================================================================
// * Meters Status M
//=============================================================================
function MetersStatusM() {
    this.initialize.apply(this, arguments);
};

MetersStatusM.prototype = Object.create(Sprite.prototype);
MetersStatusM.prototype.constructor = MetersStatusM;

//==============================
// * Initialize
//==============================
MetersStatusM.prototype.initialize = function(actor) {
    Sprite.prototype.initialize.call(this);
	this.loadBitmaps();
    this._actor = actor;
};

//==============================
// * Set Actor
//==============================
MetersStatusM.prototype.setActor = function(actor) {
    this._actor = actor;
	this.update();
};

//==============================
// * Load Bitmaps
//==============================
MetersStatusM.prototype.loadBitmaps = function() {
    this._meterImg0 = ImageManager.loadMenusstatus("Meter1_1");
    this._meterImg1 = ImageManager.loadMenusstatus("Meter1_2");
};

//==============================
// * create Meters
//==============================
MetersStatusM.prototype.createMeters = function() {
    this._meters1 = [];
	this._meters1Data = [];
	for (var i = 0; i < 6; i++) {
		 this._meters1[i] = new Sprite(this._meterImg1);
		 this._meters1Data[i] = [this._meters1[i].width,this._meters1[i].height,0,0];
		 this._meters1[i].x = 412;
		 this._meters1[i].y = 403 + (39 * i);
		 this.addChild(this._meters1[i]);
	};

	this._meters0 = new Sprite(this._meterImg0);
	this._meters0Data = [this._meters0.width,this._meters0.height,0,0];
	this._meters0.x = 121;
	this._meters0.y = 328;
	this.addChild(this._meters0);

};

//==============================
// * update Meters
//==============================
MetersStatusM.prototype.updateMeters = function() {
	for (var i = 0; i < this._meters1.length; i++) {
		 var par1;
		 var par2;
		 if (i === 0) {
		    par1 = this._actor.mhp;
		    par2 = 99999;
		 } else if (i === 1) {
		    par1 = this._actor.mdf;
		    par2 = 200;
		 } else if (i === 2) {
		    par1 = this._actor.atk;
		    par2 = 99;
		 } else if (i === 3) {
		    par1 = this._actor.mat;
		    par2 = 99;
		 } else if (i === 4) {
		    par1 = this._actor.def;
		    par2 = 99;
		 } else if (i === 5) {
		    par1 = this._actor.luk;
		    par2 = 99;
		 };
		 this.updateFrame(this._meters1[i],this._meters1Data[i],par1,par2);
	};
	var exp1 = this._actor.currentExp() - this._actor.expForLevel(this._actor.level);
	var exp2 = this._actor.nextLevelExp() - this._actor.expForLevel(this._actor.level);
	this.updateFrame(this._meters0,this._meters0Data,exp1,exp2);
};

//==============================
// * update Meter
//==============================
MetersStatusM.prototype.updateFrame = function(sprite,data,v1,v2) {
	 var cw = data[0] * v1 / v2;
     sprite.setFrame(data[3],0,cw,data[1]);
};

//==============================
// * Update
//==============================
MetersStatusM.prototype.update = function() {
    Sprite.prototype.update.call(this);
    if (!this._meters1 && this._meterImg1.isReady()) {this.createMeters()};
    if (this._meters1 && this._actor) {this.updateMeters()};
};


//=============================================================================
// * Meters Status M 2
//=============================================================================
function MetersStatusM2() {
    this.initialize.apply(this, arguments);
};

MetersStatusM2.prototype = Object.create(Sprite.prototype);
MetersStatusM2.prototype.constructor = MetersStatusM2;

//==============================
// * Initialize
//==============================
MetersStatusM2.prototype.initialize = function(actor) {
    Sprite.prototype.initialize.call(this);
	  this.loadBitmaps();
    this._actor = actor;
    this._data = [this._actor.blessing1, this._actor.blessing2, this._actor.blessing3, this._actor.blessing4];
};

//==============================
// * Set Actor
//==============================
MetersStatusM2.prototype.setActor = function(actor) {
    this._actor = actor;
	if (this._meters2) {this.updateStat()};
};


//==============================
// * Load Bitmaps
//==============================
MetersStatusM2.prototype.loadBitmaps = function() {
	this._meterImg2 = ImageManager.loadMenusstatus("Meter2_1");
	this._meterImg3 = ImageManager.loadMenusstatus("Meter2_2");
	this._numberImg2 = ImageManager.loadMenusstatus("LevelNumber_2");
	this._numberImg3 = ImageManager.loadMenusstatus("LevelNumber_1");
};

//==============================
// * create Sprites
//==============================
MetersStatusM2.prototype.createSprites = function() {
	this.createMeters2();
	this.createMeters3();
	this.createNumber2();
	this.createNumber3();
};

//==============================
// * create Meters 2
//==============================
MetersStatusM2.prototype.createMeters2 = function() {
	this._meters2 = [];
	this._meters2Data = [];
	for (var i = 0; i < this._data.length; i++) {
		this._meters2[i] = new Sprite(this._meterImg2);
		this._meters2Data[i] = [this._meters2[i].width,this._meters2[i].height,0,0];
		this._meters2[i].x = 484;
		this._meters2[i].y = 423 + (i * 53);
		this.addChild(this._meters2[i]);
  	this.updateFrame(this._meters2[i],this._meters2Data[i],this._data[i],10);
	};
};

//==============================
// * create Meters 3
//==============================
MetersStatusM2.prototype.createMeters3 = function() {
	this._meters3 = new Sprite(this._meterImg3);
	this._meters3Data = [this._meters3.width,this._meters3.height,0,0];
	this._meters3.x = 475;
	this._meters3.y = 332;
	this.addChild(this._meters3);
	this.updateFrame(this._meters3,this._meters3Data,this._actor.lewdexp,Micoomer.lewdnessRequiredExp[this._actor.lewdlevel]);
};

//==============================
// * create Number 3
//==============================
MetersStatusM2.prototype.createNumber2 = function() {
	if (this.number2) {
		for (var i = 0; i <  this.number2.length; i++) {
			this.removeChild(this.number2[i])
		}
	};

	this.number2 = [];
	var w = this._numberImg2.width / 11;
	var h = this._numberImg2.height;

	for (var i = 0; i < this._data.length; i++) {
		var n = Number(this._data[i]);
		this.number2[i] = new Sprite(this._numberImg2);
		this.number2[i].setFrame(n * w, 0, w, h);
		this.number2[i].anchor.x = 0.5;
		this.number2[i].anchor.y = 0.5;
		this.number2[i].x = 745;
		this.number2[i].y = 406 + (53 * i);
		this.addChild(this.number2[i]);
	};
};

//==============================
// * create Number 3
//==============================
MetersStatusM2.prototype.createNumber3 = function() {
	if (this.number3) {
		for (var i = 0; i <  this.number3.length; i++) {
			this.removeChild(this.number3[i])
		}
	};

	this.number3 = [];
	var w = this._numberImg3.width / 10;
	var h = this._numberImg3.height;
	var number = Math.abs(this._actor.lewdlevel).toString().split("");
    for (var i = 0; i <  number.length; i++) {
		var n = Number(number[i]);
		   this.number3[i] = new Sprite(this._numberImg3);
			 this.number3[i].setFrame(n * w, 0, w, h);
			 this.number3[i].anchor.x = 0.5;
			 this.number3[i].anchor.y = 0.5;
			 this.number3[i].x = 763 - ((number.length - i) * 25);
			 this.number3[i].y = 308;
		   this.addChild(this.number3[i]);
	};
};


//==============================
// * update Meter
//==============================
MetersStatusM2.prototype.updateFrame = function(sprite,data,v1,v2) {
	 var cw = data[0] * v1 / v2;
     sprite.setFrame(data[3],0,cw,data[1]);
};

MetersStatusM2.prototype.updateStat = function() {
	this.updateMeter();
	this.updateNumber();
};

MetersStatusM2.prototype.updateMeter = function() {
  this._data = [this._actor.blessing1, this._actor.blessing2, this._actor.blessing3, this._actor.blessing4];
  for (var i = 0; i < this._data.length; i++) {
  	this.updateFrame(this._meters2[i],this._meters2Data[i],this._data[i],10);
	}
	this.updateFrame(this._meters3,this._meters3Data,this._actor.lewdexp,Micoomer.lewdnessRequiredExp[this._actor.lewdlevel]);
};

MetersStatusM2.prototype.updateNumber = function() {
	this.createNumber2();
	this.createNumber3();
};

//==============================
// * Update
//==============================
MetersStatusM2.prototype.update = function() {
    Sprite.prototype.update.call(this);
	if (!this._meters2 && this._meterImg2.isReady()) {this.createSprites()};
};
