
// CATALOG
//  ID001 = PopMeter
//  ID002 = QuoteMap
//  ID003 = PagedTutor
//  ID004 = ActivityIndicator
//  ID005 = ShortcutLog
//  ID006 = DebugStat
//  ID007 = DebugStat2
//  ID008 = MessageBox
//  ID009 = ClientTimer
//  ID010 = EnemyAlert

/*:
 * @plugindesc
 * @author micoomer
 *
 */

//=============================
// ** Image Manager
//=============================
ImageManager.loadOther_Pop = function(filename) {
    return this.loadBitmap('img/hud_other/popularity/', filename, 0, true);
};

ImageManager.loadOther_Quote = function(filename) {
    return this.loadBitmap('img/hud_other/quote/', filename, 0, true);
};

ImageManager.loadOther_Tutorial = function(filename) {
    return this.loadBitmap('img/pictures/Tutorial/', filename, 0, true);
};

ImageManager.loadOther_Overworld = function(filename) {
    return this.loadBitmap('img/hud_other/overworld/', filename, 0, true);
};

//=============================================================================
// ** Game_Interpreter
//=============================================================================

//==============================
// * PluginCommand
//==============================
var mcm_ow_pluginCommand = Game_Interpreter.prototype.pluginCommand
Game_Interpreter.prototype.pluginCommand = function(command, args) {
	mcm_ow_pluginCommand.call(this,command, args)

  switch (command) {

    case "showGab":
      var face = Number(args[0]) || 0;
		  var text = String(args[1]) || '';
      var id = $gameTemp._quoteAviID[0];
      $gameTemp._quoteAviID.shift();
      $gameTemp._quoteIteration.push(SceneManager._scene._quote[id]);
      SceneManager._scene._quote[id]._id = id;
      SceneManager._scene._quote[id]._active[0] = true;
      SceneManager._scene._quote[id]._data = [face, text];
    break;

    case "showQuote":
      var face = Number(args[0]) || 0;
		  var text = String(args[1]) || '';
      $gameTemp._quoteData.push([face, text]);
      SceneManager._scene.checkQuoteAvailability();
    break;

    case "showLog":
		  var text = '';
      for (var i = 0; i < args.length; i++) {
        text += args[i];
        text += " ";
      }
      SceneManager._scene.createEventLog(String(text));
    break;

    // 0 = hide, 1 = show, 2 = toggle
    case "objHud":
      var type = Number(args[0]);
      if (type == 0) {$gameSystem._objHudVisible = false};
      if (type == 1) {$gameSystem._objHudVisible = true};
      if (type == 2) {$gameSystem._objHudVisible = !$gameSystem._objHudVisible};
    break;

    case "panel_ap":
      var type = Number(args[0]);
      if (type == 0) {$gameSystem._apPanelVisible = false};
      if (type == 1) {$gameSystem._apPanelVisible = true};
      if (type == 2) {$gameSystem._apPanelVisible = !$gameSystem._apPanelVisible};
    break;

    case "panel_client":
      var type = Number(args[0]);
      if (type == 0) {$gameSystem._clientPanelVisible = false};
      if (type == 1) {$gameSystem._clientPanelVisible = true};
      if (type == 2) {$gameSystem._clientPanelVisible = !$gameSystem._clientPanelVisible};
    break;

    case "shortcutLog":
      var type = Number(args[0]);
      if (type == 0) {$gameSystem._shortcutVisible = false};
      if (type == 1) {$gameSystem._shortcutVisible = true};
      if (type == 2) {$gameSystem._shortcutVisible = !$gameSystem._shortcutVisible};
    break;

    case "msgShow":
      var t = $gameVariables.value(560);
      SceneManager._scene._msgBox.setType(t);
      $gameTemp._msgBoxVisible = true;
    break;

    case "msgAlter":
      var t = $gameVariables.value(560) == 1 ? 0 : 1
      $gameVariables.setValue(560, t)
      t = $gameVariables.value(560);
      SceneManager._scene._msgBox.setType(t);
		  $gameTemp._msgBoxVisible = true;
    break;

    case "msgHide":
      $gameTemp._msgBoxVisible = false;
    break;

    case "show_debug":
      $gameSystem._debugId = Number(args[0]);
  	  $gameSystem._debugStatVisible = true;
    break;

    case "hide_debug":
      $gameSystem._debugStatVisible = false;
    break;

    case "toggle_debugStat":
      $gameSystem._debugStat2Visible = !$gameSystem._debugStat2Visible;
    break;

  }

};

//=============================================================================
// ** PopMeter ID001
//=============================================================================
function PopMeter() {
    this.initialize.apply(this, arguments);
};

PopMeter.prototype = Object.create(Sprite.prototype);
PopMeter.prototype.constructor = PopMeter;

PopMeter.prototype.initialize = function(data) {
    Sprite.prototype.initialize.call(this);

	this._aniPhase = 0;
	this._org = [];
	this._org = [1300, 1038];
  this._meterTimer = 120;
  this._meterIteration = 0;
  this.x = this._org[0];
  this.y = 128;
  this.setData(data);
	this.loadBitmaps();

  AudioManager.playSe({
    name: "clicky_2",
    volume: 80,
    pitch: 100
  });

};

PopMeter.prototype.setData = function(data) {
	this._data_type = data[0]; // type
  this._data_cur = data[1]; // current point
  this._data_max = data[2]; // next point - prev point
  this._data_dif = data[3];
  this._data_gain = data[4]; // gain amount

  // formula
  var full = this._data_max - this._data_dif; // 400
  var cur = this._data_cur - this._data_dif; // 0
  var inc = (cur + this._data_gain).clamp(0,full); // 100
  var cur_meter = Math.ceil((cur / full) * 134);
  var trg_meter = Math.ceil((inc / full) * 134);
  var dif_meter = (trg_meter - cur_meter) / this._meterTimer;
  this._meterData = [cur_meter,dif_meter];
};

PopMeter.prototype.loadBitmaps = function() {
	this._layImg = ImageManager.loadOther_Overworld("Pop");
};

PopMeter.prototype.createSprites = function() {
	this.createLayout();
  this.createText();
	this.createMeter();
  this.createPopup();
};

PopMeter.prototype.createLayout = function() {
	this._lay = new Sprite(this._layImg);
  this._lay.setFrame(0,0,242,32);
	this.addChild(this._lay);
};

PopMeter.prototype.createText = function() {
  var frame = 59 * this._data_type;
	this._text = new Sprite(this._layImg);
  this._text.setFrame(frame,32,59,16);
  this._text.anchor.x = 0.5;
  this._text.anchor.y = 0.5;
  this._text.x = this._lay.x + 48;
  this._text.y = this._lay.y + 12;
	this.addChild(this._text);
};

PopMeter.prototype.createMeter = function() {
	this._meter = new Sprite(this._layImg);
  this._meter.setFrame(0,49,this._meterData[0],6);
  this._meter.anchor.y = 0.5;
	this._meter.x = this._lay.x + 93;
	this._meter.y = this._lay.y + 13;
	this.addChild(this._meter);
};

PopMeter.prototype.createPopup = function() {
	this._popup = new Sprite(new Bitmap(160,40));
	this._popup.x = this._lay.x + 76;
	this._popup.y = this._lay.y;
  this._popup.posOrg = [this._lay.y, this._lay.y - 35];
  this._popup.opacity = 0;
  this._popup.bitmap.fontSize = 20;
  this._popup.bitmap.fontFace = 'FredokaBold';
  this._popup.bitmap.textColor = '#66cc40';
  this._popup.bitmap.outlineWidth = 4;
  this._popup.bitmap.outlineColor = '#ffffff';
  this._popup.bitmap.drawText("+" + this._data_gain,-8,0,160,40, 'right');
	this.addChild(this._popup);
};

PopMeter.prototype.createLevel = function() {
  this._level = [];
  for (var i = 0; i < 2; i++) {
    var frame = 150 * i;
  	this._level[i] = new Sprite(this._layImg);
    this._level[i].setFrame(frame, 55, 150, 73);
    this._level[i].anchor.x = 0.5;
    this._level[i].anchor.y = 0.5;
    this._level[i].x = this._lay.x + 162;
    this._level[i].y = this._lay.y + 12;
    this._level[i].opacity = 0;
  	this.addChild(this._level[i]);
  }
  this._levelTimer = 90;
  this.playLevelSound();
};

PopMeter.prototype.updateMeter = function(sprite) {
  this._inc_meter = this._meterData[0] + Math.ceil(this._meterData[1] * this._meterIteration);
	sprite.setFrame(0,49,this._inc_meter,6);
  this._meterIteration++;
};

PopMeter.prototype.updateMove = function() {

	switch (this._aniPhase) {
	case 0:
		this.x = globMoveTo(this.x, this._org[1], 6);
    if (this.x == this._org[1]) {
      this._aniPhase = 1;
    }
		break;

	case 1:
    this.updatePopup();
    if (this._meterTimer > 0) {
      this.updateMeter(this._meter);
      this._meterTimer--;
    }
    if (this._meterTimer == 0) {
      if (this._inc_meter >= 134) {
        this._meterTimer = 0;
        this.createLevel();
        this._aniPhase = 2;
      } else {
        this._aniPhase = 3;
      }
    }
		break;

  case 2:
    this.updateLevel();
    this._levelTimer--;
    if (this._levelTimer == 0) {
      this._aniPhase = 3;
    }
    break;

  case 3:
    this.opacity -= 5;
    if (this.opacity == 0) {
      SceneManager._scene.terminatePopMeter();
    }
    break;

	}
};

PopMeter.prototype.playLevelSound = function() {
  AudioManager.playSe({
    name: "SEL-5",
    volume: 80,
    pitch: 100
  });
};

PopMeter.prototype.updateLevel = function() {
  this._level[1].opacity += 20;
  if (this._levelTimer >= 60 && this._levelTimer < 90) {this._level[0].opacity += 20}
  if (this._levelTimer >= 30 && this._levelTimer < 60) {this._level[0].opacity -= 5}
  if (this._levelTimer >= 0 && this._levelTimer < 30) {this._level[0].opacity += 5}
};

PopMeter.prototype.updatePopup = function() {
  this._popup.y = globMoveTo(this._popup.y, this._popup.posOrg[1], 60);
  this._popup.opacity += 10;
};

PopMeter.prototype.update = function() {
  if (!this._lay && this._layImg.isReady()) {this.createSprites(); return}
  if (this._lay) {
    this.updateMove();
  }
};


//=============================================================================
// ** Quote Prompt  ID002
//=============================================================================
function QuoteMap() {
    this.initialize.apply(this, arguments);
};

QuoteMap.prototype = Object.create(Sprite.prototype);
QuoteMap.prototype.constructor = QuoteMap;

QuoteMap.prototype.initialize = function() {
    Sprite.prototype.initialize.call(this);

	this.loadBitmaps();
	this.createSprites();
  this._posX = [-540, 60];
  this._data = null;
  this.y = 180;
	this._speed = 4;
	this._timer = undefined;
  this._active = false;
  this.visible = false;
};

QuoteMap.prototype.loadBitmaps = function() {
	this._layImg = ImageManager.loadOther_Quote("Layout");
	this._faceImg = ImageManager.loadOther_Quote("Face");
};

QuoteMap.prototype.createSprites = function() {
	this.createLayout();
	this.createFace();
	this.createText();
};

QuoteMap.prototype.createLayout = function() {
	this._lay = new Sprite(this._layImg);
	this.addChild(this._lay);
};

QuoteMap.prototype.createFace = function() {
	this._face = new Sprite(this._faceImg);
	this._face.y = this._lay.y + 5;
	this._face.x = this._lay.x + 23;
  this._face.visible = false;
	this.addChild(this._face);
};

QuoteMap.prototype.createText = function() {
	this._text = new Sprite(new Bitmap(600,40));
  this._text.x = this._lay.x + 38;
	this._text.y = this._lay.y + 8;
	this._text.bitmap.fontSize = 18;
	this.addChild(this._text);
};

QuoteMap.prototype.setText = function(sprite, text) {
	sprite.bitmap.clear();
	sprite.bitmap.drawText(text, 0,0,600,40,"left");
  if (this._hasFace) {
    sprite.x = this._lay.x + 188;
  }
};

QuoteMap.prototype.setFace = function(sprite, index) {
	var w = this._faceImg.width;
	var h = this._faceImg.height;
	var i = 50;
  var index = index - 1;
	sprite.setFrame(0, i * index, w, i);
  sprite.visible = true;
};

QuoteMap.prototype.resetQuote = function() {
  this._data = $gameTemp._quoteData[0];
	this.x = this._posX[0];
  this._hasFace = this._data[0] > 0;
	this.setText(this._text, this._data[1]);
	if (this._hasFace) {
    this.setFace(this._face, this._data[0]);
  } else {
    this._face.visible = false;
  }
	this.opacity = 255;
	this._timer = 75;
  this._active = true;
};

QuoteMap.prototype.updateMove = function() {
	this.x = globMoveTo(this.x, this._posX[1], this._speed);
  this.visible = this.isVisible();
};

QuoteMap.prototype.updateTimer = function() {
	if (this._timer > 0) {
		this._timer--;
	}
	if (this._timer == 0) {
    this.opacity -= 10;
    if (this.opacity == 0) {
      this.terminateQuote();
    }
	}
};

QuoteMap.prototype.terminateQuote = function() {
  this._timer = undefined;
  this._active = false;
  this._data = null;
  this.visible = false;
  $gameTemp._quoteData.splice(0, 1);
  SceneManager._scene.checkQuoteAvailability();
};

QuoteMap.prototype.isVisible = function() {
	if ($gameMessage.isBusy()) return false;
  if ($gameTemp._quoteData.length == 0) return false;
	return true;
};

QuoteMap.prototype.update = function() {
  this.updateMove();
  this.updateTimer();
};

//=============================================================================
// ** BattleQuote
//=============================================================================

function BattleQuote() {
    this.initialize.apply(this, arguments);
};

BattleQuote.prototype = Object.create(Sprite.prototype);
BattleQuote.prototype.constructor = BattleQuote;

BattleQuote.prototype.initialize = function() {
    Sprite.prototype.initialize.call(this);

	this.loadBitmaps();
	this.createSprites();
  this._posX = [-540, 60];
  this._posY = [];
  this._data = [];
//  this._posY[0] = 180;
  this.y = 180;
	this._speed = 4;
	this._timer = undefined;
  this._active = [false,false];
  this.visible = false;
};

BattleQuote.prototype.loadBitmaps = function() {
	this._layImg = ImageManager.loadOther_Quote("Layout");
	this._faceImg = ImageManager.loadOther_Quote("Face");
};

BattleQuote.prototype.createSprites = function() {
	this.createLayout();
	this.createFace();
	this.createText();
};

BattleQuote.prototype.createLayout = function() {
	this._lay = new Sprite(this._layImg);
	this.addChild(this._lay);
};

BattleQuote.prototype.createFace = function() {
	this._face = new Sprite(this._faceImg);
	this._face.y = this._lay.y + 5;
	this._face.x = this._lay.x + 23;
  this._face.visible = false;
	this.addChild(this._face);
};

BattleQuote.prototype.createText = function() {
	this._text = new Sprite(new Bitmap(600,40));
  this._text.x = this._lay.x + 38;
	this._text.y = this._lay.y + 8;
	this._text.bitmap.fontSize = 18;
	this.addChild(this._text);
};

BattleQuote.prototype.setText = function(sprite, text) {
	sprite.bitmap.clear();
	sprite.bitmap.drawText(text, 0,0,600,40,"left");
  if (this._hasFace) {
    sprite.x = this._lay.x + 188;
  }
};

BattleQuote.prototype.setFace = function(sprite, index) {
	var w = this._faceImg.width;
	var h = this._faceImg.height;
	var i = 50;
  var index = index - 1;
	sprite.setFrame(0, i * index, w, i);
  sprite.visible = true;
};

BattleQuote.prototype.refreshGab = function() {
	this.x = this._posX[0];
  this.y = 180 + ($gameTemp._quoteIteration.indexOf(this) * 60);
  this._hasFace = this._data[0] > 0;
	this.setText(this._text, this._data[1]);
	if (this._hasFace) {
    this.setFace(this._face, this._data[0]);
  } else {
    this._face.visible = false;
  }
	this.opacity = 255;
	this._timer = 75;
  this._data = [];
};

BattleQuote.prototype.sprite_move_to = function(value,real_value,speed) {
	if (value == real_value) {return value};
	var dnspeed = 5 + (Math.abs(value - real_value) / speed);
	if (value > real_value) {value -= dnspeed;
	    if (value < real_value) {value = real_value};}
    else if (value < real_value) {value  += dnspeed;
    	if (value  > real_value) {value  = real_value};
    };
	return Math.floor(value);
};

BattleQuote.prototype.updateMove = function() {
	this.x = this.sprite_move_to(this.x, this._posX[1], this._speed);
//  this.y = this.sprite_move_to(this.y, this._posY[1], this._speed);
  this.visible = this.isVisible();
};

BattleQuote.prototype.updateTimer = function() {
	if (this._timer > 0) {
		this._timer--;
	}
	if (this._timer == 0) {
    this.opacity -= 10;
    if (this.opacity == 0) {
      this.terminateQuote();
    }
	}
};

BattleQuote.prototype.terminateQuote = function() {
	this._active[1] = false;
  this._timer = undefined;
  this.visible = false;
  $gameTemp._quoteAviID.push(this._id);
  $gameTemp._quoteIteration.shift();
};

BattleQuote.prototype.isVisible = function() {
	if ($gameMessage.isBusy()) return false;
	return true;
};

BattleQuote.prototype.checkUpdate = function() {
  this._active[1] = true;
  this.refreshGab();
};

BattleQuote.prototype.update = function() {
  if (this._active[1]) {
    this.updateMove();
  	this.updateTimer();
  }
	if (this._data.length > 0) this.checkUpdate();
};

//=============================================================================
// ** PagedTutorial  ID003
//=============================================================================

function PagedTutor() {
    this.initialize.apply(this, arguments);
};

PagedTutor.prototype = Object.create(Sprite.prototype);
PagedTutor.prototype.constructor = PagedTutor;

PagedTutor.prototype.initialize = function(data, max, swId) {
    Sprite.prototype.initialize.call(this);

	this.x = 640;
	this.opacity = 0;

	this._data = data;
	this._maxPage = max - 1;
	this._maxLoad = max;
	this.setPathing(this._data, this._maxLoad);

	this._swId = swId;

	this._page = [];
	this._temp = 0;
	this._index = 0;
	this._loaded = 0;
	this._aniPhase = 0;
	this._org = [400, 340, 280];

  this.createLayout();
  $gameTemp.reserveCommonEvent(24);
	SoundManager.playOk();
};

PagedTutor.prototype.setPathing = function(path, max) {
	for (var i = 0; i < max; i++) {
		var bmp = ImageManager.loadOther_Tutorial(path[i]);
		bmp.id = i;
		bmp.addLoadListener(this.launch.bind(this));
	}
};

PagedTutor.prototype.launch = function(bmp) {
	this.createImg(bmp, bmp.id);
	this._loaded++;
};

PagedTutor.prototype.createImg = function(img, id) {
	this._page[id] = new Sprite(img);
	this._page[id].visible = id == 0 ? true : false;
	this._page[id].anchor.x = 0.5;
	this._page[id].anchor.y = 0.5;
  this._page[id].y = 400;
	this.addChild(this._page[id]);
};

PagedTutor.prototype.createLayout = function() {
	this._lay = new Sprite(ImageManager.loadOther_Tutorial('PagedLayout'));
  this._lay.y = 600;
  this._lay.anchor.x = 0.5;
	this.addChild(this._lay);
};

PagedTutor.prototype.sprite_move_to = function(value,real_value, speed) {
	if (value === real_value) {return value};
	var dnspeed = 1 + (Math.abs(value - real_value) / speed);
	if (value > real_value) {value -= dnspeed;
	    if (value < real_value) {value = real_value};}
    else if (value < real_value) {value  += dnspeed;
    	if (value  > real_value) {value  = real_value};
    };
	return Math.floor(value);
};

PagedTutor.prototype.updateMove = function() {

	switch (this._aniPhase) {

	case 0:
		this.opacity += 20;
    for (var i = 0; i < this._page.length; i++) {
      this._page[i].y = this.sprite_move_to(this._page[i].y, this._org[1], 24);
    }

		if (this.opacity >= 255) {
			this._active = true;
			this._aniPhase = 1;
		}
		break;

	case 2:
		this._active = false;
		this.opacity -= 20;
    for (var i = 0; i < this._page.length; i++) {
		    this._page[i].y = this.sprite_move_to(this._page[i].y, this._org[2], 24);
    }
		if (this.opacity == 0) {
			SceneManager._scene.terminatePagedTutor();
		}
		break;

	}
};

PagedTutor.prototype.updateInput = function() {
	if (Input.isTriggered('right') || Input.isTriggered('ok')) {
		this.processInputRight();
	} else if (Input.isTriggered('left')) {
		this.processInputLeft();
	} else if (Input.isTriggered('cancel')) {
		this.processClose();
	}
};

PagedTutor.prototype.processInputRight = function() {
	if (this._index < this._maxPage) {
		this._index++;
		SoundManager.playCursor();
		this.updatePage(this._index);
	}
}

PagedTutor.prototype.processInputLeft = function() {
	if (this._index > 0) {
		this._index--;
		SoundManager.playCursor();
		this.updatePage(this._index);
	}
}

PagedTutor.prototype.processClose = function() {
	this._aniPhase = 2;
	SoundManager.playOk();
  $gameTemp.reserveCommonEvent(25);
  if (this._swId) $gameTemp.reserveCommonEvent(this._swId);
}

PagedTutor.prototype.updatePage = function(id) {
	this._page[id].visible = true;
	this._page[this._temp].visible = false;
	this._temp = id;
}

PagedTutor.prototype.update = function() {
	if (this._loaded !== this._maxLoad) {return};
	this.updateMove();
	if (this._active) {this.updateInput()};
};

//=============================================================================
// ** Objective  ID004
//=============================================================================
function Objective() {
    this.initialize.apply(this, arguments);
};

Objective.prototype = Object.create(Sprite.prototype);
Objective.prototype.constructor = Objective;

Objective.prototype.initialize = function() {
    Sprite.prototype.initialize.call(this);

	this.loadBitmaps();
	this.createSprites();
	this.x = 25;
	this.y = 63;
  this.opacity = 0;
};

Objective.prototype.loadBitmaps = function() {
	this._layImg = ImageManager.loadOther_Overworld("Objective");
};

Objective.prototype.createSprites = function() {
  this.createBox();
	this.createObj();
	this.createText();
};

Objective.prototype.createObj = function() {
	this._lay = new Sprite(this._layImg);
  this._lay.x = this._box.x - 18;
  this._lay.y = this._box.y - 51;
  this._lay.setFrame(0,0,320,50);
	this.addChild(this._lay);
};

Objective.prototype.createBox = function() {
	this._box = new Sprite(this._layImg);
  this._box.setFrame(0,50,320,50);
  this._box.anchor.y = 0.5;
	this.addChild(this._box);
};

Objective.prototype.createText = function() {
	this._text = new Sprite(new Bitmap(300,40));
	this._text.x = this._box.x + 10;
	this._text.y = this._box.y - 21;
	this._text.bitmap.fontSize = 16;
  this._text.bitmap.fontFace = 'FredokaSemi';
  this._text.bitmap.textColor = '#f57ac8';
	this.addChild(this._text);
};

Objective.prototype.setText = function(sprite, text) {
	sprite.bitmap.clear();
  sprite.bitmap.drawText(text,0,0,300,40,'center');
};

Objective.prototype.updateVisibility = function() {
  if (this.needFade()) {
    this.opacity -= 25;
    if (this._box.scale.y > 0) this._box.scale.y -= 0.1;
  } else {
    this.opacity += 25;
    if (this._box.scale.y < 1) this._box.scale.y += 0.1;
  }
};

Objective.prototype.refresh = function() {
	this.setText(this._text, $gameSystem._objectiveText);
};

Objective.prototype.needFade = function() {
  if (!$gameSystem._objHudVisible) {return true};
	if (!$gamePlayer.canMove()) {return true};
	return false;
};

Objective.prototype.update = function() {
	this.refresh();
  this.updateVisibility();
};



//=============================================================================
// ** AP indicator  ID004
//=============================================================================
function Panel_AP() {
    this.initialize.apply(this, arguments);
};

Panel_AP.prototype = Object.create(Sprite.prototype);
Panel_AP.prototype.constructor = Panel_AP;

Panel_AP.prototype.initialize = function() {
    Sprite.prototype.initialize.call(this);

	this.loadBitmaps();
	this.createSprites();
	this.x = 963;
	this.y = 15;
  this.opacity = 0;
};

Panel_AP.prototype.loadBitmaps = function() {
	this._layImg = ImageManager.loadOther_Overworld("Panel");
};

Panel_AP.prototype.createSprites = function() {
	this.createLayout();
	this.createText();
  this.createMaxText();
};

Panel_AP.prototype.createLayout = function() {
	this._lay = new Sprite(this._layImg);
  this._lay.setFrame(0,0,150,36);
	this.addChild(this._lay);
};

Panel_AP.prototype.createText = function() {
	this._text = new Sprite(new Bitmap(200,40));
	this._text.x = this._lay.x - 116;
	this._text.y = this._lay.y - 5;
	this._text.bitmap.fontSize = 20;
  this._text.bitmap.fontFace = 'FredokaBold';
  this._text.bitmap.textColor = this.setColor();
	this.addChild(this._text);
};

Panel_AP.prototype.createMaxText = function() {
	this._maxText = new Sprite(new Bitmap(200,40));
	this._maxText.x = this._text.x + 220;
	this._maxText.y = this._text.y;
	this._maxText.bitmap.fontSize = 20;
  this._maxText.bitmap.fontFace = 'FredokaBold';
  this._maxText.bitmap.textColor = '#f57ac8';
	this.addChild(this._maxText);
};

Panel_AP.prototype.setText = function(sprite, text, type) {
	sprite.bitmap.clear();
  if (type == 1) {sprite.bitmap.drawText(text,0,0,200,40,'right')};
  if (type == 2) {sprite.bitmap.drawText(text,0,0,200,40,'left')};
};

Panel_AP.prototype.setColor = function() {
  var rate = $gameSystem._partyAPCur / $gameSystem._partyAPMax;
  if (rate > 0.5) return '#6cd140';
  if (rate > 0.1 && rate <= 0.5) return '#e7dc33';
  if (rate <= 0.1) return '#e26f6f';
};

Panel_AP.prototype.updateVisibility = function() {
  if (this.needFade()) {
    this.opacity -= 25;
  } else {
    this.opacity += 25;
  }
};

Panel_AP.prototype.refresh = function() {
	this.setText(this._text, $gameSystem._partyAPCur, 1);
  this.setText(this._maxText, $gameSystem._partyAPMax, 2);
  this._text.bitmap.textColor = this.setColor();
  this.x = $gameSystem._clientPanelVisible ? 963 : 1113;
};

Panel_AP.prototype.needFade = function() {
  if (!$gameSystem._apPanelVisible) {return true};
	if (!$gamePlayer.canMove()) {return true};
	return false;
};

Panel_AP.prototype.update = function() {
	this.refresh();
  this.updateVisibility();
};


//=============================================================================
// ** Client Panel  ID009
//=============================================================================
function Panel_Client() {
    this.initialize.apply(this, arguments);
};

Panel_Client.prototype = Object.create(Sprite.prototype);
Panel_Client.prototype.constructor = Panel_Client;

Panel_Client.prototype.initialize = function() {
    Sprite.prototype.initialize.call(this);

	this.loadBitmaps();
	this.createSprites();
	this.x = 1113;
	this.y = 15;
  this.opacity = 0;
  this._timerSec = $gameSystem._client_nextTimer;
};

Panel_Client.prototype.loadBitmaps = function() {
	this._layImg = ImageManager.loadOther_Overworld("Panel");
};

Panel_Client.prototype.createSprites = function() {
	this.createLayout();
	this.createTimer();
  this.createClientNum();
};

Panel_Client.prototype.createLayout = function() {
	this._lay = new Sprite(this._layImg);
  this._lay.setFrame(0,36,150,36);
	this.addChild(this._lay);
};

Panel_Client.prototype.createClientNum = function() {
	this._num = new Sprite(new Bitmap(200,40));
	this._num.x = this._lay.x - 43;
	this._num.y = this._lay.y - 5;
	this._num.bitmap.fontSize = 20;
  this._num.bitmap.fontFace = 'FredokaBold';
  this._num.bitmap.textColor = '#f57ac8';
	this.addChild(this._num);
};

Panel_Client.prototype.createTimer = function() {
	this._text = new Sprite(new Bitmap(200,40));
	this._text.x = this._lay.x + 9;
	this._text.y = this._lay.y - 5;
	this._text.bitmap.fontSize = 20;
  this._text.bitmap.fontFace = 'FredokaBold';
  this._text.bitmap.textColor = '#f57ac8';
	this.addChild(this._text);
};

Panel_Client.prototype.refreshText = function() {
  var a = Math.floor (this._timerSec / 60);
  var sec = a % 60;
  var min = Math.floor(a / 60)
  var text = min.padZero(2) + ":" + sec.padZero(2);
  this._text.bitmap.clear();
	this._text.bitmap.drawText(text,0,0,200,40,'center');

  var num = $gameSystem._client_ready.length;
  this._num.bitmap.clear();
  this._num.bitmap.drawText(num,0,0,200,40,'center');
};

Panel_Client.prototype.updateSec = function() {
  if (this._timerSec !== $gameSystem._client_nextTimer) this._timerSec = $gameSystem._client_nextTimer;
};

Panel_Client.prototype.updateVisibility = function() {
  if (this.needFade()) {
    this.opacity -= 25;
  } else {
    this.opacity += 25;
  }
};

Panel_Client.prototype.needFade = function() {
  if (!$gameSystem._clientPanelVisible) {return true};
	if (!$gamePlayer.canMove()) {return true};
	return false;
};

Panel_Client.prototype.update = function() {
  this.updateSec();
	this.refreshText();
  this.updateVisibility();
};


//=============================================================================
// ** Shortcut log  ID005
//=============================================================================
function ShortcutLog() {
    this.initialize.apply(this, arguments);
};

ShortcutLog.prototype = Object.create(Sprite.prototype);
ShortcutLog.prototype.constructor = ShortcutLog;

ShortcutLog.prototype.initialize = function() {
    Sprite.prototype.initialize.call(this);

	this.loadBitmaps();
	this.createSprites();
	this.x = 848;
	this.y = 685;
  this.opacity = 0;
  this._translucent = 75;
  this._wait = [0,30];
};

ShortcutLog.prototype.loadBitmaps = function() {
	this._img = ImageManager.loadOther_Overworld("Shortcut");
};

ShortcutLog.prototype.createSprites = function() {
  this._lay = new Sprite(this._img);
	this.addChild(this._lay);
};

ShortcutLog.prototype.updateVisibility = function() {
  if (this.needFade()) {
    this.opacity -= 25;
//    if (this.opacity <= this._translucent) {
//      this.opacity = this._translucent;
//    }
  } else {
    this.opacity += 25;
  }
};

ShortcutLog.prototype.needFade = function() {
  if (!$gameSystem._shortcutVisible) {return true};
  if (this._wait[0] !== this._wait[1]) {return true};
	if (!$gamePlayer.canMove()) {return true};
	return false;
};

ShortcutLog.prototype.updateWait = function() {
  if (this._wait[0] < this._wait[1]) {
    if (!$gamePlayer.isMoving()) {
      this._wait[0]++;
    }
  }
  if ($gamePlayer.isMoving()) {
    this._wait[0] = 0;
  }
};

ShortcutLog.prototype.update = function() {
  this.updateWait();
  this.updateVisibility();
};

//=============================================================================
// ** ID006 Debug Stat
//=============================================================================
function DebugStat() {
    this.initialize.apply(this, arguments);
};

DebugStat.prototype = Object.create(Sprite.prototype);
DebugStat.prototype.constructor = DebugStat;

DebugStat.prototype.initialize = function() {
    Sprite.prototype.initialize.call(this);
	var id = $gameSystem._debugId;
	var unit = $gameActors.actor(id);
	this._var = [];
  this._var[0] = unit.name();
  this._var[1] = "pregnancy : " + unit.pregnancy;
  this._var[2] = "pregphase : " + unit.pregphase;
  this._var[3] = "fetusphase : " + unit.fetusphase;
  this._var[4] = "babies : " + unit.babies;
  this._var[5] = "bellysize : " + unit.bellysize;
  this._var[6] = "milk : " + unit.milk + ' / ' + unit.mmilk;
  this._var[7] = "milksize : " + unit.milksize;
  this._var[8] = "stamina : " + unit.stam + ' / ' + unit.maxstam;
  this._var[9] = "lewdlevel : " + unit.lewdlevel;
  this._var[10] = "lewdexp : " + unit.lewdexp;
  this._var[11] = "horny : " + unit.horny;
  this._var[12] = "ejacpoint : " + unit.ejacpoint + ' / ' + unit._prevEJP;
  this._var[13] = "preggrowth : " + unit.preggrowth;
  this._var[14] = "milkspeed : " + unit.milkspeed;
  this._var[15] = "blessing1 : " + unit.blessing1;
  this._var[16] = "blessing2 : " + unit.blessing2;
  this._var[17] = "blessing3 : " + unit.blessing3;
  this._var[18] = "blessing4 : " + unit.blessing4;
  this._var[19] = "mp1 : " + unit.mp1;
  this._var[20] = "mp2 : " + unit.mp2;
  this._var[21] = "resist : " + unit.resist;
	this.createSprites();
};

DebugStat.prototype.createSprites = function() {
	this.x = 1020;
	this.y = 20;
  this.createLayout();
  this.createName();
	this.createNumber();
	if (this.needHide()) {this.opacity = 0};
};

DebugStat.prototype.createLayout = function() {
     this._layout = new Sprite(ImageManager.loadOther_Overworld("DebugStat"));
	 this.addChild(this._layout);
};

DebugStat.prototype.createName = function() {
		this._name = new Sprite(new Bitmap(200,60));
		this._name.x = this._layout.x + 20;
		this._name.y = this._layout.y;
		this._name.bitmap.fontSize = 30;
		this._name.bitmap.drawText(this._var[0],0,0,200,60,"left");
		this.addChild(this._name);
};

DebugStat.prototype.createNumber = function() {
	this._number = [];
	for (i = 1; i < this._var.length - 1; i++) {
		this._number[i] = new Sprite(new Bitmap(200,60));
		this._number[i].x = this._layout.x + 20;
		this._number[i].y = this._layout.y + 25 + (30 * i);
		this._number[i].bitmap.fontSize = 18;
		this.addChild(this._number[i]);
		this._number[i].bitmap.drawText(this._var[i],0,0,200,60,"left");
	}
};

DebugStat.prototype.refreshNumber = function(index) {
	this._number[index].bitmap.clear();
	this._number[index].bitmap.drawText(this._var[index],0,0,200,60,"left");
};

DebugStat.prototype.needHide = function() {
	if (!$gameSystem._debugStatVisible) {return true};
	return false
};

DebugStat.prototype.updateVisible = function() {
    if (this.needHide()) {
		this.opacity = 0;
	} else {
		this.opacity = 255;
	};
};

DebugStat.prototype.updateNumber = function() {
	if (this.opacity > 0) {
		var id = $gameSystem._debugId;
		var unit = $gameActors.actor(id);
    this._var[0] = unit.name();
  	this._var[1] = "pregnancy : " + unit.pregnancy;
  	this._var[2] = "pregphase : " + unit.pregphase;
  	this._var[3] = "fetusphase : " + unit.fetusphase;
  	this._var[4] = "babies : " + unit.babies;
  	this._var[5] = "bellysize : " + unit.bellysize;
  	this._var[6] = "milk : " + unit.milk + ' / ' + unit.mmilk;
    this._var[7] = "milksize : " + unit.milksize;
  	this._var[8] = "stamina : " + unit.stam + ' / ' + unit.maxstam;
    this._var[9] = "lewdlevel : " + unit.lewdlevel;
    this._var[10] = "lewdexp : " + unit.lewdexp;
  	this._var[11] = "horny : " + unit.horny;
  	this._var[12] = "ejacpoint : " + unit.ejacpoint + ' / ' + unit._prevEJP;
    this._var[13] = "preggrowth : " + unit.preggrowth;
  	this._var[14] = "milkspeed : " + unit.milkspeed;
    this._var[15] = "blessing1 : " + unit.blessing1;
    this._var[16] = "blessing2 : " + unit.blessing2;
    this._var[17] = "blessing3 : " + unit.blessing3;
    this._var[18] = "blessing4 : " + unit.blessing4;
    this._var[19] = "mp1 : " + unit.mp1;
    this._var[20] = "mp2 : " + unit.mp2;
    this._var[21] = "resist : " + unit.resist;
		for (i = 1; i < this._number.length; i++) {
			this.refreshNumber(i);
		}
		this._name.bitmap.clear();
		this._name.bitmap.drawText(this._var[0],0,0,200,60,"left");
	}
};

DebugStat.prototype.update = function() {
	this.updateVisible();
	this.updateNumber();
};

//=============================================================================
// ** ID007 Debug Stat (other)
//=============================================================================
function DebugStat2() {
    this.initialize.apply(this, arguments);
};

DebugStat2.prototype = Object.create(Sprite.prototype);
DebugStat2.prototype.constructor = DebugStat2;

DebugStat2.prototype.initialize = function() {
  Sprite.prototype.initialize.call(this);

  this.x = 30;
  this.y = 120;
	this._var = [];

  // data you want to show
	this._var[0] = '';
	this._var[1] = '';
	this._var[2] = '';
  this._var[3] = '';
  this._var[4] = '';
	this.createSprites();
};

DebugStat2.prototype.createSprites = function() {
   this.createLayout();
	 this.createNumber();
	 if (this.needHide()) {this.opacity = 0};
};

DebugStat2.prototype.createLayout = function() {
  this._layout = new Sprite(ImageManager.loadOther_Overworld("DebugStat2"));
	this.addChild(this._layout);
};

DebugStat2.prototype.createNumber = function() {
	this._number = [];
	for (i = 0; i < this._var.length; i++) {
		this._number[i] = new Sprite(new Bitmap(200,60));
		this._number[i].x = this._layout.x + 20;
		this._number[i].y = this._layout.y + 0 + (30 * i);
		this._number[i].bitmap.fontSize = 18;
		this.addChild(this._number[i]);
		this._number[i].bitmap.drawText(this._var[i],0,0,200,60,"left");
	}
};

DebugStat2.prototype.refreshNumber = function(index) {
	this._number[index].bitmap.clear();
	this._number[index].bitmap.drawText(this._var[index],0,0,200,60,"left");
};

DebugStat2.prototype.needHide = function() {
	if (!$gameSystem._debugStat2Visible) {return true};
	return false
};

DebugStat2.prototype.updateVisible = function() {
    if (this.needHide()) {
		this.opacity -= 20;
	} else {
		this.opacity += 20;
	};
};

DebugStat2.prototype.updateNumber = function() {
	if (this.opacity > 0) {
    this._var[0] = $gameSystem._client_pool.length;
    this._var[1] = $gameSystem._client_ready.length;
		for (i = 0; i < this._number.length; i++) {
			this.refreshNumber(i);
		}
	}
};

DebugStat2.prototype.update = function() {
	this.updateVisible();
	this.updateNumber();
};


//=============================================================================
// ** ID008 MessageBox
//=============================================================================
function MessageBox() {
    this.initialize.apply(this, arguments);
};

MessageBox.prototype = Object.create(Sprite.prototype);
MessageBox.prototype.constructor = MessageBox;

MessageBox.prototype.initialize = function() {
  Sprite.prototype.initialize.call(this);

  this.x = Graphics.boxWidth / 2;
  this.y = 632;
  this.opacity = 0;
  this.type = 0;

	this.createSprites();
  this.createFF();
};

MessageBox.prototype.createSprites = function() {
  this._sprite = new Sprite();
  this._sprite.anchor.x = 0.5;
  this._sprite.anchor.y = 0.5;
	this.addChild(this._sprite);
  this.setType(this.type);
};

MessageBox.prototype.createFF = function() {
  this._ff = new Sprite(ImageManager.loadOther_Overworld('Message_FF'));
  this._ff.x = -65;
  this._ff.y = -75;
  this._ff.anchor.x = 0.5;
  this._ff.anchor.y = 0.5;
  this._ff.visible = false;
	this.addChild(this._ff);
};

MessageBox.prototype.needHide = function() {
	if (!$gameTemp._msgBoxVisible) {return true};
	return false
};

MessageBox.prototype.FFvisibility = function() {
	if ($gameSystem._fastForward) return true;
	return false
};

MessageBox.prototype.setType = function(type) {
	this.type = type;
  this._sprite.bitmap = ImageManager.loadOther_Overworld('Message_' + this.type);
};

MessageBox.prototype.updateVisible = function() {
  if (this.needHide()) {
		this.opacity -= 13;
	} else {
		this.opacity += 13;
	}
  this._ff.visible = this.FFvisibility();
};

MessageBox.prototype.update = function() {
	this.updateVisible();
};

//=============================================================================
// ** EnemyAlert  ID010
//=============================================================================
function EnemyAlert() {
    this.initialize.apply(this, arguments);
};

EnemyAlert.prototype = Object.create(Sprite.prototype);
EnemyAlert.prototype.constructor = EnemyAlert;

EnemyAlert.prototype.initialize = function() {
    Sprite.prototype.initialize.call(this);

	this.loadBitmaps();
  this.opacity = 0;
  this._timer = [0, 60];
	this.createSprites();
};

EnemyAlert.prototype.loadBitmaps = function() {
	this._spr = ImageManager.loadOther_Overworld("Alert");
};

EnemyAlert.prototype.createSprites = function() {
	this._lay = new Sprite(this._spr);
	this.addChild(this._lay);
};

EnemyAlert.prototype.updateOpc = function() {
  if (!this.needFade()) {
    this.opacity += this._timer[0] < (this._timer[1] / 2) ? 9 : -9;
    this._timer[0]++;
    if (this._timer[0] == this._timer[1]) this._timer[0] = 0;
  };
};

EnemyAlert.prototype.updateVisibility = function() {
  if ($gameTemp._alerted) {
    this.visible = true;
  } else {
    this.visible = false;
  }
};

EnemyAlert.prototype.needFade = function() {
  if (this.visible) return false
	return true;
};

EnemyAlert.prototype.update = function() {
  this.updateOpc();
  this.updateVisibility();
};

//=============================================================================
// ** Event Log  ID011
//=============================================================================
function EventLog() {
    this.initialize.apply(this, arguments);
};

EventLog.prototype = Object.create(Sprite.prototype);
EventLog.prototype.constructor = EventLog;

EventLog.prototype.initialize = function(index, data) {
    Sprite.prototype.initialize.call(this);

	this.loadBitmaps();
	this._timer = 240;
  this._phase = 0;
  this._data = data;
  this._index = index;
  this._wait = 10 * index;
  this._sound = true;
  this.x = -600;
  this.y = 696 - (25 * this._index);
};

EventLog.prototype.loadBitmaps = function() {
	this._layImg = ImageManager.loadOther_Overworld("Log");
};

EventLog.prototype.createSprites = function() {
  this.createField();
	this.createLayout();
	this.createText();
};

EventLog.prototype.createField = function() {
	this._field = new Sprite();
	this.addChild(this._field);
};

EventLog.prototype.createLayout = function() {
	this._lay = new Sprite(this._layImg);
	this._field.addChild(this._lay);
};

EventLog.prototype.createText = function() {
	this._text = new Sprite(new Bitmap(600,40));
  this._text.x = this._lay.x + 64;
	this._text.y = this._lay.y - 7;
	this._text.bitmap.fontSize = 14;
  this._text.bitmap.fontFace = "FredokaSemi";
  this._text.bitmap.textColor = "#f57ac8";
	this._field.addChild(this._text);
  this._text.bitmap.drawText(this._data,0,0,600,40);
};

EventLog.prototype.sprite_move_to = function(value,real_value,speed) {
	if (value == real_value) {return value};
	var dnspeed = 5 + (Math.abs(value - real_value) / speed);
	if (value > real_value) {value -= dnspeed;
	    if (value < real_value) {value = real_value};}
    else if (value < real_value) {value  += dnspeed;
    	if (value  > real_value) {value  = real_value};
    };
	return Math.floor(value);
};

EventLog.prototype.playSound = function() {
  AudioManager.playSe({
    name: "clicky",
    volume: 20,
    pitch: 150
  });
  this._sound = false;
};

EventLog.prototype.updatePhase = function() {
  if (this._wait > 0) {this._wait--; return};
  if (this._sound) {this.playSound()};
  switch (this._phase) {
    case 0:
      this.updatePos();
      this.updateTimer();
      break;

    case 1:
      this.updateOpc();
      break;
  }
};

EventLog.prototype.updatePos = function() {
	this.x = this.sprite_move_to(this.x, 0, 4);
};

EventLog.prototype.updateTimer = function() {
	if (this._timer > 0) this._timer--;
	if (this._timer == 0) this._phase = 1;
};

EventLog.prototype.updateOpc = function() {
	this.opacity -= 10;
	if (this.opacity == 0) {
    this.terminateLog();
	}
};

EventLog.prototype.terminateLog = function() {
  SceneManager._scene.removeEventLog(this);
};

EventLog.prototype.isVisible = function() {
	if ($gameMessage.isBusy()) return false;
	return true;
};

EventLog.prototype.update = function() {
  this.visible = this.isVisible();
  if (!this._lay && this._layImg.isReady()) {
    this.createSprites();
    return;
  }
  if (this._field) {
    this.updatePhase();
  }
};
