//=============================================================================
// MOG_BattleCommands.js                      (Template - 2)
//=============================================================================

/*:
 * @plugindesc (v1.3 *) Comandos de batalhas animados por imagens.
 * @author Moghunter
 *
 * @param -> MAIN <<<<<<<<<<<<<<<<<<<<<<<
 * @desc
 *
 * @param Mode
 * @parent -> MAIN <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição do tipo de comando.
 * 0 - Normal     1 - Ring Command
 * @default 1
 * @type select
 * @option (0) Normal
 * @value 0
 * @option (1) Ring Command
 * @value 1
 *
 * @param Row Max
 * @parent -> MAIN <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição da quantidade comandos visíveis.
 * @default 4
 *
 * @param Side Input
 * @parent -> MAIN <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Ativar Input para o lado direito e esquerdo.
 * @default true
 * @type boolean
 *
 * @param
 *
 * @param -> POSITION <<<<<<<<<<<<<<<<<<<<<<<
 * @desc
 *
 * @param Com X-axis
 * @parent -> POSITION <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição X-Axis da imagem.
 * @default 0
 *
 * @param Com Y-axis
 * @parent -> POSITION <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição Y-Axis da imagem.
 * @default 0
 *
 * @param Layout X-axis
 * @parent -> POSITION <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição X-Axis da imagem.
 * @default 22
 *
 * @param Layout Y-axis
 * @parent -> POSITION <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição Y-Axis da imagem.
 * @default 15
 *
 * @param
 *
 * @param -> COMMAND NAME <<<<<<<<<<<<<<<<<<<<<<<
 * @desc
 *
 * @param Com Name
 * @parent -> COMMAND NAME <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Ativar o nome do comando.
 * @default true
 * @type boolean
 *
 * @param Com Name X-axis
 * @parent -> COMMAND NAME <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição X-Axis do nome.
 * @default 55
 *
 * @param Com Name Y-axis
 * @parent -> COMMAND NAME <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição Y-Axis do nome.
 * @default 75
 *
 * @param Com Font Size
 * @parent -> COMMAND NAME <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição do tamanho da fonte.
 * @default 22
 *
 * @param
 *
 * @param -> CURSOR <<<<<<<<<<<<<<<<<<<<<<<
 * @desc
 *
 * @param Cursor
 * @parent -> CURSOR <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Ativar cursor.
 * @default true
 * @type boolean
 *
 * @param Cursor X-axis
 * @parent -> CURSOR <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição X-Axis do cursor.
 * @default 0
 *
 * @param Cursor Y-axis
 * @parent -> CURSOR <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição X-Axis do cursor.
 * @default 0
 *
 * @param Cursor Slide
 * @parent -> CURSOR <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Ativar a animação de deslize.
 * @default true
 * @type boolean
 *
 * @param
 *
 * @param -> FACE <<<<<<<<<<<<<<<<<<<<<<<
 * @desc
 *
 * @param Face
 * @parent -> FACE <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Apresentar Face.
 * @default true
 * @type boolean
 *
 * @param Face X-axis
 * @parent -> FACE <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição X-Axis da face do personagem.
 * @default 0
 *
 * @param Face Y-axis
 * @parent -> FACE <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição Y-Axis da face do personagem.
 * @default -50
 *
 * @param
 *
 * @param -> SLIDE ANIMATION <<<<<<<<<<<<<<<<<<<<<<<
 * @desc
 *
 * @param Slide Animation
 * @parent -> SLIDE ANIMATION <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Ativar animação de deslize.
 * @default false
 * @type boolean
 *
 * @param Slide X
 * @parent -> SLIDE ANIMATION <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição da distância X.
 * @default 0
 *
 * @param Slide Y
 * @parent -> SLIDE ANIMATION <<<<<<<<<<<<<<<<<<<<<<<
 * @desc Definição da distância Y.
 * @default 0
 *
 * @help
 * =============================================================================
 * +++ MOG - Battle Commands (v1.3) +++
 * By Moghunter
 * https://mogplugins.wordpress.com
 * =============================================================================
 * Comandos de batalhas animados por imagens.
 * Este plugin requer o MOG_BattleHud para funcionar.
 *
 * =============================================================================
 * - REQUIRED FILES
 * =============================================================================

 * As imagens dos comandos deverão ser gravados na pasta /img/battlecommands/
 * O nomes das imagens deverão seguir a seguinte nomeação.
 *
 * Com_ + COMMAND NAME.png
 *
 * Exemplo
 *
 * -> Com_Attack.png
 * -> Com_Guard.png
 * -> Com_Magic.png
 * ...
 *
 * =============================================================================
 * - FACES
 * =============================================================================
 * Para definir as faces dos personagens nomeie da seguinte forma.
 *
 * Face_ + Actor ID.png
 *
 * EG
 *
 * -> Face_1.png
 * -> Face_2.png
 * -> Face_3.png
 * -> ...
 *
 * ============================================================================
 * - WHAT'S  NEW (version 1.3)
 * ============================================================================
 * - (NEW) - Plugins parameters compatíveis com RM1.5+
 * - (BUG FIX) - Correção da posição da janela no modo Ring Command.
 */

//=============================================================================
// ** PLUGIN PARAMETERS
//=============================================================================
　　var Imported = Imported || {};
　　Imported.MOG_BattleCommands = true;
　　var Moghunter = Moghunter || {};

    Moghunter.parameters = PluginManager.parameters('MOG_BattleCommands');
	Moghunter.bcom_mode = Number(Moghunter.parameters['Mode'] || 0);
    Moghunter.bcom_lay_x = Number(Moghunter.parameters['Layout X-axis'] || -45);
    Moghunter.bcom_lay_y = Number(Moghunter.parameters['Layout Y-axis'] || -25);
	Moghunter.bcom_com_x = Number(Moghunter.parameters['Com X-axis'] || -10);
	Moghunter.bcom_com_y = Number(Moghunter.parameters['Com Y-axis'] || 0);
	Moghunter.bcom_row_max = Number(Moghunter.parameters['Row Max'] || 4);
	Moghunter.bcom_slide_effect = String(Moghunter.parameters['Slide Animation'] || true);
	Moghunter.bcom_slide_x = Number(Moghunter.parameters['Slide X'] || 30);
	Moghunter.bcom_slide_y = Number(Moghunter.parameters['Slide Y'] || 0);
	Moghunter.bcom_com_name = String(Moghunter.parameters['Com Name'] || false);
	Moghunter.bcom_com_name_x = Number(Moghunter.parameters['Com Name X-axis'] || 55);
	Moghunter.bcom_com_name_y = Number(Moghunter.parameters['Com Name Y-axis'] || 75);
	Moghunter.bcom_com_font_size = Number(Moghunter.parameters['Com Font Size'] || 22);
	Moghunter.bcom_side_input = String(Moghunter.parameters['Side Input'] || true);
    Moghunter.bcom_cursor = String(Moghunter.parameters['Cursor'] || true);
    Moghunter.bcom_cursor_x = Number(Moghunter.parameters['Cursor X-axis'] || 0);
    Moghunter.bcom_cursor_y = Number(Moghunter.parameters['Cursor Y-axis'] || 0);
    Moghunter.bcom_cursor_slide = String(Moghunter.parameters['Cursor Slide'] || true);
    Moghunter.bcom_face = String(Moghunter.parameters['Face'] || true);
    Moghunter.bcom_face_x = Number(Moghunter.parameters['Face X-axis'] || 0);
    Moghunter.bcom_face_y = Number(Moghunter.parameters['Face Y-axis'] || -50);

if (Imported.MOG_BattleHud) {
//=============================================================================
// ** ImageManager
//=============================================================================

//==============================
// * BHud
//==============================
ImageManager.loadBcom = function(filename) {
    return this.loadBitmap('img/hud_battlecom/', filename, 0, true);
};

//=============================================================================
// ** Game_Temp
//=============================================================================

//==============================
// * Initialize
//==============================
var _alias_mog_bcom_temp_initialize = Game_Temp.prototype.initialize;
Game_Temp.prototype.initialize = function() {
	_alias_mog_bcom_temp_initialize.call(this);
	this._bcom_need_refresh = false;
};

//=============================================================================
// ** Game_Interpreter
//=============================================================================

//==============================
// * Command129
//==============================
var _alias_mog_bcom_command129 = Game_Interpreter.prototype.command129;
Game_Interpreter.prototype.command129 = function() {
	_alias_mog_bcom_command129.call(this);
	$gameTemp._bcom_need_refresh = true;
	return true;
};

//=============================================================================
// ** Window Command
//=============================================================================

//==============================
// * Setup
//==============================
var _mog_batCom_Wact_setup = Window_ActorCommand.prototype.setup;
Window_ActorCommand.prototype.setup = function(actor) {
    _mog_batCom_Wact_setup.call(this,actor);
	if (!this._hudField) {this.create_hudfield()}
	if (this._actor) {this.battle_commands_initialize()};
};

//==============================
// * Battle Com Initialize
//==============================
Window_ActorCommand.prototype.battle_commands_initialize = function() {
	this._oldID = -1;
	if (!this._actor) {this.clearComSprites();return};
	this._oldID = this._actor._actorId;
    this.com_pic_initialize();
	this.load_com_images();
	this.create_com_sprites();
    this.refresh_com_sprites();
	this._old_visible = this.visible;
};

//==============================
// * clear Com Sprites
//==============================
Window_ActorCommand.prototype.clearComSprites = function() {
    if (this._com_sprites) {this.com_sprites_clear();this._com_sprites = null};
};

//==============================
// * Load Com Images
//==============================
Window_ActorCommand.prototype.com_pic_initialize = function() {
	this.com_sprites_clear();
	this._com_mode_b = Math.min(Math.max(Moghunter.bcom_mode,0),1);
    this._com_sprites = [];
    this._incom_sprites = [];
	this._com_index = this._index;
	this._max_com = 0;
	this._wh = [0,0];
	this._np = [0,0];
	this.sel_time = 0;
	this._side = [];
	this._side_m = [0,0];
	if (String(Moghunter.bcom_slide_effect) === "true" && this._com_mode_b != 1) {this._side_m = [Moghunter.bcom_slide_x, Moghunter.bcom_slide_y]};
	this._row_max = Math.max(Moghunter.bcom_row_max - 1,1)
};

//==============================
// * Com Sprites Clear
//==============================
Window_ActorCommand.prototype.com_sprites_clear = function() {
	if (this._com_sprites) {
		for (var i = 0; i < this._com_sprites.length; i++) {
			 this._hudField.removeChild(this._com_sprites[i]);
			 this._hudField.removeChild(this._incom_sprites[i]);
		};
	};
};

//==============================
// * Load Com Images
//==============================
Window_ActorCommand.prototype.load_com_images = function() {
	this._com_images = [];
	this._incom_images = [];
	for (var i = 0; i < this._list.length; i++) {
		 if (this._max_com < this._list.length) {this._max_com = this._list.length}
		 for (var r = 0; r < this._list.length; r++) {
		      this._com_images.push(ImageManager.loadBcom("Com_" + this._list[r].name));
		      this._incom_images.push(ImageManager.loadBcom("InCom_" + this._list[r].name));
		 };
	};
};

Window_ActorCommand.prototype.create_hudfield = function() {
	this._hudField = new Sprite();
	this.addChild(this._hudField);
};

//==============================
// * Create Com Sprites
//==============================
Window_ActorCommand.prototype.create_com_sprites = function() {
	this.create_inactive_commands();
  this.create_commands();
};

//==============================
// * Create Commands
//==============================
Window_ActorCommand.prototype.create_commands = function() {
	for (var i = 0; i < this._max_com; i++) {
		 this._com_sprites[i] = new Sprite();
		 this._com_sprites[i].enabled = this.isCommandEnabled(i);
		 this._com_sprites[i].anchor.x = 0.5;
		 this._com_sprites[i].anchor.y = 0.5;
		 this._com_sprites[i].x = Moghunter.bcom_com_x;
		 this._com_sprites[i].y = (66 * i) + Moghunter.bcom_com_y;
		 this._hudField.addChild(this._com_sprites[i]);
		 this._side[i] = [0,0];
	};
};

//==============================
// * Create Inactive Commands
//==============================
Window_ActorCommand.prototype.create_inactive_commands = function() {
	for (var i = 0; i < this._max_com; i++) {
		 this._incom_sprites[i] = new Sprite();
		 this._incom_sprites[i].enabled = this.isCommandEnabled(i);
		 this._incom_sprites[i].anchor.x = 0.5;
		 this._incom_sprites[i].anchor.y = 0.5;
		 this._incom_sprites[i].x = Moghunter.bcom_com_x - 109;
		 this._incom_sprites[i].y = (66 * i) + Moghunter.bcom_com_y;
		 this._hudField.addChild(this._incom_sprites[i]);
	};
};

//==============================
// * Refresh Index
//==============================
Window_ActorCommand.prototype.refresh_index = function() {
	this._com_index = this._index;
};

//==============================
// * Refresh Com Sprites
//==============================
Window_ActorCommand.prototype.refresh_com_sprites = function() {
	this._com_index = -1;
	this._wh = [0,0];
    this.refresh_bitmap_com();
	this.position_clear();
	this.update_battle_commands();
};

//==============================
// * Refresh Bitmap Com
//==============================
Window_ActorCommand.prototype.refresh_bitmap_com = function() {
    for (var i = 0; i < this.maxCom(); i++) {
		this._com_sprites[i].bitmap = this._com_images[i];
		this._com_images.enabled = this.isCommandEnabled(i);


		this._incom_sprites[i].bitmap = this._incom_images[i];


	};
};

//==============================
// * Position Clear
//==============================
Window_ActorCommand.prototype.position_clear = function() {
	this._old_visible = this.visible;
	for (var i = 0; i < this._com_sprites.length; i++) {
		this._com_sprites[i].opacity = 0;
		this._incom_sprites[i].opacity = 255;
	};
	for (var i = 0; i < this.maxCom(); i++) {
		this.position_clear_mode_0(i);
	};
};

//==============================
// * Position Clear Mode 0
//==============================
Window_ActorCommand.prototype.position_clear_mode_0 = function(i) {
  if (this._index > this.limit_rows_sp()) {
		   if (i >= this._index - this.limit_rows_sp() && i <= this._index) {
			 this._com_sprites[i].opacity = 255;
		   } else {
			 this._com_sprites[i].opacity = 0;
		   };
   } else {
		  if (i > this.limit_rows_sp()) {
			  this._com_sprites[i].opacity = 0;
		  };
   };
};

//==============================
// * processWheel
//==============================
Window_ActorCommand.prototype.processWheel = function() {
    if (this.isOpenAndActive()) {
        var threshold = 20;
        if (TouchInput.wheelY >= threshold) {
            this._index++;
			SoundManager.playCursor();
			if (this._index > (this.maxCom() - 1)) {this._index = 0};
        };
        if (TouchInput.wheelY <= -threshold) {
            this._index--;
			SoundManager.playCursor();
			if (this._index < 0) {this._index = (this.maxCom() - 1)};
        };
    };
};

//==============================
// * LineHeight
//==============================
Window_ActorCommand.prototype.lineHeight = function() {
    return 26;
};

//==============================
// * Max Com
//==============================
Window_ActorCommand.prototype.maxCom = function() {
	if (!this._list) {return 0};
	return this._list.length;
};

//==============================
// * Limit Rows SP
//==============================
Window_ActorCommand.prototype.limit_rows_sp = function() {
	if (this._com_mode_b === 1) {this.maxCom()};
	return this._row_max;
};

//==============================
// * Com Fade Speed
//==============================
Window_ActorCommand.prototype.com_fade_speed = function() {
	return 20;
};

//==============================
// * Com Move Speed
//==============================
Window_ActorCommand.prototype.com_move_speed = function() {
	if (this._com_mode_b === 1) {return 5};
	return 20;
};

//==============================
// * Limit Height
//==============================
Window_ActorCommand.prototype.limit_height = function(i) {
	if (this._index >= this.limit_rows_sp()) {
	   return (this._index - this.limit_rows_sp()) * this._wh[1];
	};
	return 0;
};

//==============================
// * Command Name
//==============================
Window_ActorCommand.prototype.command_name = function() {
	if (!this._list || !this._list[this._index]) {return ""};
	return this._list[this._index].name;
};

//==============================
// * need Reset Com
//==============================
Window_ActorCommand.prototype.needResetCom = function() {
     if (!this._com_sprites) {return true};
	 if (this._actor && this._oldID != this._actor._actorId) {return true};
	 return false
};

//==============================
// * Update Com Sprites
//==============================
Window_ActorCommand.prototype.update_battle_commands = function() {
	if (this.needResetCom()) {
	   if (this._actor) {this.battle_commands_initialize()};
	   return
	};
	this.contentsOpacity = 0;
	this.opacity = 0;
	if (this._com_index != this._index) {this.refresh_index()};
	for (var i = 0; i < this._com_sprites.length; i++) {
		if (i <= this.maxCom()) {
		    this._com_sprites[i].visible = true;
			this.update_commands(i);
		} else {
			this._com_sprites[i].opacity = 0;
			this._com_sprites[i].visible = false;
	    };
	};
	if (this._old_visible != this.visible) {this.position_clear()};
};

//==============================
// * Sprite Move To
//==============================
Window_ActorCommand.prototype.sprite_move_to = function(value,real_value,speed) {
	if (value == real_value) {return value};
	var dnspeed = 5 + (Math.abs(value - real_value) / speed);
	if (value > real_value) {value -= dnspeed;
	    if (value < real_value) {value = real_value};}
    else if (value < real_value) {value  += dnspeed;
    	if (value  > real_value) {value  = real_value};
    };
	return Math.floor(value);
};

//==============================
// * Update Commands
//==============================
Window_ActorCommand.prototype.update_commands = function(i) {
      this.update_position(i);
	  this.update_effect_selection(i);
};

//==============================
// ** update Position
//==============================
Window_ActorCommand.prototype.updatePos = function() {
	var opc = this.active ? 255 : 0;
	this._hudField.opacity = this.sprite_move_to(this._hudField.opacity, opc, 5);
	var xy = $gameTemp._com_posX;
	this._hudField.x = this.sprite_move_to(this._hudField.x, xy, 5);
};

//==============================
// * Update Position
//==============================
Window_ActorCommand.prototype.update_position = function(i) {
    this._np[0] = Moghunter.bcom_com_x + this._side[i][0];
	this._np[1] = (66 * i) - this.limit_height() + Moghunter.bcom_com_y + this._side[i][1];
	this._com_sprites[i].x = this.sprite_move_to(this._com_sprites[i].x,this._np[0],this.com_move_speed());
	this._com_sprites[i].y = this.sprite_move_to(this._com_sprites[i].y,this._np[1],this.com_move_speed());
};

//==============================
// * Update Effect Selection
//==============================
Window_ActorCommand.prototype.update_effect_selection = function(i) {
	if (this._index === i) {
		this.update_on_index(i);
	} else {
		this.update_off_index(i);
	};
};

//==============================
// * Update On Index
//==============================
Window_ActorCommand.prototype.update_on_index = function(i) {
	this._side[i] = [this._side_m[0],this._side_m[1]];
	if (!this._com_sprites[i].enabled) {
		this._com_sprites[i].opacity += this.com_fade_speed();
		if (this._com_sprites[i].opacity >= 120) {
			this._com_sprites[i].opacity = 120;
		}
	} else {
		this._com_sprites[i].opacity += this.com_fade_speed();
	}
	this._incom_sprites[i].opacity = 0;
};

//==============================
// * Update Off Index
//==============================
Window_ActorCommand.prototype.update_off_index = function(i) {
   this._side[i] = [0,0];
   if (this._com_sprites[i].opacity > 0){this._com_sprites[i].opacity -= this.com_fade_speed();};
   if (this._incom_sprites[i].opacity < 255){this._incom_sprites[i].opacity += this.com_fade_speed();};
   this.update_off_mode_0(i);
};

//==============================
// * Update Off Mode 0
//==============================
Window_ActorCommand.prototype.update_off_mode_0 = function(i) {
   if (this._index > this.limit_rows_sp()) {
		   if (i >= this._index - this.limit_rows_sp() && i <= this._index) {
			 if (this._com_sprites[i].opacity < 0) {
				 this._com_sprites[i].opacity += this.com_fade_speed();
				 this._incom_sprites[i].opacity = 0;
			 };
		   } else {
			 this._com_sprites[i].opacity -= this.com_fade_speed();
			 this._incom_sprites[i].opacity = 255;
		   };
   } else {
		  if (i > this.limit_rows_sp()) {
			  this._com_sprites[i].opacity -= this.com_fade_speed();
			  this._incom_sprites[i].opacity = 255;
		  } else {
			  if (this._com_sprites[i].opacity < 0){
				  this._com_sprites[i].opacity += this.com_fade_speed();
				  this._incom_sprites[i].opacity = 0;
			 };
		  };
   };
};

//==============================
// * Process Touch
//==============================
Window_ActorCommand.prototype.processTouch = function() {
    if (this.isOpenAndActive()) {
		if (TouchInput.isCancelled()) {
      if (this.isCancelEnabled()) {
        this.processCancel();
      };
		} else if (TouchInput.isTriggered() && this.isTouchedInsideCom()) {
      if (this._com_sprites[this._index].opacity == 255) {
        this.processOk();
      }
    };
	};
};

//==============================
// * Process Touch
//==============================
Window_ActorCommand.prototype.isTouchedInsideCom = function() {
	for (var i = 0; i < this._com_sprites.length; i++) {
		if (TouchInput.x > this.x + this._com_sprites[i].x - (this._com_sprites[i].bitmap.width / 2) &&
		    TouchInput.x < this.x + this._com_sprites[i].x + this._com_sprites[i].bitmap.width - (this._com_sprites[i].bitmap.width / 2) &&
 		    TouchInput.y > this.y + this._com_sprites[i].y - (this._com_sprites[i].bitmap.height / 2) &&
			  TouchInput.y < this.y + this._com_sprites[i].y + this._com_sprites[i].bitmap.height - (this._com_sprites[i].bitmap.height / 2))
			  {this._index = i; return true};
	};
};

//==============================
// * Update Wait Selection
//==============================
Window_ActorCommand.prototype.update_wait_selection = function() {
//	this.sel_time--;
//	if (this.sel_time === 0) { this.processOk();};
	if (BattleManager._actorIndex >= 0) {this.update_battle_commands()};
};

//==============================
// * Update
//==============================
var _alias_mog_bcom_wcom_update = Window_ActorCommand.prototype.update;
Window_ActorCommand.prototype.update = function() {


	if (this._hudField) this.updatePos();
	if ($gameTemp._bcom_need_refresh) {$gameTemp._bcom_need_refresh = false;this.battle_commands_initialize()};
//	if (this.sel_time > 0) {this.update_wait_selection();return;};
	_alias_mog_bcom_wcom_update.call(this);
	if (BattleManager._actorIndex >= 0) {this.update_battle_commands()};
};

//==============================
// * Set Mcursor Data
//==============================
Window_ActorCommand.prototype.set_mcursor_data = function() {
};

};
