//=============================================================================
// MOG_BattleCry.js
//=============================================================================

/*:
 * @plugindesc (v1.4) Adiciona vozes na batalha.
 * @author Moghunter
 *
 * @param Volume
 * @desc Definição do volume.
 * @default 120
 *
 * @help
 * =============================================================================
 * +++ MOG - Battle Cry (v1.4) +++
 * By Moghunter
 * https://mogplugins.wordpress.com
 * =============================================================================
 * Adiciona vozes na batalha (ação, dano, vitória,etc...)
 * Para definir as vozes é necessário editar o plugin manualmente.
 * A edição do plugin deve ser feita a partir da linha 70.
 *
 * =============================================================================
 * HISTÓRICO
 * =============================================================================
 * (v1.4) - Correção do tocar as vozes no menu.
 *        - Correção de não atualizar a ID do inimigo no efeito transformação.
 * (v1.3) Compatibilidade com MOG Battle Result.
 * (v1.2) Compatibilidade com MOG Battle Transitions.
 * (v1.1) Corrigido o bug de não mover o personagem na hora da ação.
 */

//=============================================================================
// ** PLUGIN PARAMETERS
//=============================================================================

    // Não modifique essa parte.
    // ☢CAUTION!!☢ Don't Touch.^_^ ----------------------------------------
　　var Imported = Imported || {};
　　Imported.MOG_BattleCry = true;
　　var Moghunter = Moghunter || {};

	Moghunter.parameters = PluginManager.parameters('MOG_BattleCry');
	Moghunter.v_volume = Number(Moghunter.parameters['Volume'] || 100);
  Moghunter.v_actor_start = [];
	Moghunter.v_actor_turn = [];
	Moghunter.v_actor_skill = [];
	Moghunter.v_actor_item = [];
	Moghunter.v_actor_damage = [];
	Moghunter.v_actor_dead = [];
  Moghunter.v_actor_recover = [];
	Moghunter.v_actor_victory = [];
	Moghunter.v_actor_levelup = [];
	Moghunter.v_actor_escape = [];

    // ☢CAUTION!!☢ Don't Touch.^_^ ----------------------------------------

	// SETUP ----------------------------------------------------------------
	// Exemplo de configuração geral, o modo de configurar é igual para todas
	// ações.
	//
	// Moghunter.v_actor_start[A] = [B,B,B,B...]
	//
	// A - Actor ID
	// B - File Name
	//
	// -----------------------------------------------------------------------

	// -----------------------------------------------------------------------
	// ACTOR - BATTLE START
	// -----------------------------------------------------------------------
	Moghunter.v_actor_start[1] = ["[BATTLE] Marie_Turn01","[BATTLE] Marie_Support01"];
	Moghunter.v_actor_start[2] = ["[BATTLE] Elucia_Turn02","[BATTLE] Elucia_Turn03"];
	Moghunter.v_actor_start[3] = [];
	// -----------------------------------------------------------------------
	// ACTOR - BATTLE TURN
	// -----------------------------------------------------------------------
	Moghunter.v_actor_turn[1] = [
	"[BATTLE] Marie_Turn01",
	"[BATTLE] Marie_Turn02",
	"[BATTLE] Marie_Turn04"
	];
	Moghunter.v_actor_turn[2] = [
		"[BATTLE] Elucia_Turn01",
		"[BATTLE] Elucia_Turn02",
		"[BATTLE] Elucia_Turn04"
	];
	Moghunter.v_actor_turn[3] = [];
	// -----------------------------------------------------------------------
	// ACTOR - SKILL
	// -----------------------------------------------------------------------
	// Moghunter.v_actor_skill[A] = {B:[C,C,C,C,...] }
	//
	// A - Actor ID
	// B - Skill ID
	// C - File Name
	// -----------------------------------------------------------------------
  Moghunter.v_actor_skill[1] = [];
	Moghunter.v_actor_skill[2] = [];
	Moghunter.v_actor_skill[3] = [];
	// -----------------------------------------------------------------------
	// ACTOR - ITEM
	// -----------------------------------------------------------------------
  Moghunter.v_actor_item[1] = [];
	Moghunter.v_actor_item[2] = [];
	Moghunter.v_actor_item[3] = [];
	// -----------------------------------------------------------------------
	// ACTOR - DAMAGE
	// -----------------------------------------------------------------------
	Moghunter.v_actor_damage[1] = [
	"[BATTLE] Marie_Damage01",
	"[BATTLE] Marie_Damage02",
	"[BATTLE] Marie_Damage03",
	"[BATTLE] Marie_Damage04",
	"[BATTLE] Marie_Damage05",
	"[BATTLE] Marie_Damage06",
	"[BATTLE] Marie_Damage07",
	"[BATTLE] Marie_Damage08",
	"[BATTLE] Marie_Damage09",
	"[BATTLE] Marie_Damage10",
	"[BATTLE] Marie_Damage11",
	"[BATTLE] Marie_Damage12"
	];
	Moghunter.v_actor_damage[2] = [
		"[BATTLE] Elucia_Damage01",
		"[BATTLE] Elucia_Damage02",
		"[BATTLE] Elucia_Damage03",
		"[BATTLE] Elucia_Damage04",
		"[BATTLE] Elucia_Damage05",
		"[BATTLE] Elucia_Damage06"
	];
	Moghunter.v_actor_damage[3] = [];
	// -----------------------------------------------------------------------
	// ACTOR - RECOVER
	// -----------------------------------------------------------------------
	Moghunter.v_actor_recover[1] = [];
	Moghunter.v_actor_recover[2] = [];
	Moghunter.v_actor_recover[3] = [];
	// -----------------------------------------------------------------------
	// ACTOR - DEAD
	// -----------------------------------------------------------------------
	Moghunter.v_actor_dead[1] = ["[BATTLE] Marie_Dead01","[BATTLE] Marie_Dead02","[BATTLE] Marie_Dead03"];
	Moghunter.v_actor_dead[2] = ["[BATTLE] Elucia_Dead01","[BATTLE] Elucia_Dead02","[BATTLE] Elucia_Dead03"];
	Moghunter.v_actor_dead[3] = [];
	// -----------------------------------------------------------------------
	// ACTOR - ESCAPE
	// -----------------------------------------------------------------------
	Moghunter.v_actor_escape[1] = [];
	Moghunter.v_actor_escape[2] = [];
	Moghunter.v_actor_escape[3] = [];
	// -----------------------------------------------------------------------
	// ACTOR - VICTORY
	// -----------------------------------------------------------------------
	Moghunter.v_actor_victory[1] = ["[BATTLE] Marie_Victory01","[BATTLE] Marie_Victory02","[BATTLE] Marie_Victory03","[BATTLE] Marie_Victory04"];
	Moghunter.v_actor_victory[2] = ["[BATTLE] Elucia_Victory01","[BATTLE] Elucia_Victory02","[BATTLE] Elucia_Victory03","[BATTLE] Elucia_Victory04"];
	Moghunter.v_actor_victory[3] = [];
	// -----------------------------------------------------------------------
	// ACTOR - LEVEL UP
	// -----------------------------------------------------------------------
	Moghunter.v_actor_levelup[1] = [];
	Moghunter.v_actor_levelup[2] = [];
	Moghunter.v_actor_levelup[3] = [];

//=============================================================================
// ** Sound Manager
//=============================================================================

//==============================
// * select Voice
//==============================
SoundManager.selectVoice = function(voices){
   if (!voices) {return};
   if (voices.length === 0) {return};
   var voiceIndex = Math.randomInt(voices.length);
   var fileName = voices[voiceIndex];
   this.playVoice(fileName);
};

//==============================
// * Play Voice
//==============================
SoundManager.playVoice = function(fileName){
   var se = {};
   se.name = fileName;
   se.pitch = 100;
   se.volume = Moghunter.v_volume;
   AudioManager.playSe(se);
};

//=============================================================================
// ** BattleManager
//=============================================================================

//================================
// ** Random Actor
//================================
BattleManager.randomActor = function() {
    var actorIndex = Math.randomInt($gameParty.aliveMembers().length);
    return $gameParty.aliveMembers()[actorIndex];
};

//==================================
// ** Start Battle
//==================================
var _alias_mog_bmngr_startBattle = BattleManager.startBattle;
BattleManager.startBattle = function() {
     _alias_mog_bmngr_startBattle.call(this);
	 if (!Imported.MOG_BattleTransitions ||
	      (Imported.MOG_BattleTransitions && $gameSystem._treType[1] === -1)) {
	     var actor = this.randomActor();
        if (actor) {SoundManager.selectVoice(actor._v_start)};
     };
};

//==================================
// ** Process Victory
//==================================
var _alias_mog_bcry_processVictory = BattleManager.processVictory;
BattleManager.processVictory = function() {
	 var actor = this.randomActor();
     if (actor) {SoundManager.selectVoice(actor._v_victory)};
     _alias_mog_bcry_processVictory.call(this);
};

//==================================
// ** Process Escape
//==================================
var _alias_mog_bcry_processEscape = BattleManager.processEscape;
BattleManager.processEscape = function() {
	 var actor = this.randomActor();
     if (actor) {SoundManager.selectVoice(actor._v_escape)};
	 _alias_mog_bcry_processEscape.call(this);
};

//=============================================================================
// ** Game Battler
//=============================================================================

//==============================
// * InitMembers
//==============================
var _alias_mog_batcry_gbattler_initMembers = Game_Battler.prototype.initMembers;
Game_Battler.prototype.initMembers = function() {
    _alias_mog_batcry_gbattler_initMembers.call(this);
    this.battleCrySetup();
};

//==============================
// * Battle Cry Setup
//==============================
Game_Battler.prototype.battleCrySetup = function() {
	this._v_start = [];
	this._v_turn = [];
	this._v_damage = [];
	this._v_dead = [];
	this._v_recover = [];
	this._v_escape = [];
	this._v_victory = [];
	this._v_levelup = [];
};

//==============================
// * Battle Cry Setup Actor
//==============================
Game_Battler.prototype.battleCrySetupActor = function() {
	if (Moghunter.v_actor_start[this._actorId]) {this._v_start = Moghunter.v_actor_start[this._actorId]};
	if (Moghunter.v_actor_turn[this._actorId]) {this._v_turn = Moghunter.v_actor_turn[this._actorId]};
	if (Moghunter.v_actor_damage[this._actorId]) {this._v_damage = Moghunter.v_actor_damage[this._actorId]};
	if (Moghunter.v_actor_dead[this._actorId]) {this._v_dead = Moghunter.v_actor_dead[this._actorId]};
	if (Moghunter.v_actor_recover[this._actorId]) {this._v_recover = Moghunter.v_actor_recover[this._actorId]};
	if (Moghunter.v_actor_escape[this._actorId]) {this._v_escape = Moghunter.v_actor_escape[this._actorId]};
	if (Moghunter.v_actor_victory[this._actorId]) {this._v_victory = Moghunter.v_actor_victory[this._actorId]};
	if (Moghunter.v_actor_levelup[this._actorId]) {this._v_levelup = Moghunter.v_actor_levelup[this._actorId]};
};

//===============================
// ** PerfotmAction
//===============================
var _alias_mog_bcry_performActionStart = Game_Battler.prototype.performActionStart;
Game_Battler.prototype.performActionStart = function(action) {
   if (action) {this.playVoiceAction(action)};
   _alias_mog_bcry_performActionStart.call(this, action);
};

//===============================
// ** play Voice Action
//===============================
Game_Battler.prototype.playVoiceAction = function(action) {
  var actionID = action.item().id
	 if (this.isActor()) {
		 if (action.isSkill() && Moghunter.v_actor_skill[this._actorId] &&
		     Moghunter.v_actor_skill[this._actorId][actionID]) {
    		 SoundManager.selectVoice(Moghunter.v_actor_skill[this._actorId][actionID]);
			 return;
		 } else if (action.isItem() && Moghunter.v_actor_item[this._actorId]) {
			 SoundManager.selectVoice(target.v_actor_item);
			 return;
		 };
	 }
};

//=============================================================================
// ** Game Actor
//=============================================================================

//==============================
// * Setup
//==============================
var _mog_bcry_gact_setup = Game_Actor.prototype.setup;
Game_Actor.prototype.setup = function(actorId) {
	_mog_bcry_gact_setup.call(this,actorId);
	this.battleCrySetupActor();
};

//=============================================================================
// ** Scene Battle
//=============================================================================

//==============================
// * select Voice
//==============================
var _alias_mog_bcry_scbat_start = Scene_Battle.prototype.start;
Scene_Battle.prototype.start = function() {
	_alias_mog_bcry_scbat_start.call(this);
	this._actorvoice = null;
};

//==============================
// * Update Battle Process
//==============================
var _alias_mog_bcry_updateBattleProcess = Scene_Battle.prototype.updateBattleProcess;
Scene_Battle.prototype.updateBattleProcess = function() {
	if (this._actorvoice != BattleManager.actor()) {this.playActorTurn()};
	this.updatePartyVoiceCD();
	_alias_mog_bcry_updateBattleProcess.call(this);
};

Scene_Battle.prototype.updatePartyVoiceCD = function() {
	var party = $gameParty.size();
	var actor = $gameParty.members();
	for (var i = 0; i < party; i++) {
		if (actor[i]._voiceCD == 0) {continue}
		actor[i]._voiceCD--;
	}
};

//==============================
// * Play Actor Turn
//==============================
Scene_Battle.prototype.playActorTurn = function() {
	 this._actorvoice = BattleManager.actor();
     if (this._actorvoice) {
		if (this._actorvoice._v_turn && this._actorvoice._v_turn.length > 0) {
//		     AudioManager.stopSe();
		     SoundManager.selectVoice(this._actorvoice._v_turn)
		};
     };
};

//=============================================================================
// ** Game Action
//=============================================================================

//==============================
// * Apply
//==============================
var _alias_mog_bcry_gaction_apply = Game_Action.prototype.apply;
Game_Action.prototype.apply = function(target) {
	 var old_hp = target.hp
	 _alias_mog_bcry_gaction_apply.call(this,target);
	 if ($gameParty.inBattle()) {
      if (old_hp != target.hp || this.item().damage.type === 3) {
				if (target._voiceCD == 0) {
					this.playVoiceHP(old_hp,target.hp,target);
					target._voiceCD = 40;
				}
			};
	 };
};

//==============================
// * Play Voice HP
//==============================
Game_Action.prototype.playVoiceHP = function(old_hp,now_hp,target) {
   if (old_hp < now_hp || this.item().damage.type === 3) {
	   SoundManager.selectVoice(target._v_recover);
   } else if (old_hp > now_hp) {
       SoundManager.selectVoice(target._v_damage);
   };
};

//==============================
// * Item Effect Recover HP
//==============================
var _alias_mog_btcry_gact_itemEffectRecoverHp = Game_Action.prototype.itemEffectRecoverHp;
Game_Action.prototype.itemEffectRecoverHp = function(target, effect) {
	var old_hp = target.hp;
	_alias_mog_btcry_gact_itemEffectRecoverHp.call(this,target, effect)
	if (old_hp <= target.hp) {SoundManager.selectVoice(target._v_recover)};
};
