//=============================================================================
// MOG_SceneSkill.js
//=============================================================================

/*:
 * @plugindesc (v1.1) Modifica a cena de habilidades.
 * @author Moghunter
 *
 * @help  
 * =============================================================================
 * +++ MOG - Scene Skill (v1.1) +++
 * By Moghunter 
 * https://mogplugins.wordpress.com
 * =============================================================================
 * Modifica a cena de habilidades.
 *
 * =============================================================================
 * UTILIZAÇÃO
 * =============================================================================
 * As imagens do sistema deverão ser gravados na pasta.
 *
 * /img/menus/skill/
 *
 * =============================================================================
 * HISTÓRICO
 * =============================================================================
 * (v1.1) - Correção do plugin parameter relativo ao SW Par Y-Axis.
 */

//=============================================================================
// ** PLUGIN PARAMETERS
//=============================================================================
　　var Imported = Imported || {};
　　Imported.MOG_SceneSkill = true;
　　var Moghunter = Moghunter || {}; 

  　Moghunter.parameters = PluginManager.parameters('MOG_SceneSkill');
  
	Moghunter.scSkill_ItemWindowWidth = Number(Moghunter.parameters['Item Width'] || 370);
	Moghunter.scSkill_ItemWindowHeight = Number(Moghunter.parameters['Item Height'] || 370);
	Moghunter.scSkill_ItemWindowX = Number(Moghunter.parameters['Item X-Axis'] || 272);
	Moghunter.scSkill_ItemWindowY = Number(Moghunter.parameters['Item Y-Axis'] || 139);
	Moghunter.scSkill_ListLayoutX = Number(Moghunter.parameters['List X-Axis'] || 135);
	Moghunter.scSkill_ListLayoutY = Number(Moghunter.parameters['List Y-Axis'] || 101);
	Moghunter.scSkill_TypeWindowX = Number(Moghunter.parameters['Type X-Axis'] || 130);
	Moghunter.scSkill_TypeWindowY = Number(Moghunter.parameters['Type Y-Axis'] || 130);
	Moghunter.scSkill_HelpWindowX = Number(Moghunter.parameters['Help X-Axis'] || 76);
	Moghunter.scSkill_HelpWindowY = Number(Moghunter.parameters['Help Y-Axis'] || 563);
	Moghunter.scSkill_HelpLayoutX = Number(Moghunter.parameters['HelpLay X-Axis'] || 83);
	Moghunter.scSkill_HelpLayoutY = Number(Moghunter.parameters['HelpLay Y-Axis'] || 537);
	
//=============================================================================
// ** ImageManager
//=============================================================================

//==============================
// * Skill
//==============================
ImageManager.loadMenuSkill = function(filename) {
    return this.loadBitmap('img/menus/skill/', filename, 0, true);
};

//=============================================================================
// ** Scene Skill
//=============================================================================

//==============================
// * creaate
//==============================
var _mog_scnSkill_create = Scene_Skill.prototype.create;
Scene_Skill.prototype.create = function() {
    _mog_scnSkill_create.call(this);
	this.loadBitmaps();
	this._statusWindow.visible = false;
    this._helpWindow.opacity = 0;
    this._helpWindow.x = Moghunter.scSkill_HelpWindowX;
    this._helpWindow.y = Moghunter.scSkill_HelpWindowY;
	this._helpOrg = [this._helpWindow.x, this._helpWindow.y, this._helpWindow.y + 50];
	this._skillTypeWindow.x = Moghunter.scSkill_TypeWindowX;
	this._skillTypeWindow.y = Moghunter.scSkill_TypeWindowY;
	this._skillTypeWindow.opacity = 0;
	this._skillTypeWindow.contentsOpacity = 0;
	this._skillTypeOrg = [this._skillTypeWindow.x, this._skillTypeWindow.y, this._skillTypeWindow.y + 50];
	this._skillTypeIndex = this._skillTypeWindow._index;
};

//==============================
// * create Background
//==============================
var _mog_scSkill_createBackground = Scene_Skill.prototype.createBackground;
Scene_Skill.prototype.createBackground = function() {
	_mog_scSkill_createBackground.call(this);
	this._field = new Sprite();
	this.addChild(this._field);	
};

//==============================
// * create Item Window
//==============================
Scene_Skill.prototype.createItemWindow = function() {
	var ww = Moghunter.scSkill_ItemWindowWidth;
	var wh = Moghunter.scSkill_ItemWindowHeight;
	var wx = Moghunter.scSkill_ItemWindowX;
    var wy = Moghunter.scSkill_ItemWindowY;
    this._itemWindow = new Window_SkillListM(wx, wy, ww, wh);
    this._itemWindow.setHandler('cancel', this.onItemCancel.bind(this));
    this._itemWindow.setHelpWindow(this._helpWindow);
    this._itemWindow.opacity = 0;
    this._skillTypeWindow.setSkillWindow(this._itemWindow);
    this.addWindow(this._itemWindow);
	this._itemPosOrg = [this._itemWindow.x,this._itemWindow.y, this._itemWindow.y + 50];
};

//==============================
// * loadBitmaps
//==============================
Scene_Skill.prototype.loadBitmaps = function() {
	this._titleImg = ImageManager.loadMenuSkill("Title");
	this._helpImg = ImageManager.loadMenuSkill("Help");
	this._listImg = [];
	this._listImg[0] = ImageManager.loadMenuSkill("List_0");
	this._listImg[1] = ImageManager.loadMenuSkill("List_1");
};

//==============================
// * create Sprites
//==============================
Scene_Skill.prototype.createSprites = function() {
	this.createBust();
	this.createTitle();
	this.createList();
	this.createHelp();
};

//==============================
// * create Sprites
//==============================
Scene_Skill.prototype.createBust = function() {
	this._bust = new MSprite(this._actor._actorId, 0);
	this._bustOrg = [];
	this._bustOrg = [430, 430+100];
	this._bust.x = this._bustOrg[1];
	this._bust.y = -140;
	this._field.addChild(this._bust);
};

Scene_Skill.prototype.createTitle = function() {
	this._title = new Sprite(this._titleImg);
	this._titleOrg = [0, -50];
	this._field.addChild(this._title);
};

Scene_Skill.prototype.createHelp = function() {
	this._help = new Sprite(this._helpImg);
	this._help.x = Moghunter.scSkill_HelpLayoutX;
	this._help.y = Moghunter.scSkill_HelpLayoutY;
	this._helpLayOrg = [this._help.y, this._help.y + 50];
	this._field.addChild(this._help);
};

Scene_Skill.prototype.createList = function() {
	this._list = [];
	for (var i = 0; i < 2; i++) {
		this._list[i] = new Sprite(this._listImg[i]);
		this._list[i].visible = false;
		this._list[i].x = Moghunter.scSkill_ListLayoutX;
		this._list[i].y = Moghunter.scSkill_ListLayoutY;
		this._field.addChild(this._list[i]);
	};
	this._listOrg = [this._list[0].y, this._list[0].y + 50];
};

//==============================
// * refresh Type Index
//==============================
Scene_Skill.prototype.refreshTypeIndex = function() {
    this._skillTypeIndex = this._skillTypeWindow._index;
    this.updateCategory(this._skillTypeIndex);
};

//==============================
// * update Commands
//==============================
Scene_Skill.prototype.updateIndex = function() {
    if (!this._itemWindow.active) {
		 if (this._skillTypeIndex != this._skillTypeWindow._index) {this.refreshTypeIndex()};
	};
};

//==============================
// * addCatIndex
//==============================
Scene_Skill.prototype.resetPosition = function() {
	this._skillTypeWindow.select(0);
	this._skillTypeWindow.update();
	this.refreshTypeIndex();
	
	this._title.y = this._titleOrg[1];
	this._help.y = this._helpLayOrg[1];
	this._list[0].y = this._listOrg[1];
	
	this._helpWindow.x = this._helpOrg[0];
	this._helpWindow.y = this._helpOrg[2];
	this._itemWindow.x = this._itemPosOrg[0];
	this._itemWindow.y = this._itemPosOrg[2];
	this._skillTypeWindow.x = this._skillTypeOrg[0];
	this._skillTypeWindow.y = this._skillTypeOrg[2];
	
	this._bust.x = this._bustOrg[1];
	this._bust.replaceBust(this._actor._actorId, 0);
};

Scene_Skill.prototype.updateAni = function() {
	for (var i = 0; i < this._list.length; i++) {
		this._list[i].y = this.commandMoveTo(this._list[i].y, this._listOrg[0], 20);
	}
	this._title.y = this.commandMoveTo(this._title.y, this._titleOrg[0], 20);
	this._help.y = this.commandMoveTo(this._help.y, this._helpLayOrg[0], 20);
	this._itemWindow.y = this.commandMoveTo(this._itemWindow.y, this._itemPosOrg[1], 20);
	this._skillTypeWindow.y = this.commandMoveTo(this._skillTypeWindow.y, this._skillTypeOrg[1], 20);
	this._helpWindow.y = this.commandMoveTo(this._helpWindow.y, this._helpOrg[1], 20);
	this._bust.x = this.commandMoveTo(this._bust.x, this._bustOrg[0], 20);;
};

Scene_Skill.prototype.updateCategory = function(a) {
	for (var i = 0; i < this._list.length; i++) {
		this._list[i].visible = false;
	}
	this._list[a].visible = true;
};

//==============================
// * Command Move To
//==============================
Scene_Skill.prototype.commandMoveTo = function(value,real_value,speed) {
	if (value == real_value) {return value};
	var dnspeed = 3 + (Math.abs(value - real_value) / speed);
	if (value > real_value) {value -= dnspeed;
	    if (value < real_value) {value = real_value};}
    else if (value < real_value) {value  += dnspeed;
    	if (value  > real_value) {value  = real_value};		
    };
	return Math.floor(value);
};

//==============================
// * On Actor Change
//==============================
var _mog_scskillM_onActorChange = Scene_Skill.prototype.onActorChange;
Scene_Skill.prototype.onActorChange = function() {
	_mog_scskillM_onActorChange.call(this);
	this.resetPosition();
};

//==============================
// * update
//==============================
var _mog_scnSkill_update = Scene_Skill.prototype.update;
Scene_Skill.prototype.update = function() {
    _mog_scnSkill_update.call(this);
	if (!this._title) {
		if (this._titleImg.isReady()) {
			this.createSprites();
			this.resetPosition();
		};
		return
	};
	this.updateAni();
	this.updateIndex();
};

//=============================================================================
// * Window Skill List M
//=============================================================================
function Window_SkillListM() {
    this.initialize.apply(this, arguments);
}

Window_SkillListM.prototype = Object.create(Window_Selectable.prototype);
Window_SkillListM.prototype.constructor = Window_SkillListM;

//==============================
// * Initialize
//==============================
Window_SkillListM.prototype.initialize = function(x, y, width, height) {
    Window_Selectable.prototype.initialize.call(this, x, y, width, height);
    this._actor = null;
    this._stypeId = 0;
    this._data = [];
};

//==============================
// * set Actor
//==============================
Window_SkillListM.prototype.setActor = function(actor) {
    if (this._actor !== actor) {
        this._actor = actor;
        this.refresh();
        this.resetScroll();
    }
};

//==============================
// * setStypeID
//==============================
Window_SkillListM.prototype.setStypeId = function(stypeId) {
    if (this._stypeId !== stypeId) {
        this._stypeId = stypeId;
        this.refresh();
        this.resetScroll();
    };
};

//==============================
// * max Cols
//==============================
Window_SkillListM.prototype.maxCols = function() {
    return 1;
};

//==============================
// * spacing
//==============================
Window_SkillListM.prototype.spacing = function() {
    return 48;
};

//==============================
// * maxItems
//==============================
Window_SkillListM.prototype.maxItems = function() {
    return this._data ? this._data.length : 1;
};

//==============================
// * Item
//==============================
Window_SkillListM.prototype.item = function() {
    return this._data && this.index() >= 0 ? this._data[this.index()] : null;
};

//==============================
// * Is Current Item Enabled
//==============================
Window_SkillListM.prototype.isCurrentItemEnabled = function() {
    return this.isEnabled(this._data[this.index()]);
};

//==============================
// * Includes
//==============================
Window_SkillListM.prototype.includes = function(item) {
    return item && item.stypeId === this._stypeId;
};

//==============================
// * Is Item Enabled
//==============================
Window_SkillListM.prototype.isEnabled = function(item) {
    return this._actor;
};

//==============================
// * make Item List
//==============================
Window_SkillListM.prototype.makeItemList = function() {
    if (this._actor) {
        this._data = this._actor.skills().filter(function(item) {
            return this.includes(item);
        }, this);
    } else {
        this._data = [];
    }
};

//==============================
// * Select Last
//==============================
Window_SkillListM.prototype.selectLast = function() {
    var skill;
    if ($gameParty.inBattle()) {
        skill = this._actor.lastBattleSkill();
    } else {
        skill = this._actor.lastMenuSkill();
    }
    var index = this._data.indexOf(skill);
    this.select(index >= 0 ? index : 0);
};

//==============================
// * Draw Item
//==============================
Window_SkillListM.prototype.drawItem = function(index) {
    var skill = this._data[index];
    if (skill) {
        var costWidth = this.costWidth();
        var rect = this.itemRect(index);
        rect.width -= this.textPadding();
        this.drawItemName(skill, rect.x, rect.y, rect.width - costWidth);
        this.drawSkillCost(skill, rect.x, rect.y, rect.width);
    }
};

//==============================
// * cost Width
//==============================
Window_SkillListM.prototype.costWidth = function() {
    return this.textWidth('000');
};

//==============================
// * draw Skill Cost
//==============================
Window_SkillListM.prototype.drawSkillCost = function(skill, x, y, width) {
    if (this._actor.skillTpCost(skill) > 0) {
        this.changeTextColor(this.textColor(0));
        this.drawText(this._actor.skillTpCost(skill) + " TP", x, y, width, 'right');
    } else if (this._actor.skillMpCost(skill) > 0) {
        this.changeTextColor(this.textColor(0));
        this.drawText(this._actor.skillMpCost(skill) + " MP", x, y, width, 'right');
    }
};

//==============================
// * update Help
//==============================
Window_SkillListM.prototype.updateHelp = function() {
    this.setHelpWindowItem(this.item());
};

//==============================
// * Refresh
//==============================
Window_SkillListM.prototype.refresh = function() {
    this.makeItemList();
    this.createContents();
    this.drawAllItems();
};

//==============================
// * update
//==============================
var _mog_WindowSkillListM_update = Window_SkillListM.prototype.update;
Window_SkillListM.prototype.update = function() {
	if (this.contentsOpacity != 255) {return};
    _mog_WindowSkillListM_update.call(this);
};